function initAPI() {
    const {CrazySDK: CrazySDK} = window.CrazyGames;
    MainGame.crazysdk = CrazySDK.getInstance();
    MainGame.crazysdk.init();
    MainGame.isApiReady = true;
    MainGame.crazysdk.addEventListener("adblockDetectionExecuted", MainGame.adblockDetection);
    MainGame.crazysdk.addEventListener("adStarted", MainGame.adStarted);
    MainGame.crazysdk.addEventListener("adError", MainGame.adError);
    MainGame.crazysdk.addEventListener("adFinished", MainGame.adFinished);
    MainGame.crazysdk.addEventListener("bannerRendered", event => {
        console.log(`Banner for container ${event.containerId} has been\n\t    rendered!`)
    });
    MainGame.crazysdk.addEventListener("bannerError", event => {
        console.log(`Banner render error: ${event.error}`)
    });
    MainGame.continuePreloader()
}

var MainGame = {
    Config: {ORIENTATION: "landscape", DEFAULT_WIDTH: 0, DEFAULT_HEIGHT: 0, MAX_WIDTH: 0, MAX_HEIGHT: 0},
    version: "v1.03",
    fontName: "UniSansHeavy40",
    isDebug: false,
    showDebugCircle: false,
    isAudioDisable: false,
    isAPI: true,
    isApiReady: false,
    isGDto: "",
    isApiBreakTime: false,
    isApiGameplayStop: false,
    isDesktop: true,
    title: "chickenwar_v1.0",
    languages: ["EN", "IT", "ES", "PT", "TR", "BR", "RU", "FR", "DE", "AR"],
    languagesN: ["00", "01", "02", "03", "04", "06", "07", "08", "05", "10"],
    language: 0,
    GAME_TEXT: null,
    TEXT_FILE: null,
    showFPS: false,
    firstLoad: true,
    firstGo: true,
    isNoSave: false,
    isFromFireMode: false,
    isFromTutorial: false,
    reward_wheel: null,
    amount_diamonds: null,
    amount_coins: null,
    exp: null,
    nextCarLevel: null,
    currentLevel: null,
    LIMIT_parking: null,
    LIMIT_pilots: null,
    box_have: null,
    arDeltaCarLevel: null,
    lastSession: null,
    selectedGun: 1,
    selectedHat: 0,
    fireLevel: 1,
    freeTimeWheel: 0,
    cdNextFree: 0,
    maxTimeWheel: 3,
    TIME_BANNER: 10,
    lastDataBanner: null,
    debug_isFreeUpgrade: false,
    debug_typeGun: 1,
    debug_typeSquad: 7,
    continuePreloader: function () {
        game.scene.start("Preloader")
    },
    initSettings: function () {
        MainGame.Config.DEFAULT_WIDTH = config.scale.width;
        MainGame.Config.DEFAULT_HEIGHT = config.scale.height;
        MainGame.Config.MAX_WIDTH = config.scale.max.width;
        MainGame.Config.MAX_HEIGHT = config.scale.max.height;
        MainGame.isDesktop = game.device.os.desktop;
        MainGame.loadSaves();
        if (game.device.os.desktop) {
            game.canvas.oncontextmenu = function (e) {
                e.preventDefault()
            };
            window.addEventListener("wheel", event => event.preventDefault(), {passive: false});
            window.addEventListener("keydown", event => {
                if (["ArrowUp", "ArrowDown", " "].includes(event.key)) {
                    event.preventDefault()
                }
            })
        }
        if (MainGame.isDebug) {
        }
    },
    api_google: function (vValue, vLevel) {
    },
    adblockDetection: function () {
        if (event.hasAdblock) {
            MainGame.isApiReady = false;
            console.log("User is using an adblocker")
        } else {
            console.log("User is NOT using an adblocker")
        }
    },
    adStarted: function () {
        MainGame.isApiBreakTime = true;
        game.sound.mute = true;
        MainGame.state.setGameLogicPause(true)
    },
    adError: function () {
        MainGame.isApiBreakTime = false;
        game.sound.mute = false;
        MainGame.state.setGameLogicPause(false);
        MainGame.getReward(false)
    },
    adFinished: function () {
        MainGame.isApiBreakTime = false;
        game.sound.mute = false;
        MainGame.state.setGameLogicPause(false);
        MainGame.getReward(true)
    },
    setReward: function () {
        MainGame.selectedReward = 1
    },
    getReward: function (withReward) {
        if (withReward) {
            MainGame.state.getRewards(MainGame.selectedReward)
        } else {
        }
    },
    clickReward: function (vReward) {
        MainGame.selectedReward = vReward;
        if (MainGame.isApiReady) {
            if(window.h5api.playAd(result => {
                if(result.code === 10001){
                    MainGame.getReward(true)
                }else{
                    // MainGame.crazysdk.requestAd("rewarded")
                }
            }));
        } else {
            if (MainGame.isDebug) MainGame.getReward(true)
        }
    },
    showAds: function () {
        console.log(' show ad ======')
        if (MainGame.isAPI) {
            MainGame.crazysdk.requestAd("midgame")
        }
    },
    showBanner: function () {
        if (MainGame.isAPI) {
        }
    },
    addText: function (vLink, vLayer, vX, vY, vText, vSize, vIsUpperCase, vIsNoShadow) {
        vText = vText + "";
        if (vText && vIsUpperCase) vText = vText.toUpperCase();
        var shadowEffect = true;
        if (vIsNoShadow) shadowEffect = false;
        var txt = vLink.add.bitmapText(vX, vY, MainGame.fontName, vText);
        txt.setFontSize(vSize);
        txt.setOrigin(.5);
        if (shadowEffect) txt.setDropShadow(-1, 2, 0, 1);
        if (vLayer) vLayer.add(txt);
        return txt
    },
    updateTextWidth: function (vText, vMaxWidth) {
        var scale = 1;
        vText.setScale(scale);
        var txtWidth = vText.width;
        if (txtWidth > vMaxWidth) {
            scale = vMaxWidth / txtWidth;
            vText.setScale(scale)
        }
        return scale
    },
    replaceText: function (vText, vValue) {
        return vText.replace("#", vValue.toString())
    },
    convertNumberFormat: function (number) {
        var temp = number;
        var tabUnits = ["K", "M", "B", "T", "aa", "bb", "cc", "dd", "ee", "ff", "gg", "hh", "ii", "jj", "kk", "ll", "mm", "nn", "oo", "pp", "qq", "rr", "ss", "tt", "uu", "vv", "ww", "xx", "yy", "zz"];
        var highnumber = false;
        var bignumber = 1e3;
        var tabposition = -1;
        var p_atomepersecond = true;
        var unit;
        if (number >= bignumber) {
            highnumber = true;
            while (number >= bignumber) {
                bignumber *= 1e3;
                tabposition++
            }
            number /= bignumber / 1e3;
            unit = tabUnits[tabposition]
        } else unit = "";
        if (unit == undefined) return temp.toExponential(2);
        var toround = highnumber == true ? p_atomepersecond == true ? 100 : 100 : 10;
        var res = Math.round(number * toround) / toround;
        return [res.toLocaleString().replace(",", ".") + "" + unit]
    },
    secToHHMMSS: function (vSec) {
        var seconds = parseInt(vSec, 10);
        var hours = Math.floor(seconds / 3600);
        var minutes = Math.floor((seconds - hours * 3600) / 60);
        var seconds = seconds - hours * 3600 - minutes * 60;
        if (hours < 10) hours = "0" + hours;
        if (minutes < 10) minutes = "0" + minutes;
        if (seconds < 10) seconds = "0" + seconds;
        var time = minutes + ":" + seconds;
        return time
    },
    jelly: function (game, object, strength, delay, initialScale) {
        strength = strength || .2;
        delay = delay || 0;
        initialScale = initialScale || {x: 1, y: 1};
        game.tweens.killTweensOf(object);
        game.tweens.add({
            targets: object,
            props: {
                scaleX: {value: initialScale.x + initialScale.x * strength, duration: 50, delay: delay},
                scaleY: {value: initialScale.y + initialScale.y * strength, duration: 50, delay: delay + 50}
            },
            ease: "Quadratic.easeInOut"
        });
        game.tweens.add({
            targets: object,
            props: {
                scaleX: {value: initialScale.x, duration: 500, delay: 50 + delay},
                scaleY: {value: initialScale.y, duration: 500, delay: 50 + delay + 50}
            },
            ease: "Elastic.easeOut"
        })
    },
    loadSaves: function () {
        MainGame.amount_coins = MainGame.Storage.get(MainGame.title + "-" + "amount_coins");
        MainGame.amount_diamonds = MainGame.Storage.get(MainGame.title + "-" + "amount_diamonds");
        MainGame.exp = MainGame.Storage.get(MainGame.title + "-" + "exp");
        MainGame.nextCarLevel = MainGame.Storage.get(MainGame.title + "-" + "nextCarLevel");
        MainGame.currentLevel = MainGame.Storage.get(MainGame.title + "-" + "currentLevel");
        MainGame.LIMIT_parking = MainGame.Storage.get(MainGame.title + "-" + "LIMIT_parking");
        MainGame.LIMIT_pilots = MainGame.Storage.get(MainGame.title + "-" + "LIMIT_pilots");
        MainGame.box_have = MainGame.Storage.get(MainGame.title + "-" + "box_have");
        MainGame.arDeltaCarLevel = MainGame.Storage.get(MainGame.title + "-" + "arDeltaCarLevel");
        MainGame.lastSession = MainGame.Storage.get(MainGame.title + "-" + "lastSession");
        MainGame.cdBonusMerge = MainGame.Storage.get(MainGame.title + "-" + "cdBonusMerge");
        MainGame.cdBonusCoins = MainGame.Storage.get(MainGame.title + "-" + "cdBonusCoins");
        MainGame.cdBonusSpeed = MainGame.Storage.get(MainGame.title + "-" + "cdBonusSpeed");
        MainGame.buffer_boxes = MainGame.Storage.get(MainGame.title + "-" + "buffer_boxes");
        MainGame.freeTimeWheel = MainGame.Storage.get(MainGame.title + "-" + "freeTimeWheel");
        MainGame.cdNextFree = MainGame.Storage.get(MainGame.title + "-" + "cdNextFree");
        MainGame.levelCannonDmg = MainGame.Storage.get(MainGame.title + "-" + "levelCannonDmg");
        MainGame.levelEarning = MainGame.Storage.get(MainGame.title + "-" + "levelEarning");
        MainGame.levelDiscount = MainGame.Storage.get(MainGame.title + "-" + "levelDiscount");
        MainGame.num_wave = MainGame.Storage.get(MainGame.title + "-" + "num_wave");
        MainGame.level_wall = MainGame.Storage.get(MainGame.title + "-" + "level_wall");
        var language = MainGame.Storage.get(MainGame.title + "-" + "language");
        if (language != null) MainGame.language = language
    },
    saveSaves: function () {
        if (MainGame.isNoSave) return;
        MainGame.Storage.set(MainGame.title + "-" + "amount_coins", MainGame.amount_coins);
        MainGame.Storage.set(MainGame.title + "-" + "amount_diamonds", MainGame.amount_diamonds);
        MainGame.Storage.set(MainGame.title + "-" + "exp", MainGame.exp);
        MainGame.Storage.set(MainGame.title + "-" + "nextCarLevel", MainGame.nextCarLevel);
        MainGame.Storage.set(MainGame.title + "-" + "currentLevel", MainGame.currentLevel);
        MainGame.Storage.set(MainGame.title + "-" + "LIMIT_parking", MainGame.LIMIT_parking);
        MainGame.Storage.set(MainGame.title + "-" + "LIMIT_pilots", MainGame.LIMIT_pilots);
        MainGame.Storage.set(MainGame.title + "-" + "box_have", MainGame.box_have);
        MainGame.Storage.set(MainGame.title + "-" + "arDeltaCarLevel", MainGame.arDeltaCarLevel);
        MainGame.Storage.set(MainGame.title + "-" + "lastSession", MainGame.lastSession);
        MainGame.Storage.set(MainGame.title + "-" + "language", MainGame.language);
        MainGame.Storage.set(MainGame.title + "-" + "cdBonusMerge", MainGame.cdBonusMerge);
        MainGame.Storage.set(MainGame.title + "-" + "cdBonusCoins", MainGame.cdBonusCoins);
        MainGame.Storage.set(MainGame.title + "-" + "cdBonusSpeed", MainGame.cdBonusSpeed);
        MainGame.Storage.set(MainGame.title + "-" + "buffer_boxes", MainGame.buffer_boxes);
        MainGame.Storage.set(MainGame.title + "-" + "freeTimeWheel", MainGame.freeTimeWheel);
        MainGame.Storage.set(MainGame.title + "-" + "cdNextFree", MainGame.cdNextFree);
        MainGame.Storage.set(MainGame.title + "-" + "levelCannonDmg", MainGame.levelCannonDmg);
        MainGame.Storage.set(MainGame.title + "-" + "levelEarning", MainGame.levelEarning);
        MainGame.Storage.set(MainGame.title + "-" + "levelDiscount", MainGame.levelDiscount);
        MainGame.Storage.set(MainGame.title + "-" + "num_wave", MainGame.num_wave);
        MainGame.Storage.set(MainGame.title + "-" + "level_wall", MainGame.level_wall)
    },
    clearSaves: function () {
        MainGame.Storage.remove(MainGame.title + "-" + "amount_coins");
        MainGame.Storage.remove(MainGame.title + "-" + "amount_diamonds");
        MainGame.Storage.remove(MainGame.title + "-" + "exp");
        MainGame.Storage.remove(MainGame.title + "-" + "nextCarLevel");
        MainGame.Storage.remove(MainGame.title + "-" + "currentLevel");
        MainGame.Storage.remove(MainGame.title + "-" + "LIMIT_parking");
        MainGame.Storage.remove(MainGame.title + "-" + "LIMIT_pilots");
        MainGame.Storage.remove(MainGame.title + "-" + "box_have");
        MainGame.Storage.remove(MainGame.title + "-" + "arDeltaCarLevel");
        MainGame.Storage.remove(MainGame.title + "-" + "lastSession");
        MainGame.Storage.remove(MainGame.title + "-" + "language");
        MainGame.Storage.remove(MainGame.title + "-" + "cdBonusMerge");
        MainGame.Storage.remove(MainGame.title + "-" + "cdBonusCoins");
        MainGame.Storage.remove(MainGame.title + "-" + "cdBonusSpeed");
        MainGame.Storage.remove(MainGame.title + "-" + "buffer_boxes");
        MainGame.Storage.remove(MainGame.title + "-" + "freeTimeWheel");
        MainGame.Storage.remove(MainGame.title + "-" + "cdNextFree");
        MainGame.Storage.remove(MainGame.title + "-" + "levelCannonDmg");
        MainGame.Storage.remove(MainGame.title + "-" + "levelEarning");
        MainGame.Storage.remove(MainGame.title + "-" + "levelDiscount");
        MainGame.Storage.remove(MainGame.title + "-" + "num_wave");
        MainGame.Storage.remove(MainGame.title + "-" + "level_wall");
        MainGame.isNoSave = true
    }
};
MainGame.Sfx = {
    manage: function (type, mode, game, button, label) {
        if (MainGame.isAudioDisable) return;
        switch (mode) {
            case"init": {
                MainGame.Storage.initUnset(MainGame.title + "-" + type, true);
                MainGame.Sfx.status = MainGame.Sfx.status || [];
                MainGame.Sfx.status[type] = MainGame.Storage.get(MainGame.title + "-" + type);
                if (type == "sound") {
                    MainGame.Sfx.sounds = [];
                    MainGame.Sfx.sounds["after_exposion"] = game.sound.add("after_exposion");
                    MainGame.Sfx.sounds["boost"] = game.sound.add("boost");
                    MainGame.Sfx.sounds["buy"] = game.sound.add("buy");
                    MainGame.Sfx.sounds["click"] = game.sound.add("click6");
                    MainGame.Sfx.sounds["dead1"] = game.sound.add("dead1");
                    MainGame.Sfx.sounds["dead2"] = game.sound.add("dead2");
                    MainGame.Sfx.sounds["dead3"] = game.sound.add("dead3");
                    MainGame.Sfx.sounds["dead4"] = game.sound.add("dead4");
                    MainGame.Sfx.sounds["dead5"] = game.sound.add("dead5");
                    MainGame.Sfx.sounds["dead6"] = game.sound.add("dead6");
                    MainGame.Sfx.sounds["exposion"] = game.sound.add("exposion2");
                    MainGame.Sfx.sounds["fortune"] = game.sound.add("fortune2");
                    MainGame.Sfx.sounds["kick1"] = game.sound.add("kick1");
                    MainGame.Sfx.sounds["kick2"] = game.sound.add("kick2");
                    MainGame.Sfx.sounds["kick3"] = game.sound.add("kick3");
                    MainGame.Sfx.sounds["kick4"] = game.sound.add("kick4");
                    MainGame.Sfx.sounds["knock1"] = game.sound.add("knock1");
                    MainGame.Sfx.sounds["knock2"] = game.sound.add("knock2");
                    MainGame.Sfx.sounds["knock3"] = game.sound.add("knock3");
                    MainGame.Sfx.sounds["knock4"] = game.sound.add("knock4");
                    MainGame.Sfx.sounds["knock5"] = game.sound.add("knock5");
                    MainGame.Sfx.sounds["lvl_up"] = game.sound.add("lvl_up");
                    MainGame.Sfx.sounds["merge_car"] = game.sound.add("merge_car2");
                    MainGame.Sfx.sounds["merge_unlocked"] = game.sound.add("merge_unlocked");
                    MainGame.Sfx.sounds["offline_earning"] = game.sound.add("offline_earning5");
                    MainGame.Sfx.sounds["open_box"] = game.sound.add("open_box");
                    MainGame.Sfx.sounds["remove_car"] = game.sound.add("remove_car2");
                    MainGame.Sfx.sounds["shoot1"] = game.sound.add("shoot1");
                    MainGame.Sfx.sounds["shoot2"] = game.sound.add("shoot2");
                    MainGame.Sfx.sounds["shoot3"] = game.sound.add("shoot3");
                    MainGame.Sfx.sounds["show_box"] = game.sound.add("show_box");
                    MainGame.Sfx.sounds["wave_defeat"] = game.sound.add("wave_defeat4");
                    MainGame.Sfx.sounds["wave_finish"] = game.sound.add("wave_finish");
                    MainGame.Sfx.sounds["wave_start"] = game.sound.add("wave_start");
                    MainGame.Sfx.sounds["after_exposion"].volume = 1.5;
                    MainGame.Sfx.sounds["boost"].volume = 2.4;
                    MainGame.Sfx.sounds["buy"].volume = 1.9;
                    MainGame.Sfx.sounds["click"].volume = 1;
                    MainGame.Sfx.sounds["dead1"].volume = .9;
                    MainGame.Sfx.sounds["dead2"].volume = .9;
                    MainGame.Sfx.sounds["dead3"].volume = .9;
                    MainGame.Sfx.sounds["dead4"].volume = .9;
                    MainGame.Sfx.sounds["dead5"].volume = .9;
                    MainGame.Sfx.sounds["dead6"].volume = .9;
                    MainGame.Sfx.sounds["exposion"].volume = 2.2;
                    MainGame.Sfx.sounds["fortune"].volume = 3;
                    MainGame.Sfx.sounds["kick1"].volume = .8;
                    MainGame.Sfx.sounds["kick2"].volume = .8;
                    MainGame.Sfx.sounds["kick3"].volume = .8;
                    MainGame.Sfx.sounds["kick4"].volume = .8;
                    MainGame.Sfx.sounds["knock1"].volume = .6;
                    MainGame.Sfx.sounds["knock2"].volume = .6;
                    MainGame.Sfx.sounds["knock3"].volume = .6;
                    MainGame.Sfx.sounds["knock4"].volume = .8;
                    MainGame.Sfx.sounds["knock5"].volume = .7;
                    MainGame.Sfx.sounds["lvl_up"].volume = .95;
                    MainGame.Sfx.sounds["merge_car"].volume = 2.1;
                    MainGame.Sfx.sounds["merge_unlocked"].volume = 1.8;
                    MainGame.Sfx.sounds["offline_earning"].volume = 1.2;
                    MainGame.Sfx.sounds["open_box"].volume = 2.3;
                    MainGame.Sfx.sounds["remove_car"].volume = 2.3;
                    MainGame.Sfx.sounds["shoot1"].volume = 1;
                    MainGame.Sfx.sounds["shoot2"].volume = 1;
                    MainGame.Sfx.sounds["shoot3"].volume = 1.3;
                    MainGame.Sfx.sounds["show_box"].volume = 1.5;
                    MainGame.Sfx.sounds["wave_defeat"].volume = 2;
                    MainGame.Sfx.sounds["wave_finish"].volume = 1.3;
                    MainGame.Sfx.sounds["wave_start"].volume = .91
                } else {
                    MainGame.Sfx.nameMusicPlaying = -1;
                    MainGame.Sfx.musics = [];
                    MainGame.Sfx.musics["main"] = game.sound.add("music-main");
                    MainGame.Sfx.musics["main"].volume = 1
                }
                break
            }
            case"on": {
                MainGame.Sfx.status[type] = true;
                break
            }
            case"off": {
                MainGame.Sfx.status[type] = false;
                break
            }
            case"switch": {
                MainGame.Sfx.status[type] = !MainGame.Sfx.status[type];
                break
            }
            default: {
            }
        }
        MainGame.Sfx.update(type, button, label);
        if (MainGame.Sfx.sounds) {
            var statusSound = !MainGame.Sfx.status["sound"];
            for (var id in MainGame.Sfx.sounds) {
                MainGame.Sfx.sounds[id].setMute(statusSound)
            }
        }
        if (MainGame.Sfx.musics) {
            var statuMusic = !MainGame.Sfx.status["music"];
            if (MainGame.Sfx.musics["main"]) MainGame.Sfx.musics["main"].setMute(statuMusic)
        }
        if (MainGame.Sfx.status) {
            MainGame.Storage.set(MainGame.title + "-" + type, MainGame.Sfx.status[type])
        }
    }, play: function (type, audio) {
        if (MainGame.isAudioDisable) return;
        if (MainGame.isDebug) {
        }
        if (type == "music") {
            if (MainGame.Sfx.nameMusicPlaying == audio) return;
            if (MainGame.Sfx.musics) {
                if (MainGame.Sfx.musics[MainGame.Sfx.nameMusicPlaying]) MainGame.Sfx.musics[MainGame.Sfx.nameMusicPlaying].stop();
                if (MainGame.Sfx.musics && MainGame.Sfx.musics[audio]) {
                    MainGame.Sfx.musics[audio].play({loop: true});
                    MainGame.Sfx.nameMusicPlaying = audio
                }
            }
        } else {
            if (MainGame.Sfx.sounds && MainGame.Sfx.sounds[audio]) {
                MainGame.Sfx.sounds[audio].play()
            }
        }
    }, update: function (type, button, label) {
        if (MainGame.isAudioDisable) return;
        if (MainGame.Sfx.status == undefined) return;
        if (button) {
            if (MainGame.Sfx.status[type]) {
                button.setFrame("btn_" + type + "_0000")
            } else {
                button.setFrame("btn_" + type + "_0001")
            }
        }
        if (label) {
            if (MainGame.Sfx.status[type]) {
                label.setText(MainGame.GAME_TEXT[type + "_on"].toUpperCase())
            } else {
                label.setText(MainGame.GAME_TEXT[type + "_off"].toUpperCase())
            }
        }
    }
};
MainGame.fadeOutIn = function (passedCallback, context) {
    context.cameras.main.fadeOut(200);
    context.time.addEvent({
        delay: 200, callback: function () {
            context.cameras.main.fadeIn(200);
            passedCallback(context)
        }, callbackScope: context
    })
};
MainGame.fadeOutScene = function (sceneName, context) {
    context.cameras.main.fadeOut(200);
    context.time.addEvent({
        delay: 200, callback: function () {
            context.scene.start(sceneName)
        }, callbackScope: context
    })
};
MainGame.Storage = {
    availability: function () {
        try {
            var ls = window.localStorage
        } catch (e) {
            return
        }
        if (!!(typeof window.localStorage === "undefined")) {
            console.log("localStorage not available");
            return null
        }
    }, get: function (key) {
        try {
            var ls = window.localStorage
        } catch (e) {
            return
        }
        this.availability();
        try {
            return JSON.parse(localStorage.getItem(key))
        } catch (e) {
            return window.localStorage.getItem(key)
        }
    }, set: function (key, value) {
        try {
            var ls = window.localStorage
        } catch (e) {
            return
        }
        this.availability();
        try {
            window.localStorage.setItem(key, JSON.stringify(value))
        } catch (e) {
            if (e == QUOTA_EXCEEDED_ERR) {
                console.log("localStorage quota exceeded")
            }
        }
    }, initUnset: function (key, value) {
        if (this.get(key) === null) {
            this.set(key, value)
        }
    }, getFloat: function (key) {
        return parseFloat(this.get(key))
    }, setHighscore: function (key, value) {
        if (value > this.getFloat(key)) {
            this.set(key, value)
        }
    }, remove: function (key) {
        this.availability();
        window.localStorage.removeItem(key)
    }, clear: function () {
        this.availability()
    }
};

class Boot extends Phaser.Scene {
    constructor() {
        super("Boot");
        this.wasIncorrectOrientation = false
    }

    preload() {
        this.load.image("preloader_bar", "assets/preloader_bar.png?r=2");
        this.load.image("preloader_back", "assets/preloader_back.png?r=2");
        this.load.image("bg_loading", "assets/background/bg_loading.png");
        this.load.bitmapFont("UniSansHeavy40", "assets/fonts/UniSansHeavy40.png", "assets/fonts/UniSansHeavy40.fnt")
    }

    create() {
        MainGame.world = {
            width: this.cameras.main.width,
            height: this.cameras.main.height,
            centerX: this.cameras.main.centerX,
            centerY: this.cameras.main.centerY
        };
        MainGame.initSettings();
        this.scaleForMobile();
        if (MainGame.isAPI) {
            initAPI()
        } else {
            MainGame.continuePreloader()
        }
    }

    scaleForMobile() {
        this.wasIncorrectOrientation = true;
        window.addEventListener("resize", this.onWindowResize.bind(this));
        this.onWindowResize()
    }

    onWindowResize() {
        if (game.device.os.desktop) {
        } else {
            if (window.innerWidth > window.innerHeight) {
                this.checkOriention("landscape")
            } else {
                this.checkOriention("portrait")
            }
        }
        if (MainGame.state && MainGame.state.updateResize) MainGame.state.updateResize();
        this.handleScroll()
    }

    checkOriention(orientation) {
        if (orientation === MainGame.Config.ORIENTATION) {
            this.leaveIncorrectOrientation()
        } else {
            this.enterIncorrectOrientation()
        }
    }

    enterIncorrectOrientation() {
        document.getElementById("orientation").style.display = "block"
    }

    leaveIncorrectOrientation() {
        document.getElementById("orientation").style.display = "none"
    }

    isLandscape() {
        return window.innerWidth > window.innerHeight
    }

    isPortrait() {
        return window.innerHeight > window.innerWidth
    }

    handleScroll() {
        if (typeof this.scrollTimeout !== "undefined") {
            clearTimeout(this.scrollTimeout)
        }
        this.scrollTimeout = setTimeout(() => {
            window.scrollTo(0, -window.innerHeight);
            if (MainGame.state && MainGame.state.updateResize) MainGame.state.updateResize()
        }, 500)
    }
}

class Preloader extends Phaser.Scene {
    constructor() {
        super("Preloader")
    }

    preload() {
        MainGame.state = this;
        this.initResize();
        this.midX = this.GAME_WIDTH / 2;
        this.midY = this.GAME_HEIGHT / 2;
        const midX = MainGame.Config.DEFAULT_WIDTH * .5;
        var back = this.add.sprite(midX, 0, "bg_loading");
        back.setOrigin(.5, 0);
        this.back = back;
        this.preloader_back = this.add.image(midX, 575, "preloader_back");
        this.preloader_bar = this.add.image(midX, 575, "preloader_bar");
        this.preloader_crop = new Phaser.Geom.Rectangle(0, 0, 0, this.preloader_bar.height);
        this.preloader_bar.setCrop(this.preloader_crop);
        this.load.on(Phaser.Loader.Events.START, this.onLoadStart, this);
        this.load.on(Phaser.Loader.Events.PROGRESS, this.onLoadProgress, this);
        this.load.once(Phaser.Loader.Events.COMPLETE, this.onLoadComplete, this);
        var background_url = "bg_main.png";
        var resources = {
            image: [["bg_game", "assets/background/" + background_url]],
            atlas: [["ss_main", "assets/spritesheets/ss_main.png?r=1", "assets/spritesheets/ss_main.json?r=" + MyMath.getRandomInt(0, 99)]],
            spine: [["skeleton", "assets/spine/skeleton.json", "assets/spine/skeleton.atlas"]],
            audio: [["music-main", ["assets/audio/music/game.mp3"]], ["after_exposion", ["assets/audio/sfx/after_exposion.mp3"]], ["boost", ["assets/audio/sfx/boost.mp3"]], ["buy", ["assets/audio/sfx/buy.mp3"]], ["click6", ["assets/audio/sfx/click6.mp3"]], ["dead1", ["assets/audio/sfx/dead.mp3"]], ["dead2", ["assets/audio/sfx/dead2.mp3"]], ["dead3", ["assets/audio/sfx/dead3.mp3"]], ["dead4", ["assets/audio/sfx/dead4.mp3"]], ["dead5", ["assets/audio/sfx/dead5.mp3"]], ["dead6", ["assets/audio/sfx/dead6.mp3"]], ["exposion2", ["assets/audio/sfx/exposion2.mp3"]], ["fortune2", ["assets/audio/sfx/fortune2.mp3"]], ["kick1", ["assets/audio/sfx/kick.mp3"]], ["kick2", ["assets/audio/sfx/kick2.mp3"]], ["kick3", ["assets/audio/sfx/kick3.mp3"]], ["kick4", ["assets/audio/sfx/kick4.mp3"]], ["knock1", ["assets/audio/sfx/knock.mp3"]], ["knock2", ["assets/audio/sfx/knock2.mp3"]], ["knock3", ["assets/audio/sfx/knock3.mp3"]], ["knock4", ["assets/audio/sfx/knock4.mp3"]], ["knock5", ["assets/audio/sfx/knock5.mp3"]], ["lvl_up", ["assets/audio/sfx/lvl_up.mp3"]], ["merge_car2", ["assets/audio/sfx/merge_car2.mp3"]], ["merge_unlocked", ["assets/audio/sfx/merge_unlocked.mp3"]], ["offline_earning5", ["assets/audio/sfx/offline_earning5.mp3"]], ["open_box", ["assets/audio/sfx/open_box.mp3"]], ["remove_car2", ["assets/audio/sfx/remove_car2.mp3"]], ["shoot1", ["assets/audio/sfx/shoot.mp3"]], ["shoot2", ["assets/audio/sfx/shoot2.mp3"]], ["shoot3", ["assets/audio/sfx/shoot3.mp3"]], ["show_box", ["assets/audio/sfx/show_box.mp3"]], ["wave_defeat4", ["assets/audio/sfx/wave_defeat4.mp3"]], ["wave_finish", ["assets/audio/sfx/wave_finish.mp3"]], ["wave_start", ["assets/audio/sfx/wave_start.mp3"]]],
            json: [["alltext", "assets/text/text.json?r=" + MyMath.getRandomInt(0, 99)]]
        };
        for (var method in resources) {
            resources[method].forEach((function (args) {
                var loader = this.load[method];
                loader && loader.apply(this.load, args)
            }), this)
        }
        this.updateResize()
    }

    onLoadProgress() {
        this.updateLogoCrop(this.load.progress)
    }

    updateLogoCrop(loadProgress) {
        var originalWidth = this.preloader_bar.width;
        var width = originalWidth * loadProgress;
        this.tweens.killTweensOf(this.preloader_crop);
        if (loadProgress == 1) {
            this.preloader_bar.isCropped = false
        } else {
            this.tweens.add({
                targets: this.preloader_crop,
                width: width,
                ease: Phaser.Math.Easing.Linear,
                duration: 200,
                onUpdate: () => {
                    this.preloader_bar.setCrop(this.preloader_crop)
                }
            })
        }
    }

    onLoadStart() {
        if (MainGame.isAPI) {
            MainGame.crazysdk.sdkGameLoadingStart()
        }
    }

    onLoadComplete() {
        this.tweens.killTweensOf(this.preloader_crop);
        this.load.off(Phaser.Loader.Events.PROGRESS, this.onLoadProgress);
        this.preloader_bar.isCropped = false;
        if (MainGame.isAPI) {
            MainGame.crazysdk.sdkGameLoadingStop()
        }
    }

    initResize() {
        this.GAME_WIDTH = MainGame.Config.DEFAULT_WIDTH;
        this.GAME_HEIGHT = MainGame.Config.DEFAULT_HEIGHT;
        var gameSize = this.scale.gameSize;
        var width = gameSize.width;
        var height = gameSize.height;
        if (window.innerHeight < MainGame.Config.MAX_HEIGHT) {
            height = window.innerHeight
        }
        this.parent = new Phaser.Structs.Size(width, height);
        this.sizer = new Phaser.Structs.Size(this.GAME_WIDTH, this.GAME_HEIGHT, Phaser.Structs.Size.FIT, this.parent);
        this.parent.setSize(width, height);
        this.sizer.setSize(width, height);
        this.scale.on("resize", this.updateResize, this)
    }

    updateResize() {
        var gameSize = this.scale.gameSize;
        var width = gameSize.width;
        var height = gameSize.height;
        if (MainGame.isDesktop && window.innerHeight < MainGame.Config.MAX_HEIGHT) {
            height = window.innerHeight
        }
        this.parent.setSize(width, height);
        this.sizer.setSize(width, height);
        this.updateCamera()
    }

    updateCamera() {
        const camera = this.cameras.main;
        var deltaX = Math.ceil(this.parent.width - this.sizer.width) * .5;
        var deltaY = Math.ceil(this.parent.height - this.sizer.height) * .5;
        var sdvigY = 0;
        if (MainGame.isDesktop && window.innerHeight < MainGame.Config.MAX_HEIGHT) {
            deltaY = Math.ceil(window.innerHeight - this.sizer.height) * .5;
            sdvigY = this.scale.gameSize.height - window.innerHeight
        }
        const scaleX = this.sizer.width / this.GAME_WIDTH;
        const scaleY = this.sizer.height / this.GAME_HEIGHT;
        const zoom = Math.max(scaleX, scaleY);
        const offsetX = deltaX / zoom;
        const offsetY = deltaY / zoom;
        camera.setZoom(zoom);
        if (MainGame.isDesktop) {
            camera.centerOn(this.GAME_WIDTH / 2, this.GAME_HEIGHT / 2 + offsetY + sdvigY)
        } else {
            camera.centerOn(this.GAME_WIDTH / 2, this.GAME_HEIGHT / 2);
            this.back.y = -offsetY;
            this.preloader_back.y = 590 - offsetY;
            this.preloader_bar.y = 590 - offsetY
        }
    }

    create() {
        MainGame.TEXT_FILE = this.cache.json.get("alltext");
        MainGame.Sfx.manage("music", "init", this);
        MainGame.Sfx.manage("sound", "init", this);
        this.scale.off("resize", this.updateResize, this);
        MainGame.fadeOutScene("Game", this)
    }
}

class Game extends Phaser.Scene {
    constructor() {
        super("Game")
    }

    create() {
        MainGame.isFromTutorial = false;
        MainGame.state = this;
        MainGame.stateName = "Game";
        MainGame.GAME_TEXT = MainGame.TEXT_FILE[MainGame.languages[MainGame.language]];
        this.initResize();
        this.midX = this.GAME_WIDTH / 2;
        this.midY = this.GAME_HEIGHT / 2;
        var back = this.add.image(this.midX, 0, "bg_game");
        back.setOrigin(.5, 0);
        if (MainGame.firstGo) {
            this.input.once("pointerdown", this.playOnce, this)
        } else {
            MainGame.Sfx.play("music", "main")
        }
        this.initSettingsGame();
        this.layerWall = this.add.container();
        this.layerTowers = this.add.container();
        this.layerHpBars = this.add.container();
        this.layerSpine = this.add.group();
        this.layerEffects = this.add.container();
        this.layerDmgText = this.add.container();
        this.initWall();
        this.initFog();
        this.initEffects();
        this.initPoolEffects();
        this.initPoolEnemies();
        this.initPoolBullets();
        this.layerWall.setDepth(this.DEPTH_layerWall);
        this.layerTowers.setDepth(this.DEPTH_layerTowers);
        this.layerHpBars.setDepth(this.DEPTH_layerHpBars);
        this.layerSpine.setDepth(this.DEPTH_layerSpine);
        this.layerEffects.setDepth(this.DEPTH_layerEffects);
        this.layerDmgText.setDepth(this.DEPTH_layerDmgText);
        game.scene.start("GameGui");
        this.gameGUI = this.scene.get("GameGui");
        this.icon_trash = this.gameGUI.icon_trash;
        this.initEffectMerge();
        this.initAutoMerge();
        this.initArmHelp();
        this.initParkings();
        this.updateParking();
        this.initInputEvents();
        var obj = null;
        for (var i = 0; i < this.MAX_PARKING; i++) {
            obj = this.box_have[i];
            if (obj && obj.t > 0) {
                this.addObject({lvl: obj.t, parkingId: obj.id})
            }
        }
        this.onStartGame();
        this.updateValuesFromLoad();
        this.cameras.main.fadeIn(200);
        this.updateResize();
        this.gameStarted = true;
        this.offerFreeUpgrade = 3;
        if (!this.isGoTutorial) this.initWave()
    }

    initResize() {
        this.GAME_WIDTH = MainGame.Config.DEFAULT_WIDTH;
        this.GAME_HEIGHT = MainGame.Config.DEFAULT_HEIGHT;
        var gameSize = this.scale.gameSize;
        var width = gameSize.width;
        var height = gameSize.height;
        if (window.innerHeight < MainGame.Config.MAX_HEIGHT) {
            height = window.innerHeight
        }
        this.parent = new Phaser.Structs.Size(width, height);
        this.sizer = new Phaser.Structs.Size(this.GAME_WIDTH, this.GAME_HEIGHT, Phaser.Structs.Size.FIT, this.parent);
        this.parent.setSize(width, height);
        this.sizer.setSize(width, height);
        this.scale.on("resize", this.updateResize, this)
    }

    updateResize() {
        var gameSize = this.scale.gameSize;
        var width = gameSize.width;
        var height = gameSize.height;
        if (MainGame.isDesktop && window.innerHeight < MainGame.Config.MAX_HEIGHT) {
            height = window.innerHeight
        }
        this.parent.setSize(width, height);
        this.sizer.setSize(width, height);
        this.updateCamera()
    }

    updateCamera() {
        const camera = this.cameras.main;
        var deltaX = Math.ceil(this.parent.width - this.sizer.width) * .5;
        var deltaY = Math.ceil(this.parent.height - this.sizer.height) * .5;
        var sdvigY = 0;
        if (MainGame.isDesktop && window.innerHeight < MainGame.Config.MAX_HEIGHT) {
            deltaY = Math.ceil(window.innerHeight - this.sizer.height) * .5;
            sdvigY = this.scale.gameSize.height - window.innerHeight
        }
        const scaleX = this.sizer.width / this.GAME_WIDTH;
        const scaleY = this.sizer.height / this.GAME_HEIGHT;
        const zoom = Math.max(scaleX, scaleY);
        const offsetY = deltaY / zoom;
        const offsetX = deltaX / zoom;
        camera.setZoom(zoom);
        if (MainGame.isDesktop) {
            camera.centerOn(this.GAME_WIDTH / 2, this.GAME_HEIGHT / 2 + offsetY + sdvigY)
        } else {
            camera.centerOn(this.GAME_WIDTH / 2, this.GAME_HEIGHT / 2)
        }
        if (this.gameGUI) this.gameGUI.updateCamera(offsetX, offsetY)
    }

    setGameLogicPause(vBool) {
        if (vBool) {
            this.scene.pause()
        } else {
            this.scene.resume()
        }
    }

    updateGameplayEvent(vBool) {
        if (MainGame.isAPI) {
            if (vBool) {
                MainGame.crazysdk.gameplayStop()
            } else {
                MainGame.crazysdk.gameplayStart()
            }
        } else {
            if (vBool) {
                console.log("[EVENT] gameplayStop")
            } else {
                console.log("[EVENT] gameplayStart")
            }
        }
    }

    updateCoinsText() {
        var text_coins_warm = MainGame.convertNumberFormat(this.amount_coins);
        this.gameGUI.updateCoins(text_coins_warm)
    }

    onStartGame() {
        var earning_sec = this.getCoinsPerSec();
        if (MainGame.lastSession && earning_sec > 0) {
            var currentSession = new Date;
            var dif = currentSession.getTime() - MainGame.lastSession;
            var secondsFromLastSession = Math.abs(dif / 1e3);
            var countAddFree = Math.floor(secondsFromLastSession / this.TIME_NEXT_FREE);
            var secondsDiff = Math.floor(secondsFromLastSession) % this.TIME_NEXT_FREE;
            if (countAddFree > 0) {
                this.freeTimeWheel += countAddFree;
                if (this.freeTimeWheel > MainGame.maxTimeWheel) {
                    this.freeTimeWheel = MainGame.maxTimeWheel
                }
            }
            if (this.freeTimeWheel < MainGame.maxTimeWheel) {
                if (MainGame.cdNextFree) {
                    if (MainGame.cdNextFree < 0) MainGame.cdNextFree = 0;
                    this.countDownNextFree = MainGame.cdNextFree - secondsDiff;
                    if (this.countDownNextFree < 0) {
                        this.freeTimeWheel += 1;
                        if (this.freeTimeWheel > MainGame.maxTimeWheel) {
                            this.freeTimeWheel = MainGame.maxTimeWheel
                        }
                        this.countDownNextFree = this.TIME_NEXT_FREE - Math.abs(this.countDownNextFree)
                    }
                } else {
                    this.countDownNextFree = this.TIME_NEXT_FREE
                }
            }
            if (secondsFromLastSession > this.MAX_OFFLINE_EARNING_SEC) {
                secondsFromLastSession = this.MAX_OFFLINE_EARNING_SEC
            }
            var add_money = Math.round(earning_sec * secondsFromLastSession * this.OFFLINE_EARNING);
            this.value_offline_earning = add_money;
            this.gameGUI.showOfflineEarningWindow(add_money);
            this.amount_coins += add_money
        } else {
            if (this.currentLevel == 1 && this.exp == 0) {
                this.freeTimeWheel = MainGame.maxTimeWheel;
                MainGame.freeTimeWheel = this.freeTimeWheel;
                this.initTutorial()
            }
            this.updateGameplayEvent(false)
        }
    }

    updateValuesFromLoad() {
        var text_coins_warm = MainGame.convertNumberFormat(this.amount_coins);
        this.gameGUI.updateCoins(text_coins_warm);
        this.gameGUI.updateLevel(this.exp / this.exp_max);
        this.gameGUI.updateShop(text_coins_warm);
        this.gameGUI.enableIndcatorBoostAutoMerge(false);
        this.gameGUI.enableIndcatorBoostSpeed(false);
        this.gameGUI.enableIndcatorBoostCoins(false);
        if (this.currentLevel < 4) {
            this.gameGUI.iconAdvFortune.visible = false;
            this.gameGUI.buttonFortuna.visible = false
        } else {
            if (this.freeTimeWheel > 0) {
                this.gameGUI.iconAdvFortune.visible = true;
                this.gameGUI.buttonFortuna.visible = true
            }
        }
        this.initHelicopterBonuses();
        this.updatePrivilegiesFactors();
        this.updateCarPrices();
        this.gameGUI.updateFastBuy();
        this.gameGUI.updateWallBuy();
        this.gameGUI.updateForge(1);
        if (MainGame.cdBonusMerge && MainGame.cdBonusMerge > 0) {
            this.activateBoostAutoMerge(MainGame.cdBonusMerge, true)
        }
        if (MainGame.cdBonusCoins && MainGame.cdBonusCoins > 0) {
            this.activateBoostCoins(MainGame.cdBonusCoins, true)
        }
        if (MainGame.cdBonusSpeed && MainGame.cdBonusSpeed > 0) {
            this.activateBoostSpeed(MainGame.cdBonusSpeed, true)
        }
        this.updateWallValues()
    }

    updateTowersDamages() {
        var parking = null;
        for (var i = 0; i < this.LIMIT_parking; i++) {
            parking = this.arParking[i];
            if (parking.busy) parking.obj.updateTypeBullet()
        }
    }

    updatePrivilegiesFactors() {
        var itemInfo;
        var num;
        var lvlCannonDmg = this.levelCannonDmg;
        if (lvlCannonDmg > 1) {
            itemInfo = this.arLevelCannonDmg[lvlCannonDmg - 2];
            num = 1 + itemInfo.value * .01;
            this.factorCannonDmg = Math.round((num + Number.EPSILON) * 100) / 100
        }
        var lvlDiscount = this.levelDiscount;
        if (lvlDiscount > 1) {
            itemInfo = this.arLevelDiscount[lvlDiscount - 2];
            num = 1 - itemInfo.value * .01;
            this.factorDiscount = Math.round((num + Number.EPSILON) * 100) / 100
        }
        var lvlEarning = this.levelEarning;
        if (lvlEarning > 1) {
            itemInfo = this.arLevelEarning[lvlEarning - 2];
            num = 1 + itemInfo.value * .01;
            this.factorEarning = Math.round((num + Number.EPSILON) * 100) / 100
        }
        this.updateTowersDamages();
        this.updatePrivilegiesItems();
        this.gameGUI.updateFastBuy();
        this.gameGUI.updateWallBuy();
        this.checkWallUpgrade()
    }

    initTutorial() {
        this.isGoTutorial = true;
        this.tutorialStep = 0;
        this.gameGUI.initTutorial()
    }

    finishTutorial() {
        this.initWave()
    }

    showHighlight() {
        var parking = null;
        var typeSelected = this.selectedCar.type;
        var idSelected = this.selectedCar.id;
        for (var i = 0; i < this.LIMIT_parking; i++) {
            parking = this.arParking[i];
            if (parking.id != idSelected) {
                if (typeSelected == parking.type && parking.type < this.MAX_TYPES_CAR) {
                    parking.highlighter.visible = true
                }
            }
        }
    }

    hideHighlight() {
        var parking = null;
        for (var i = 0; i < this.LIMIT_parking; i++) {
            parking = this.arParking[i];
            parking.highlighter.visible = false
        }
    }

    getInputPosition(pointer) {
        const deltaX = Math.ceil(this.parent.width - this.sizer.width) * .5;
        const deltaY = Math.ceil(this.parent.height - this.sizer.height) * .5;
        const scaleX = this.sizer.width / this.GAME_WIDTH;
        const scaleY = this.sizer.height / this.GAME_HEIGHT;
        const zoom = Math.max(scaleX, scaleY);
        const offset = deltaY / zoom;
        var pX = (pointer.x - deltaX) / zoom;
        var pY = (pointer.y - deltaY) / zoom + offset;
        return {x: pX, y: pY}
    }

    initInputEvents() {
        this.cursor_car = this.add.image(200, 200, "ss_main", "tower1_0000");
        this.cursor_car.depth = this.DEPTH_cursorcar;
        this.cursor_car.visible = false;
        this.cursor_car.setScale(this.getScaleCar(1));
        this.input.on("pointerdown", this.onInputDown, this);
        this.input.on("pointerup", this.onInputUp, this);
        this.input.on("pointerupoutside", this.onInputUp, this);
        this.input.on("pointermove", this.onInputMove, this)
    }

    initAutoMerge() {
        this.auto_car = this.add.image(200, 200, "ss_main", "tower1_0000");
        this.auto_car.depth = this.DEPTH_cursorcar;
        this.auto_car.visible = false;
        this.timerCheckAutoMerge = 0
    }

    checkAutoMerge() {
        var pairIds = this.getMaxParkingPair(true);
        if (pairIds) {
            this.goAutoMerge(pairIds[0], pairIds[1])
        } else {
        }
    }

    goAutoMerge(vId1, vId2) {
        var parking1 = this.arParking[vId1];
        var parking2 = this.arParking[vId2];
        parking1.allow = false;
        parking2.allow = false;
        parking1.obj.alpha = .5;
        parking2.obj.alpha = .5;
        this.actionMerge(parking1, parking2, true);
        this.time.delayedCall(500, this.onFinishAutoMerge, [vId1, vId2], this)
    }

    onFinishAutoMerge(vId1, vId2) {
        var parking1 = this.arParking[vId1];
        var parking2 = this.arParking[vId2];
        parking1.allow = true;
        parking2.allow = true
    }

    checkInputs() {
        if (this.isDrag) this.onInputUp(this.posInput)
    }

    onInputDown(pointer) {
        if (!this.gameGUI.buttonEnabled) return;
        if (this.isGoTutorial && this.tutorialStep < 3) return;
        this.hideArmHelp();
        this.posInput.x = pointer.x;
        this.posInput.y = pointer.y;
        var pos = this.getInputPosition(pointer);
        var parking = null;
        var dist = 0;
        for (var i = 0; i < this.LIMIT_parking; i++) {
            parking = this.arParking[i];
            dist = MyMath.distanceTwoPoints(pos.x, parking.x, pos.y, parking.y - 20);
            if (this.isGoTutorial && this.tutorialStep == 3 && parking.id == 5) {
                continue
            }
            if (dist < this.DISTANCE_DRAG && parking.busy && parking.allow) {
                this.isDownOnParking = true;
                this.selectedCar = {id: parking.id, obj: parking.obj, type: parking.type};
                if (parking.obj && parking.obj.count_box_tween > 0) {
                    this.openBox(parking, true)
                }
                break
            }
        }
    }

    onInputUp(pointer) {
        if (!this.gameGUI.buttonEnabled) return;
        this.hideArmHelp();
        var action_detected = false;
        var pos = this.getInputPosition(pointer);
        var parking = null;
        var dist = 0;
        if (this.isDrag) {
            this.cursor_car.visible = false;
            var isPlacedToParking = false;
            var isPlacedToTrack = false;
            var isTrashTime = false;
            for (var i = 0; i < this.LIMIT_parking; i++) {
                parking = this.arParking[i];
                dist = MyMath.distanceTwoPoints(pos.x, parking.x, pos.y, parking.y - 20);
                if (dist < this.DISTANCE_DRAG && parking.allow) {
                    if (parking.busy && this.selectedCar.id != parking.id) {
                        if (this.selectedCar.type == parking.type && parking.type < this.MAX_TYPES_CAR) {
                            this.actionMerge(parking, this.arParking[this.selectedCar.id]);
                            this.openBox(parking, false);
                            action_detected = true;
                            if (this.isGoTutorial && this.tutorialStep == 3) {
                                this.gameGUI.tutorialScenario()
                            }
                        } else {
                            this.openBox(parking, false);
                            this.actionSwap(parking, this.arParking[this.selectedCar.id], pos.x, pos.y);
                            action_detected = true
                        }
                        isPlacedToParking = true
                    } else {
                        var isAllowChange = true;
                        if (this.isGoTutorial) {
                            if (this.tutorialStep == 3) {
                                isAllowChange = false
                            }
                            if (this.tutorialStep == 4 && parking.id != 1) {
                                isAllowChange = false
                            }
                        }
                        if (isAllowChange && this.selectedCar.id != null) {
                            this.actionChangeParking(parking, this.arParking[this.selectedCar.id]);
                            isPlacedToParking = true;
                            action_detected = true;
                            if (this.isGoTutorial && this.tutorialStep == 4) {
                                this.gameGUI.tutorialScenario()
                            }
                        }
                    }
                }
                if (action_detected) break
            }
            if (!isPlacedToParking) {
                dist = MyMath.distanceTwoPoints(pos.x, this.icon_trash.x, pos.y, this.icon_trash.y);
                if (dist < 2e3 && !this.isGoTutorial) {
                    isTrashTime = true;
                    this.actionTrash(this.arParking[this.selectedCar.id]);
                    this.showEffect(this.icon_trash.x, this.icon_trash.y, "delete_dust");
                    action_detected = true
                }
                var oldParking = this.arParking[this.selectedCar.id];
                if (!isTrashTime && !isPlacedToTrack) {
                    oldParking.busy = true;
                    oldParking.obj = this.selectedCar.obj;
                    oldParking.type = this.selectedCar.type;
                    oldParking.allow = true;
                    if (oldParking.racing) {
                        this.cursor_car.visible = false;
                        this.linkToOldParking = null
                    } else {
                        this.cursor_car.visible = true;
                        this.linkToOldParking = oldParking;
                        var pos = oldParking.obj.getViewPosition();
                        this.tweens.add({
                            targets: this.cursor_car,
                            x: pos.x,
                            y: pos.y,
                            ease: Phaser.Math.Easing.Cubic.Out,
                            duration: 100,
                            onComplete: this.finishCursorTween
                        })
                    }
                }
            }
            this.isDrag = false;
            this.hideHighlight()
        }
        this.selectedCar = null;
        this.isDownOnParking = false;
        this.gameGUI.delete_flash.visible = false;
        if (action_detected) {
            this.updateBoxHave()
        }
    }

    onInputMove(pointer) {
        if (!this.gameGUI.buttonEnabled) return;
        if (this.isDownOnParking) {
            this.isDrag = true;
            var parking = this.arParking[this.selectedCar.id];
            if (parking.obj && pointer.distance > 3) {
                this.cursor_car.setFrame(parking.obj.car_frame);
                this.cursor_car.visible = true;
                if (!this.isGoTutorial) {
                    this.gameGUI.delete_flash.visible = true
                }
                parking.obj.setViewAlpha(.5);
                parking.busy = false;
                parking.allow = false;
                this.isDownOnParking = false;
                this.showHighlight();
                parking.obj.setViewScale(1);
                this.tweens.killTweensOf(parking.obj.view);
                parking.obj.setViewPosition(parking.x + this.CARS_OFFSET.x, parking.y + this.CARS_OFFSET.y)
            }
        }
    }

    finishCursorTween() {
        MainGame.state.cursor_car.visible = false;
        if (MainGame.state.linkToOldParking && MainGame.state.linkToOldParking.obj) MainGame.state.linkToOldParking.obj.setViewAlpha(1);
        MainGame.state.linkToOldParking = null
    }

    showAnimationMerge(vObj, vType, vIsAuto) {
        var oldType = vType - 1;
        var posX = vObj.x;
        var posY = vObj.y;
        var obj_anim = this.cursor_car;
        if (vIsAuto) {
            obj_anim = this.auto_car
        }
        obj_anim.visible = true;
        obj_anim.setFrame("tower" + oldType + "_0000");
        vObj.setFrame("tower" + oldType + "_0000");
        obj_anim.x = posX;
        obj_anim.y = posY;
        vObj.x = posX;
        vObj.y = posY;
        this.tweens.add({
            targets: obj_anim,
            x: posX + 50,
            ease: Phaser.Math.Easing.Cubic.Out,
            duration: 100,
            yoyo: true
        });
        this.tweens.add({targets: vObj, x: posX - 50, ease: Phaser.Math.Easing.Cubic.Out, duration: 100, yoyo: true});
        this.time.delayedCall(200, this.onMergePart, [vObj, vType, vIsAuto], this);
        this.showEffect(vObj.x + 12, vObj.y, "effect_connect")
    }

    onMergePart(vObj, vType, vIsAuto) {
        var obj_anim = this.cursor_car;
        if (vIsAuto) {
            obj_anim = this.auto_car
        }
        vObj.setFrame("tower" + vType + "_0000");
        obj_anim.setFrame("tower" + vType + "_0000");
        obj_anim.visible = false;
        if (this.isDrag) return;
        vObj.setScale(this.getScaleCar(1));
        this.tweens.add({
            targets: vObj,
            scale: this.getScaleCar(1.4),
            ease: Phaser.Math.Easing.Linear,
            duration: 100,
            yoyo: true
        })
    }

    actionMerge(toParking, fromParking, vIsAuto) {
        if (toParking.obj == undefined || fromParking.obj == undefined) return;
        var currentType = toParking.type;
        var nextType = currentType + 1;
        var exp = this.getExpMerge(currentType);
        var isUnlockedNew = false;
        this.increaseLevel(exp, this.nextCarLevel == nextType);
        if (this.nextCarLevel == nextType) {
            MainGame.api_google("MaxLevelCar", this.nextCarLevel);
            this.showMergeEffect(toParking.obj.view.x, toParking.obj.view.y);
            this.gameGUI.showMergeAnimation(this.nextCarLevel);
            this.nextCarLevel++;
            this.gameGUI.updateFastBuy();
            if (this.nextCarLevel == 6) {
                this.timer_carAds = this.TIME_ADD_ADS_CAR;
                this.num_ads_car = 0
            }
            this.updateAdsCar();
            isUnlockedNew = true
        } else {
            if (MainGame.debug_isFreeUpgrade) {
                this.parking_upgrade_id = toParking.id;
                this.parking_upgrade_type = nextType + 2;
                this.gameGUI.showUpgradeWindow(nextType);
                this.offerFreeUpgrade = 0
            } else {
                if (nextType < this.nextCarLevel - this.MIN_LVL_UPGRADE && !vIsAuto) {
                    this.offerFreeUpgrade++;
                    if (this.offerFreeUpgrade >= this.ALLOW_UPGRADE && !this.isAutoMerge) {
                        this.parking_upgrade_id = toParking.id;
                        this.parking_upgrade_type = nextType + 2;
                        this.gameGUI.showUpgradeWindow(nextType);
                        this.offerFreeUpgrade = 0
                    }
                }
            }
        }
        if (toParking.obj) toParking.obj.setSkinTower(nextType);
        toParking.type = nextType;
        toParking.allow = false;
        if (fromParking.obj) fromParking.obj.removeTower();
        fromParking.busy = false;
        fromParking.obj = null;
        fromParking.type = 0;
        fromParking.icon_panel_number.visible = false;
        fromParking.textNumberType.visible = false;
        if (toParking.obj) {
            toParking.obj.setViewAngle(0);
            toParking.obj.setViewAlpha(1);
            toParking.obj.setInitPosition(toParking.obj.view.x, toParking.obj.view.y)
        }
        this.setSpriteText(toParking.textNumberType, nextType);
        if (!vIsAuto) {
            this.time.delayedCall(200, this.onAllowAfterAnimation, [toParking, fromParking], this)
        }
        this.showAnimationMerge(toParking.obj.view, nextType, vIsAuto);
        this.checkNextCar();
        MainGame.Sfx.play("sound", "merge_car")
    }

    actionSwap(toParking, fromParking, vX, vY) {
        if (toParking.obj == undefined || fromParking.obj == undefined) return;
        var swapType = toParking.type;
        var posX1 = fromParking.x + this.CARS_OFFSET.x;
        var posY1 = fromParking.y + this.CARS_OFFSET.y;
        var posX2 = toParking.x + this.CARS_OFFSET.x;
        var posY2 = toParking.y + this.CARS_OFFSET.y;
        this.setSpriteText(toParking.textNumberType, fromParking.type);
        this.setSpriteText(fromParking.textNumberType, toParking.type);
        var save_type = toParking.type;
        toParking.type = fromParking.type;
        fromParking.type = save_type;
        fromParking.busy = true;
        toParking.busy = true;
        fromParking.allow = false;
        toParking.allow = false;
        if (fromParking.obj) {
            fromParking.obj.setViewAngle(0);
            fromParking.obj.setViewAlpha(1);
            fromParking.obj.setSkinTower(fromParking.type);
            fromParking.obj.setInitPosition(posX1, posY1)
        }
        if (toParking.obj) {
            toParking.obj.setViewAngle(0);
            toParking.obj.setViewAlpha(1);
            toParking.obj.setSkinTower(toParking.type);
            toParking.obj.setInitPosition(posX2, posY2)
        }
        if (toParking.obj && fromParking.obj) {
            this.showAnimationSwap(toParking.obj.view, fromParking.obj.view, {x: vX, y: vY});
            this.time.delayedCall(200, this.onAllowAfterAnimation, [toParking, fromParking], this)
        }
    }

    onAllowAfterAnimation(vParking1, vParking2) {
        vParking1.allow = true;
        vParking2.allow = true
    }

    showAnimationSwap(obj1, obj2, vPosition) {
        var to_x1 = obj1.x;
        var to_y1 = obj1.y;
        var to_x2 = obj2.x;
        var to_y2 = obj2.y;
        obj2.x = obj1.x;
        obj2.y = obj1.y;
        obj1.x = vPosition.x;
        obj1.y = vPosition.y;
        this.tweens.add({targets: obj1, x: to_x1, y: to_y1, ease: Phaser.Math.Easing.Linear, duration: 200});
        this.tweens.add({targets: obj2, x: to_x2, y: to_y2, ease: Phaser.Math.Easing.Linear, duration: 200});
        obj1.setScale(this.getScaleCar(1));
        obj2.setScale(this.getScaleCar(1));
        this.tweens.add({
            targets: obj1,
            scale: this.getScaleCar(1.4),
            ease: Phaser.Math.Easing.Linear,
            duration: 100,
            yoyo: true
        });
        this.tweens.add({
            targets: obj2,
            scale: this.getScaleCar(1.4),
            ease: Phaser.Math.Easing.Linear,
            duration: 100,
            yoyo: true
        })
    }

    playOnce() {
        MainGame.firstGo = false;
        MainGame.Sfx.play("music", "main")
    }

    initSettingsGame() {
        this.MAX_POOL_EFFECTS = 50;
        this.MAX_POOL_BULLETS = 50;
        this.MAX_POOL_ENEMIES = 50;
        this.MAX_TYPES_CAR = 50;
        this.COINS_PER_DMG = 1.4;
        this.box_have = [];
        this.isGameOver = false;
        this.TYPE_SKINS = ["chick1", "chick2", "chick3", "chick4", "chick5", "chick6", "chick7", "chick_big1", "chick_big2", "chick_big3", "chick_big4", "chick_big5", "chick_big6", "chick_big7", "chick_mini1", "chick_mini2", "chick_mini3"];
        this.TYPE_WEAPON2 = [2, 3, 4, 7, 12, 13, 17, 21, 25];
        this.SPEED_BULLET = Phaser.Math.GetSpeed(600, 1);
        this.SPEED_ENEMY = Phaser.Math.GetSpeed(70, 1);
        this.ATTACK_ENEMY = 1;
        this.ATTACK_TOWER = 1;
        this.WAVE_INC = 1;
        this.START_ENEMY_X = 90;
        this.MIN_LVL_UPGRADE = 4;
        this.ALLOW_UPGRADE = 12;
        this.DISTANCE_DRAG = 2e3;
        this.value_offline_earning = 0;
        this.tutorialStep = 0;
        this.isGoTutorial = false;
        this.gameStarted = false;
        this.isAutoMerge = false;
        this.isDoubleSpeed = false;
        this.isBoostTimer = false;
        this.helicopterBonus = "auto_merge";
        this.showAfterMerge = false;
        this.isShowHelicopter = false;
        this.isDownOnParking = false;
        this.isDrag = false;
        this.selectedCar = null;
        this.linkToOldParking = null;
        this.posInput = {x: 0, y: 0};
        this.DEPTH_layerWall = .02;
        this.DEPTH_hightlight = .025;
        this.DEPTH_layerTowers = .03;
        this.DEPTH_layerHpBars = .04;
        this.DEPTH_panel_number = .05;
        this.DEPTH_text_number = .06;
        this.DEPTH_effect_unboxing = .07;
        this.DEPTH_layerSpine = .08;
        this.DEPTH_layerEffects = .09;
        this.DEPTH_layerDmgText = .095;
        this.DEPTH_GUI = .1;
        this.DEPTH_text_coins = .2;
        this.DEPTH_text_field = .21;
        this.DEPTH_helicopter = .22;
        this.DEPTH_layerMainButtons = .24;
        this.DEPTH_layerLevelBar = .25;
        this.DEPTH_cursorcar = .26;
        this.DEPTH_layerMerge = .3;
        this.DEPTH_layerUnlock = .31;
        this.DEPTH_layerShop = .5;
        this.DEPTH_systemtext = .6;
        this.countDownBonusAutoMerge = 0;
        this.countDownBonusSpeed = 0;
        this.countDownBonusCoins = 0;
        this.countDownNextFree = 0;
        this.countDownOfferTV = 0;
        this.enemies_killed = 0;
        this.coins_earned = 0;
        this.VALUE_SELL = .25;
        this.DELTA_PRICE = 1.2;
        this.OFFLINE_EARNING = .2;
        this.MAX_OFFLINE_EARNING_SEC = 60 * 60 * 48;
        this.MAX_PARKING = 15;
        this.MAX_PILOTS = 10;
        this.value_boost = 3;
        this.FACTOR_TURBO = 2;
        this.ALLOW_ADS_CAR = false;
        this.num_ads_car = 0;
        this.offerFreeUpgrade = 0;
        this.parking_upgrade_id = null;
        this.parking_upgrade_type = 0;
        this.TIME_BOOST_MERGE = 60;
        this.TIME_BOOST_SPEED = 60;
        this.TIME_BOOST_COINS = 60;
        this.TIME_ADD_FREE_BOX = 20;
        this.TIME_ADD_HELICOPTER = 90;
        this.TIME_ADD_ADS_CAR = 120;
        this.TIME_BTN_FASTBUY_EFFECT = 7;
        this.TIME_BTN_FORGE_EFFECT = 12;
        this.TIME_HELP_ARM = 2 * 60;
        this.TIME_CHECK_BUFFER = 200;
        this.TIME_NEXT_FREE = 30 * 60;
        this.ICON_RETURN_OFFSET = {x: 52, y: -27};
        this.PANEL_NUMBER_OFFSET = {x: 25, y: 25};
        this.HIGHLIGHTER_OFFSET = {x: 0, y: 0};
        this.CARS_OFFSET = {x: -10, y: 0};
        this.amount_coins = MainGame.amount_coins || 220;
        this.exp = MainGame.exp || 0;
        this.nextCarLevel = MainGame.nextCarLevel || 2;
        this.currentLevel = MainGame.currentLevel || 1;
        this.LIMIT_parking = MainGame.LIMIT_parking || 15;
        this.freeTimeWheel = MainGame.freeTimeWheel || 0;
        this.levelCannonDmg = MainGame.levelCannonDmg || 1;
        this.levelDiscount = MainGame.levelDiscount || 1;
        this.levelEarning = MainGame.levelEarning || 1;
        this.num_wave = MainGame.num_wave || 1;
        this.level_wall = MainGame.level_wall || 1;
        var kfShopPriv = 1e4;
        this.arLevelCannonDmg = [{price: kfShopPriv * 50, value: 5}, {
            price: kfShopPriv * 2500,
            value: 10
        }, {price: kfShopPriv * 125e3, value: 25}, {price: kfShopPriv * 625e4, value: 50}, {
            price: kfShopPriv * 3125e5,
            value: 100
        }, {price: kfShopPriv * 15625e6, value: 200}, {
            price: kfShopPriv * 78125e7,
            value: 300
        }, {price: kfShopPriv * 390625e8, value: 400}, {price: kfShopPriv * 1953125e9, value: 500}];
        this.arLevelDiscount = [{price: kfShopPriv * 50, value: 5}, {
            price: kfShopPriv * 2500,
            value: 10
        }, {price: kfShopPriv * 125e3, value: 15}, {price: kfShopPriv * 625e4, value: 20}, {
            price: kfShopPriv * 3125e5,
            value: 25
        }, {price: kfShopPriv * 15625e6, value: 30}, {
            price: kfShopPriv * 78125e7,
            value: 35
        }, {price: kfShopPriv * 390625e8, value: 40}, {price: kfShopPriv * 1953125e9, value: 50}];
        this.arLevelEarning = [{price: kfShopPriv * 50, value: 5}, {
            price: kfShopPriv * 2500,
            value: 10
        }, {price: kfShopPriv * 125e3, value: 15}, {price: kfShopPriv * 625e4, value: 20}, {
            price: kfShopPriv * 3125e5,
            value: 30
        }, {price: kfShopPriv * 15625e6, value: 40}, {
            price: kfShopPriv * 78125e7,
            value: 50
        }, {price: kfShopPriv * 390625e8, value: 75}, {price: kfShopPriv * 1953125e9, value: 100}];
        this.factorCannonDmg = 1;
        this.factorDiscount = 1;
        this.factorEarning = 1;
        this.exp_max = this.getExpMax(this.currentLevel);
        this.arCurrentPricesCar = [];
        this.box_have = [];
        this.buffer_boxes = [];
        this.arDeltaCarLevel = [];
        if (MainGame.box_have) {
            for (var i = 0; i < this.MAX_PARKING; i++) {
                this.box_have[i] = MainGame.box_have[i]
            }
        } else {
            for (var i = 0; i < this.MAX_PARKING; i++) {
                this.box_have[i] = null
            }
        }
        if (MainGame.buffer_boxes) {
            for (var i = 0; i < MainGame.buffer_boxes.length; i++) {
                this.buffer_boxes[i] = MainGame.buffer_boxes[i]
            }
        }
        if (MainGame.arDeltaCarLevel) {
            for (var i = 0; i < this.MAX_TYPES_CAR; i++) {
                this.arDeltaCarLevel[i] = MainGame.arDeltaCarLevel[i]
            }
        } else {
            for (var i = 0; i < this.MAX_TYPES_CAR; i++) {
                this.arDeltaCarLevel[i] = 0
            }
        }
        this.timer_freeBox = 0;
        this.timer_helicopter = this.TIME_ADD_HELICOPTER - 30;
        this.timer_carAds = this.TIME_ADD_ADS_CAR - 35;
        this.timer_btn_fastbuy = 0;
        this.timer_btn_forge = 0;
        this.time.addEvent({delay: 1e3, callback: this.updateTimerEverySec, callbackScope: this, loop: true});
        this.timerCheckHelp = 0;
        this.timerCheckBuffer = 0
    }

    updateTimerEverySec() {
        this.updateForge();
        this.timer_helicopter++;
        if (this.timer_helicopter >= this.TIME_ADD_HELICOPTER) {
            this.timeToHelicopter();
            this.timer_helicopter = 0
        }
        if (this.num_ads_car == 0) {
            this.timer_carAds++;
            if (this.timer_carAds >= this.TIME_ADD_ADS_CAR) {
                this.goAllowAdsCar();
                this.timer_carAds = 0
            }
        }
        this.timer_btn_fastbuy++;
        if (this.timer_btn_fastbuy >= this.TIME_BTN_FASTBUY_EFFECT) {
            if (this.checkFastBuy()) this.gameGUI.showBtnFastbuyEffect();
            this.timer_btn_fastbuy = 0
        }
        if (!this.isGoTutorial) this.timer_btn_forge++;
        if (this.timer_btn_forge >= this.TIME_BTN_FORGE_EFFECT) {
            this.gameGUI.showBtnForgeEffect();
            this.timer_btn_forge = 0
        }
        if (this.freeTimeWheel < MainGame.maxTimeWheel) {
            if (this.countDownNextFree > 0) {
                this.countDownNextFree--;
                MainGame.cdNextFree = this.countDownNextFree;
                if (this.countDownNextFree == 0) {
                    this.freeTimeWheel++;
                    MainGame.freeTimeWheel = this.freeTimeWheel;
                    if (this.freeTimeWheel < MainGame.maxTimeWheel) {
                        this.countDownNextFree = this.TIME_NEXT_FREE
                    }
                    this.gameGUI.iconAdvFortune.visible = true
                }
                this.gameGUI.updateFortunaWheelWindow(this.countDownNextFree)
            }
        }
        if (!this.isAutoMerge) {
            if (this.countDownOfferTV > 0) {
                this.countDownOfferTV--;
                if (this.countDownOfferTV == 0) {
                    this.gameGUI.showOfferTV()
                }
            } else if (this.countDownOfferTV < 0) {
                this.countDownOfferTV++
            }
        }
        if (!this.isGoTutorial) {
            MainGame.amount_coins = this.amount_coins;
            MainGame.saveSaves()
        }
    }

    checkFastBuy() {
        if (this.getSlotFullness() == 10) return false;
        var typeFastCar = this.getTypeBetterPrice();
        var priceCar = this.getPriceCar(typeFastCar);
        priceCar = Math.round(priceCar * this.factorDiscount);
        if (this.amount_coins < priceCar) return false;
        return true
    }

    initEffects() {
        this.anims.create({
            key: "effect_connect",
            frames: this.anims.generateFrameNames("ss_main", {prefix: "effect_connect1_", end: 13, zeroPad: 4}),
            hideOnComplete: true
        });
        this.anims.create({
            key: "delete_dust",
            frames: this.anims.generateFrameNames("ss_main", {prefix: "delete_dust_", end: 12, zeroPad: 4}),
            hideOnComplete: true
        });
        this.anims.create({
            key: "effect_connect2",
            frames: this.anims.generateFrameNames("ss_main", {prefix: "effect_connect2_", end: 28, zeroPad: 4}),
            hideOnComplete: true
        });
        this.anims.create({
            key: "magic_1",
            frames: this.anims.generateFrameNames("ss_main", {prefix: "magic_1_", end: 14, zeroPad: 4}),
            hideOnComplete: false,
            repeat: -1
        });
        this.anims.create({
            key: "propeller1",
            frames: this.anims.generateFrameNames("ss_main", {prefix: "propeller1_", end: 7, zeroPad: 4}),
            hideOnComplete: false,
            repeat: -1
        });
        this.anims.create({
            key: "propeller2",
            frames: this.anims.generateFrameNames("ss_main", {prefix: "propeller2_", end: 7, zeroPad: 4}),
            hideOnComplete: false,
            repeat: -1
        });
        this.anims.create({
            key: "effect_unboxing",
            frames: this.anims.generateFrameNames("ss_main", {prefix: "effect_unboxing_", end: 8, zeroPad: 4}),
            hideOnComplete: true
        });
        this.anims.create({
            key: "effect_kick1",
            frames: this.anims.generateFrameNames("ss_main", {prefix: "effect_kick_", end: 7, zeroPad: 4}),
            hideOnComplete: true
        });
        this.anims.create({
            key: "effect_kick2",
            frames: this.anims.generateFrameNames("ss_main", {prefix: "effect_kick2_", end: 5, zeroPad: 4}),
            hideOnComplete: true
        });
        this.anims.create({
            key: "effect_dead",
            frames: this.anims.generateFrameNames("ss_main", {prefix: "effect_dead_", end: 9, zeroPad: 4}),
            hideOnComplete: true
        });
        this.anims.create({
            key: "effect_dead2",
            frames: this.anims.generateFrameNames("ss_main", {prefix: "effect_dead2_", end: 12, zeroPad: 4}),
            hideOnComplete: true
        });
        this.anims.create({
            key: "effect_boom",
            frames: this.anims.generateFrameNames("ss_main", {prefix: "effect_boom_", end: 13, zeroPad: 4}),
            hideOnComplete: true
        });
        this.anims.create({
            key: "effect_coin",
            frames: this.anims.generateFrameNames("ss_main", {prefix: "effect_coin_", end: 11, zeroPad: 4}),
            hideOnComplete: false,
            repeat: -1
        });
        this.anims.create({
            key: "effect_tutor",
            frames: this.anims.generateFrameNames("ss_main", {prefix: "effect_tutor_", end: 19, zeroPad: 4}),
            hideOnComplete: false,
            repeat: -1
        });
        this.anims.create({
            key: "delete_flash",
            frames: this.anims.generateFrameNames("ss_main", {prefix: "delete_flash_", end: 24, zeroPad: 4}),
            hideOnComplete: false,
            repeat: -1
        });
        this.anims.create({
            key: "effect_connect3",
            frames: this.anims.generateFrameNames("ss_main", {prefix: "effect_connect3_", end: 29, zeroPad: 4}),
            hideOnComplete: false,
            repeat: -1
        });
        this.anims.create({
            key: "flash_btn_big",
            frames: this.anims.generateFrameNames("ss_main", {prefix: "flash_btn_big_", end: 15, zeroPad: 4}),
            hideOnComplete: false
        });
        this.anims.create({
            key: "flash_btn_forge",
            frames: this.anims.generateFrameNames("ss_main", {prefix: "flash_btn_forge_", end: 15, zeroPad: 4}),
            hideOnComplete: false
        })
    }

    addEffectKick(vX, vY, vType) {
        vX += MyMath.getRandomInt(-3, 3);
        vY += MyMath.getRandomInt(-3, 3);
        this.showEffect(vX, vY, "effect_kick" + vType);
        if (vType == 1) {
            var r = MyMath.getRandomInt(1, 4);
            MainGame.Sfx.play("sound", "kick" + r)
        } else {
            var r = MyMath.getRandomInt(1, 5);
            MainGame.Sfx.play("sound", "knock" + r)
        }
    }

    addEffectKilled(vX, vY) {
        vX += MyMath.getRandomInt(-3, 3);
        vY += MyMath.getRandomInt(-3, 3);
        var r = MyMath.getRandomInt(1, 6);
        MainGame.Sfx.play("sound", "dead" + r);
        this.showEffect(vX, vY, "effect_dead");
        this.showEffect(vX, vY, "effect_dead2");
        var effectCoin = this.showEffect(vX, vY, "effect_coin", false);
        if (effectCoin) {
            this.tweens.add({
                targets: effectCoin,
                y: vY - 70,
                ease: Phaser.Math.Easing.Sine.Out,
                duration: 400,
                yoyo: true,
                onComplete: function () {
                    effectCoin.hide()
                }
            })
        }
    }

    initHelicopterBonuses() {
        this.ar_bonuses = ["auto_merge", "speed_x2", "reward_box4", "bonus_coins"];
        this.heli_count = 3;
        this.helicopterBonus = this.ar_bonuses[this.heli_count]
    }

    getHelicopterBonus() {
        this.helicopterBonus = this.ar_bonuses[this.heli_count];
        this.heli_count++;
        if (this.heli_count >= this.ar_bonuses.length) {
            this.heli_count = 0;
            MyMath.shuffleArr(this.ar_bonuses)
        }
    }

    increaseLevel(vValue, vShowLater) {
        this.exp += vValue;
        var delta = this.exp_max - this.exp;
        if (this.exp >= this.exp_max) {
            this.exp = -delta;
            this.currentLevel++;
            this.exp_max = this.getExpMax(this.currentLevel);
            this.gameGUI.textLevel.setText(this.currentLevel);
            this.gameGUI.updateLevel(1);
            this.gameGUI.updateLevel(this.exp / this.exp_max, 250);
            if (vShowLater) {
                this.showAfterMerge = true
            } else {
                this.time.delayedCall(500, this.gameGUI.showLevelUpWindow, [], this.gameGUI)
            }
            if (this.currentLevel == 2) {
                this.timer_helicopter = this.TIME_ADD_HELICOPTER - 5
            }
            if (this.currentLevel >= 3 && this.freeTimeWheel > 0) {
                this.gameGUI.iconAdvFortune.visible = true;
                this.gameGUI.buttonFortuna.visible = true
            }
        } else {
            this.gameGUI.updateLevel(this.exp / this.exp_max)
        }
    }

    checkNextCar() {
        var countParking = this.LIMIT_parking;
        var parking;
        var progress = 0;
        var type = 0;
        var cost_current = 0;
        var cost_need = Math.pow(2, this.nextCarLevel - 1);
        for (var i = 0; i < countParking; i++) {
            parking = this.arParking[i];
            type = parking.type;
            if (type > 0) {
                cost_current += Math.pow(2, type - 1)
            }
        }
        progress = cost_current / cost_need;
        if (progress > 1) {
            progress = 1
        }
    }

    updateBoxHave() {
        if (this.isGoTutorial) return;
        var parking;
        for (var i = 0; i < this.LIMIT_parking; i++) {
            parking = this.arParking[i];
            if (parking.type > 0) {
                this.box_have[i] = {id: parking.id, t: parking.type, r: parking.racing}
            } else {
                this.box_have[i] = null
            }
        }
        this.saveBoxHave();
        this.saveGameValues()
    }

    saveBoxHave() {
        if (this.isGoTutorial) return;
        MainGame.box_have = [];
        for (var i = 0; i < this.box_have.length; i++) {
            MainGame.box_have.push(this.box_have[i])
        }
        MainGame.saveSaves()
    }

    saveBoxBuffer() {
        MainGame.buffer_boxes = [];
        for (var i = 0; i < this.buffer_boxes.length; i++) {
            MainGame.buffer_boxes.push(this.buffer_boxes[i])
        }
        MainGame.saveSaves()
    }

    saveDeltaCarLevel() {
        if (this.isGoTutorial) return;
        MainGame.arDeltaCarLevel = [];
        for (var i = 0; i < this.arDeltaCarLevel.length; i++) {
            MainGame.arDeltaCarLevel.push(this.arDeltaCarLevel[i])
        }
        MainGame.saveSaves()
    }

    saveDeltaWallLevel() {
        if (this.isGoTutorial) return;
        this.saveGameValues()
    }

    saveGameValues() {
        if (this.isGoTutorial) return;
        MainGame.amount_coins = this.amount_coins;
        MainGame.level_wall = this.level_wall;
        MainGame.num_wave = this.num_wave;
        MainGame.exp = this.exp;
        MainGame.nextCarLevel = this.nextCarLevel;
        MainGame.currentLevel = this.currentLevel;
        MainGame.LIMIT_parking = this.LIMIT_parking;
        MainGame.LIMIT_pilots = this.LIMIT_pilots;
        MainGame.lastSession = (new Date).getTime();
        MainGame.saveSaves()
    }

    initParkings() {
        this.arParking = [];
        var posX = 715;
        var posY = 75;
        var offsetY = 83;
        var posX2 = 133;
        var posX3 = 133 + 83;
        this.arParking.push({
            id: 0,
            x: posX,
            y: posY + offsetY * 0,
            obj: null,
            busy: false,
            battle: true,
            type: 0,
            allow: true
        });
        this.arParking.push({
            id: 1,
            x: posX,
            y: posY + offsetY * 1,
            obj: null,
            busy: false,
            battle: true,
            type: 0,
            allow: true
        });
        this.arParking.push({
            id: 2,
            x: posX,
            y: posY + offsetY * 2,
            obj: null,
            busy: false,
            battle: true,
            type: 0,
            allow: true
        });
        this.arParking.push({
            id: 3,
            x: posX,
            y: posY + offsetY * 3,
            obj: null,
            busy: false,
            battle: true,
            type: 0,
            allow: true
        });
        this.arParking.push({
            id: 4,
            x: posX,
            y: posY + offsetY * 4,
            obj: null,
            busy: false,
            battle: true,
            type: 0,
            allow: true
        });
        this.arParking.push({
            id: 5,
            x: posX + posX2,
            y: posY + offsetY * 0,
            obj: null,
            busy: false,
            battle: false,
            type: 0,
            allow: true
        });
        this.arParking.push({
            id: 6,
            x: posX + posX2,
            y: posY + offsetY * 1,
            obj: null,
            busy: false,
            battle: false,
            type: 0,
            allow: true
        });
        this.arParking.push({
            id: 7,
            x: posX + posX2,
            y: posY + offsetY * 2,
            obj: null,
            busy: false,
            battle: false,
            type: 0,
            allow: true
        });
        this.arParking.push({
            id: 8,
            x: posX + posX2,
            y: posY + offsetY * 3,
            obj: null,
            busy: false,
            battle: false,
            type: 0,
            allow: true
        });
        this.arParking.push({
            id: 9,
            x: posX + posX2,
            y: posY + offsetY * 4,
            obj: null,
            busy: false,
            battle: false,
            type: 0,
            allow: true
        });
        this.arParking.push({
            id: 10,
            x: posX + posX3,
            y: posY + offsetY * 0,
            obj: null,
            busy: false,
            battle: false,
            type: 0,
            allow: true
        });
        this.arParking.push({
            id: 11,
            x: posX + posX3,
            y: posY + offsetY * 1,
            obj: null,
            busy: false,
            battle: false,
            type: 0,
            allow: true
        });
        this.arParking.push({
            id: 12,
            x: posX + posX3,
            y: posY + offsetY * 2,
            obj: null,
            busy: false,
            battle: false,
            type: 0,
            allow: true
        });
        this.arParking.push({
            id: 13,
            x: posX + posX3,
            y: posY + offsetY * 3,
            obj: null,
            busy: false,
            battle: false,
            type: 0,
            allow: true
        });
        this.arParking.push({
            id: 14,
            x: posX + posX3,
            y: posY + offsetY * 4,
            obj: null,
            busy: false,
            battle: false,
            type: 0,
            allow: true
        });
        for (var i = 0; i < this.arParking.length; i++) {
            this.addParking(this.arParking[i])
        }
    }

    addParking(vData) {
        var icon_parking = this.add.image(vData.x, vData.y - 5, "ss_main", "icon_parking_0000");
        var highlighter = this.add.image(vData.x + this.HIGHLIGHTER_OFFSET.x, vData.y + this.HIGHLIGHTER_OFFSET.y, "ss_main", "highlighted_car_0000");
        var icon_panel_number = this.add.image(vData.x, vData.y, "ss_main", "panel_number_0000");
        icon_panel_number.setScale(1.1);
        icon_panel_number.x += this.PANEL_NUMBER_OFFSET.x;
        icon_panel_number.y += this.PANEL_NUMBER_OFFSET.y;
        icon_parking.setDepth(this.DEPTH_platform);
        highlighter.setDepth(this.DEPTH_hightlight);
        icon_panel_number.setDepth(this.DEPTH_panel_number);
        var textNumberType = this.add.container();
        textNumberType.setDepth(this.DEPTH_text_number);
        highlighter.visible = false;
        icon_panel_number.visible = false;
        textNumberType.visible = false;
        vData.icon_parking = icon_parking;
        vData.highlighter = highlighter;
        vData.icon_panel_number = icon_panel_number;
        vData.textNumberType = textNumberType;
        vData.initPos = {x: vData.x, y: vData.y};
        if (!vData.battle) {
            icon_parking.visible = false
        }
    }

    getTypeFastCar() {
        var vLvl = this.nextCarLevel - 1;
        switch (vLvl) {
            case 1:
            case 2:
            case 3:
            case 4:
            case 5:
                return 1;
                break;
            case 6:
                return 2;
                break;
            case 7:
                return 3;
                break;
            case 8:
                return 3;
                break;
            case 9:
                return 4;
                break;
            case 10:
                return 4;
                break;
            case 11:
                return 5;
                break;
            default:
                return vLvl - 7;
                break
        }
    }

    getTypeRandomBox() {
        var vLvl = this.getTypeFastCar() - 1;
        if (vLvl < 1) vLvl = 1;
        return vLvl
    }

    getFreeParking() {
        var placeNum = -1;
        for (var i = 0; i < this.LIMIT_parking; i++) {
            if (this.selectedCar) {
                if (this.selectedCar.id == i) {
                    continue
                }
            }
            if (!this.arParking[i].busy && !this.arParking[i].battle) {
                placeNum = i;
                break
            }
        }
        return placeNum
    }

    getCountMobCoins(vNumWave) {
        return 30 * Math.floor(Math.pow(2, vNumWave))
    }

    getCountBossCoins(vNumWave) {
        return 1500 * Math.round(Math.pow(2, vNumWave))
    }

    getCountMobHp(vNumWave) {
        if (vNumWave <= 15) {
            return 250 * Math.floor(Math.pow(1.45, vNumWave))
        } else if (vNumWave > 15 && vNumWave <= 20) {
            return 300 * Math.floor(Math.pow(1.65, vNumWave))
        } else if (vNumWave > 20 && vNumWave <= 25) {
            return 400 * Math.floor(Math.pow(1.75, vNumWave))
        } else if (vNumWave > 25 && vNumWave <= 30) {
            return 500 * Math.floor(Math.pow(2, vNumWave))
        } else if (vNumWave > 30 && vNumWave <= 35) {
            return 600 * Math.floor(Math.pow(2.25, vNumWave))
        } else {
            return 700 * Math.floor(Math.pow(2.45, vNumWave))
        }
    }

    getCountBossHp(vNumWave) {
        if (vNumWave <= 15) {
            return Math.round(5e3 * Math.pow(1.65, vNumWave - 1))
        } else if (vNumWave > 15 && vNumWave <= 20) {
            return Math.round(7e3 * Math.pow(1.9, vNumWave - 1))
        } else if (vNumWave > 20 && vNumWave <= 25) {
            return Math.round(8e3 * Math.pow(2.05, vNumWave - 1))
        } else if (vNumWave > 25 && vNumWave <= 30) {
            return Math.round(1e4 * Math.pow(2.1, vNumWave - 1))
        } else if (vNumWave > 30 && vNumWave <= 35) {
            return Math.round(15e3 * Math.pow(2.5, vNumWave - 1))
        } else {
            return Math.round(15e3 * Math.pow(2.55, vNumWave - 1))
        }
    }

    getMobDamage(vNumWave) {
        return Math.round(4 * Math.pow(1.3, vNumWave - 1))
    }

    getBossDamage(vNumWave) {
        return Math.round(40 * Math.pow(1.2, vNumWave - 1))
    }

    getCoinsLevelUp(vPlayerLevel) {
        return 1500 * Math.round(Math.pow(2.5, vPlayerLevel))
    }

    getExpMerge(vCarLevel) {
        return 15 * Math.pow(2, vCarLevel)
    }

    getExpMax(vPlayerLevel) {
        return 250 * Math.pow(2, vPlayerLevel)
    }

    getDamage(vType) {
        var dmg = 15 * Math.pow(2, vType);
        dmg = Math.floor(dmg * this.factorCannonDmg);
        return dmg
    }

    getPriceWall(vLevel) {
        var value = vLevel || this.level_wall;
        return Math.pow(4, value) * 500
    }

    updateWallValues() {
        this.wall_hp_max = 500 * Math.round(Math.pow(1.5, this.level_wall + 1));
        this.wall_hp = this.wall_hp_max;
        this.gameGUI.updateWallHp(1, this.wall_hp, this.wall_hp_max);
        this.setSpriteText(this.text_wall_lvl, this.level_wall)
    }

    saveBoxHave() {
        if (this.isGoTutorial) return;
        MainGame.box_have = [];
        for (var i = 0; i < this.box_have.length; i++) {
            MainGame.box_have.push(this.box_have[i])
        }
        MainGame.saveSaves()
    }

    getScaleCar(value, bool) {
        if (bool) {
            var atlas_scale = 2;
            var scale = value / atlas_scale;
            return Math.round(scale * 100) / 100
        } else {
            return value
        }
    }

    getTypeBetterPrice() {
        var vLvl = this.nextCarLevel - 1;
        switch (vLvl) {
            case 1:
            case 2:
            case 3:
            case 4:
            case 5:
                return 1;
                break;
            case 6:
            case 7:
            case 8:
                var price1 = this.getPriceCar(vLvl - 5);
                var price2 = this.getPriceCar(vLvl - 4);
                var type = vLvl - 5;
                if (price1 > price2 * .5) type = vLvl - 4;
                return type;
                break;
            default:
                var price1 = this.getPriceCar(vLvl - 6);
                var price2 = this.getPriceCar(vLvl - 5);
                var price3 = this.getPriceCar(vLvl - 4);
                var type = vLvl - 6;
                if (price1 > price2 * .5) type = vLvl - 5;
                if (price2 > price3 * .5) type = vLvl - 4;
                return type;
                break
        }
    }

    getCarInfo(type) {
        var _price = 100;
        if (type > 1) {
            _price = Math.floor(1500 * Math.pow(2.29, type - 2))
        }
        return {price: _price}
    }

    updateCarPrices() {
        var price = 0;
        for (var i = 0; i < this.MAX_TYPES_CAR; i++) {
            price = this.getCarInfo(i + 1).price;
            for (var j = 0; j < this.arDeltaCarLevel[i]; j++) {
                price = Math.round(price * this.DELTA_PRICE)
            }
            this.arCurrentPricesCar[i] = price
        }
    }

    getPriceCar(vType) {
        return this.arCurrentPricesCar[vType - 1]
    }

    updatePriceCar(vType) {
        var type_car = vType;
        this.arDeltaCarLevel[type_car - 1]++;
        var new_value = this.arCurrentPricesCar[type_car - 1] * this.DELTA_PRICE;
        this.arCurrentPricesCar[type_car - 1] = Math.round(new_value)
    }

    clickBuyShopItem(value) {
        if (this.ALLOW_ADS_CAR && this.num_ads_car == value) {
            if (this.getFreeParking() < 0) {
                this.gameGUI.showSystemMessage(MainGame.GAME_TEXT.no_parking);
                return
            }
            this.showAdsForCar()
        } else {
            this.buyCar(value, true)
        }
    }

    buyFastCar() {
        var typeFastCar = this.getTypeBetterPrice();
        this.buyCar(typeFastCar, false);
        this.timer_btn_fastbuy = 0;
        if (this.isGoTutorial && this.tutorialStep < 3) {
            this.gameGUI.tutorialScenario()
        }
    }

    buyCar(vNum, vFromShop) {
        if (this.getFreeParking() < 0) {
            this.gameGUI.showSystemMessage(MainGame.GAME_TEXT.no_parking);
            return
        }
        var priceCar = this.getPriceCar(vNum);
        priceCar = Math.round(priceCar * this.factorDiscount);
        if (this.amount_coins < priceCar) {
            this.gameGUI.showSystemMessage(MainGame.GAME_TEXT.no_money);
            return
        }
        this.addObject({lvl: vNum, fromShop: vFromShop}, true);
        this.amount_coins -= priceCar;
        var text_coins_warm = MainGame.convertNumberFormat(this.amount_coins);
        this.gameGUI.updateCoins(text_coins_warm);
        this.gameGUI.updateShop(text_coins_warm);
        this.updatePriceCar(vNum);
        this.gameGUI.updateFastBuy();
        this.checkWallUpgrade();
        this.gameGUI.updateShopItem();
        this.updateBoxHave();
        this.saveDeltaCarLevel();
        MainGame.Sfx.play("sound", "buy")
    }

    clickBuyWall() {
        var price = this.getPriceWall();
        price = Math.round(price * this.factorDiscount);
        if (this.amount_coins < price) {
            this.gameGUI.showSystemMessage(MainGame.GAME_TEXT.no_money);
            return
        }
        this.level_wall++;
        this.updateWallValues();
        this.amount_coins -= price;
        var text_coins_warm = MainGame.convertNumberFormat(this.amount_coins);
        this.gameGUI.updateCoins(text_coins_warm);
        this.gameGUI.updateShop(text_coins_warm);
        this.gameGUI.updateWallBuy();
        this.checkWallUpgrade();
        this.saveDeltaWallLevel();
        MainGame.Sfx.play("sound", "buy")
    }

    clickForge() {
        this.timer_btn_forge = 0;
        this.updateForge()
    }

    updateForge() {
        if (this.getSlotFullness() == 10) return;
        this.timer_freeBox++;
        if (this.timer_freeBox >= this.TIME_ADD_FREE_BOX) {
            this.timeToAddFreeBox();
            this.timer_freeBox = 0
        }
        var progress = this.timer_freeBox / this.TIME_ADD_FREE_BOX;
        this.gameGUI.updateForge(1 - progress)
    }

    setSpriteText(vLayer, vNum) {
        vLayer.removeAll(true);
        var stringNum = vNum.toString();
        var arrayOfNum = stringNum.split("");
        var length = 0;
        var symb = null;
        var symsAr = [];
        for (var n in arrayOfNum) {
            symb = this.add.image(length, 2, "ss_main", "num_" + arrayOfNum[n] + "_0000");
            symb.setScale(1.05);
            symb.setOrigin(0, .5);
            vLayer.add(symb);
            symsAr.push(symb);
            length += symb.displayWidth - 4
        }
        var offsetX = 0;
        var totalLength = Math.floor(length * .5);
        for (var s in symsAr) {
            symsAr[s].x -= totalLength
        }
    }

    addBoxToBuffer(vTypeCar) {
        this.buffer_boxes.push({type: vTypeCar})
    }

    checkBuffer() {
        if (this.buffer_boxes.length > 0) {
            var free_park_num = this.getFreeParking();
            if (free_park_num >= 0) {
                var obj = this.buffer_boxes.shift();
                this.addObject({lvl: obj.type, skinBox: true});
                this.updateBoxHave();
                this.saveBoxBuffer()
            }
        }
    }

    addObject(data, vIsSound) {
        data = data || {};
        var num = data.lvl || this.getTypeRandomBox();
        var free_park_num = -1;
        if (data.parkingId != null) {
            free_park_num = data.parkingId
        } else {
            free_park_num = this.getFreeParking()
        }
        if (free_park_num >= 0) {
            var park_place = this.arParking[free_park_num];
            park_place.busy = true;
            var posX = park_place.x + this.CARS_OFFSET.x;
            var posY = park_place.y + this.CARS_OFFSET.y;
            var car = new Tower(this, this.layerTowers, posX, posY, num);
            park_place.icon_panel_number.visible = true;
            park_place.textNumberType.visible = true;
            this.setSpriteText(park_place.textNumberType, num);
            park_place.obj = car;
            park_place.type = num;
            if (data.parkingId == null || data.skinBox) {
                if (data.skinBox || data.fromShop) {
                    if (data.fromShop) {
                        car.setSkinBox(2);
                        car.view.x += 12;
                        car.view.y -= 2
                    } else {
                        car.setSkinBox(1);
                        car.view.x += 10;
                        car.view.y -= 3
                    }
                    car.view.setOrigin(.5);
                    this.shakeBox(park_place);
                    park_place.icon_panel_number.visible = false;
                    park_place.textNumberType.visible = false;
                    if (!data.fromShop) MainGame.Sfx.play("sound", "show_box")
                }
                car.setViewScale(.3);
                car.setViewAlpha(.5);
                this.tweens.add({
                    targets: car.view,
                    scale: this.getScaleCar(1),
                    ease: Phaser.Math.Easing.Back.Out,
                    duration: 200
                });
                this.tweens.add({targets: car.view, alpha: 1, ease: Phaser.Math.Easing.Linear, duration: 150})
            }
        } else {
            this.gameGUI.showSystemMessage(MainGame.GAME_TEXT.no_parking)
        }
        this.checkNextCar();
        if (vIsSound) this.getSlotFullness(true)
    }

    openBox(vParking, vIsAnimScale) {
        var vObj = vParking.obj;
        if (vObj == null) return;
        if (this.isGoTutorial && this.tutorialStep == 5) {
            this.gameGUI.tutorialScenario()
        }
        if (vObj.timedEvent) vObj.timedEvent.remove();
        vObj.count_box_tween = 0;
        vObj.setSkinTower(vParking.type);
        this.tweens.killTweensOf(vObj.view);
        vObj.setViewAngle(0);
        vObj.setViewPosition(vParking.x + this.CARS_OFFSET.x, vParking.y + this.CARS_OFFSET.y);
        vParking.icon_panel_number.visible = true;
        vParking.textNumberType.visible = true;
        if (vIsAnimScale) {
            this.showEffect(vObj.view.x + 10, vObj.view.y, "effect_unboxing");
            vObj.setViewScale(.3);
            vObj.setViewAlpha(.5);
            this.tweens.add({
                targets: vObj.view,
                scale: this.getScaleCar(1),
                ease: Phaser.Math.Easing.Back.Out,
                duration: 200
            });
            this.tweens.add({targets: vObj.view, alpha: 1, ease: Phaser.Math.Easing.Linear, duration: 150});
            MainGame.Sfx.play("sound", "open_box")
        }
    }

    goShake(vParking) {
        var vObj = vParking.obj;
        if (vObj) {
            vObj.count_box_tween--;
            if (vObj.count_box_tween <= 0) {
                this.openBox(vParking, true)
            } else {
                this.tweens.add({
                    targets: vObj.view,
                    angle: -10,
                    ease: Phaser.Math.Easing.Sine.InOut,
                    duration: 150,
                    repeat: 1,
                    yoyo: true
                })
            }
        }
    }

    shakeBox(vParking) {
        var vObj = vParking.obj;
        vObj.count_box_tween = 5;
        if (this.isGoTutorial) return;
        vObj.timedEvent = this.time.addEvent({
            args: [vParking],
            delay: 1500,
            callback: this.goShake,
            callbackScope: this,
            repeat: vObj.count_box_tween
        })
    }

    updateParking() {
        var countParking = this.LIMIT_parking;
        var parking = null;
        for (var i = 0; i < countParking; i++) {
            parking = this.arParking[i];
            parking.x = parking.initPos.x;
            parking.y = parking.initPos.y;
            parking.icon_parking.x = parking.x;
            parking.icon_parking.y = parking.y;
            parking.highlighter.x = parking.x + this.HIGHLIGHTER_OFFSET.x;
            parking.highlighter.y = parking.y + this.HIGHLIGHTER_OFFSET.y;
            parking.icon_panel_number.x = parking.x + this.PANEL_NUMBER_OFFSET.x;
            parking.icon_panel_number.y = parking.y + this.PANEL_NUMBER_OFFSET.y;
            parking.textNumberType.x = parking.x + this.PANEL_NUMBER_OFFSET.x - 3;
            parking.textNumberType.y = parking.y + this.PANEL_NUMBER_OFFSET.y - 3;
            if (parking.obj) {
                parking.obj.x = parking.x + this.CARS_OFFSET.x;
                parking.obj.y = parking.y + this.CARS_OFFSET.y
            }
        }
        this.hideArmHelp()
    }

    initArmHelp() {
        this.arm_help = this.add.image(this.midX, this.midY, "ss_main", "tutor_cursor_0000");
        this.arm_help.visible = false;
        this.arm_help.setDepth(this.DEPTH_cursorcar);
        this.timerCheckHelp = 0
    }

    hideArmHelp() {
        this.tweens.killTweensOf(this.arm_help);
        this.arm_help.visible = false;
        this.timerCheckHelp = 0
    }

    getSlotFullness(vIsCheckOfferTV) {
        var countBusy = 0;
        var parking;
        for (var i = 0; i < this.LIMIT_parking; i++) {
            parking = this.arParking[i];
            if (parking.id >= 5 && parking.busy) countBusy++
        }
        if (vIsCheckOfferTV && countBusy >= 9 && this.countDownOfferTV == 0) {
            this.countDownOfferTV = 2
        }
        return countBusy
    }

    getMaxParkingPair(isForAutoMerge) {
        var valuesTypes = [];
        var parking;
        for (var i = 0; i < this.LIMIT_parking; i++) {
            parking = this.arParking[i];
            if (parking.type > 0 && parking.allow && parking.type < this.MAX_TYPES_CAR) {
                if (parking.obj && parking.obj.count_box_tween != null && parking.obj.count_box_tween <= 0) {
                    if (parking.id < 5) continue;
                    if (isForAutoMerge && (this.selectedCar && parking.id == this.selectedCar.id)) continue;
                    valuesTypes.push({id: parking.id, type: parking.type})
                }
            }
        }
        if (valuesTypes.length < 1) return null;
        var pairIds = this.getMaxValuePair(valuesTypes);
        if (pairIds.length > 1) {
            return [pairIds[1], pairIds[0]]
        }
    }

    updateArmHelp() {
        if (this.isGoTutorial || this.arm_help.visible || this.isAutoMerge) return;
        this.hideArmHelp();
        var pairIds = this.getMaxParkingPair();
        if (pairIds) {
            this.arm_help.visible = true;
            var parkingA = this.arParking[pairIds[0]];
            var parkingB = this.arParking[pairIds[1]];
            var offsetX = 15;
            var offsetY = 30;
            this.arm_help.x = parkingA.x + offsetX;
            this.arm_help.y = parkingA.y + offsetY;
            this.tweens.add({
                targets: this.arm_help,
                x: parkingB.x + offsetX,
                y: parkingB.y + offsetY,
                ease: "Cubic.easeOut",
                duration: 700,
                hold: 300
            });
            this.time.delayedCall(1500, this.hideArmHelp, [], this)
        }
    }

    getMaxValuePair(ar) {
        var max_value = 0;
        var max_count = 0;
        var indexes_of_max = [];
        ar.sort((function (a, b) {
            return b.type - a.type
        }));
        max_value = ar[0].type;
        max_count = 1;
        indexes_of_max = [ar[0].id];
        for (var i = 1; i < ar.length; i++) {
            if (ar[i].type == max_value) {
                max_count++;
                indexes_of_max.push(ar[i].id);
                if (max_count == 2) {
                    break
                }
            } else {
                max_count = 1;
                max_value = ar[i].type;
                indexes_of_max = [ar[i].id]
            }
        }
        return indexes_of_max
    }

    update(time, delta) {
        var pointer = this.input.activePointer;
        var pos = this.getInputPosition(pointer);
        if (this.gameStarted) {
            if (this.isDrag) {
                this.cursor_car.x = pos.x;
                this.cursor_car.y = pos.y
            }
            this.enemies.update(time, delta);
            if (!this.isGameOver) {
                if (!this.isWaveEnd && !this.isGoTutorial) this.updateWave();
                for (var i = 0; i < this.LIMIT_parking; i++) {
                    this.updateTower(time, delta, this.arParking[i])
                }
                if (this.isAutoMerge) {
                    this.timerCheckAutoMerge += this.WAVE_INC;
                    if (this.timerCheckAutoMerge > 90) {
                        this.checkAutoMerge();
                        this.timerCheckAutoMerge = 0
                    }
                }
            }
            this.gameGUI.updateHelicopter();
            if (!this.arm_help.visible) {
                this.timerCheckHelp++;
                if (this.timerCheckHelp > 120) {
                    this.updateArmHelp();
                    this.timerCheckHelp = 0
                }
            }
            this.timerCheckBuffer++;
            if (this.timerCheckBuffer > 12) {
                this.checkBuffer();
                this.timerCheckBuffer = 0
            }
            this.updateRedTintWall()
        }
    }

    timeToAddFreeBox() {
        if (this.isGoTutorial) return;
        if (MainGame.isApiBreakTime) return;
        var free_park_num = this.getFreeParking();
        if (free_park_num >= 0) {
            this.addObject({skinBox: true}, true);
            this.updateBoxHave()
        }
    }

    timeToHelicopter() {
        if (this.currentLevel < 2) return;
        if (!this.isShowHelicopter && !this.gameGUI.layerBoosterWindow.visible) {
            this.showHelicopter()
        }
    }

    showHelicopter() {
        this.gameGUI.showHelicopter()
    }

    goAllowAdsCar() {
        if (this.nextCarLevel < 6) return;
        if (this.ALLOW_ADS_CAR) return;
        this.ALLOW_ADS_CAR = true;
        this.num_ads_car = this.nextCarLevel - 4;
        this.gameGUI.updateShopItem();
        this.gameGUI.iconAdvShop.visible = true
    }

    updateAdsCar() {
        if (this.ALLOW_ADS_CAR) {
            this.num_ads_car = this.nextCarLevel - 4;
            this.gameGUI.updateShopItem()
        }
    }

    activateBoostCoins(vTime, isFromLoad) {
        vTime = vTime || this.TIME_BOOST_COINS;
        this.isBoostTimer = true;
        if (!isFromLoad && this.countDownBonusCoins > 0) {
            this.countDownBonusCoins += vTime;
            this.gameGUI.updateIndcatorBoostCoins(MainGame.secToHHMMSS(this.countDownBonusCoins));
            return
        }
        this.countDownBonusCoins = vTime;
        this.timerBonusCoins = this.time.addEvent({
            delay: 1e3,
            callback: this.updateTimerBonusCoins,
            callbackScope: this,
            loop: true
        });
        this.gameGUI.enableIndcatorBoostCoins(true);
        this.gameGUI.updateIndcatorBoostCoins(MainGame.secToHHMMSS(this.countDownBonusCoins));
        MainGame.Sfx.play("sound", "boost")
    }

    updateTimerBonusCoins() {
        this.countDownBonusCoins--;
        this.gameGUI.updateIndcatorBoostCoins(MainGame.secToHHMMSS(this.countDownBonusCoins));
        if (this.countDownBonusCoins == 0) {
            this.deactivateBoostCoins()
        }
        MainGame.cdBonusCoins = this.countDownBonusCoins
    }

    deactivateBoostCoins() {
        this.isBoostTimer = false;
        this.gameGUI.enableIndcatorBoostCoins(false);
        this.timerBonusCoins.remove()
    }

    activateBoostAutoMerge(vTime, isFromLoad) {
        vTime = vTime || this.TIME_BOOST_MERGE;
        this.isAutoMerge = true;
        if (!isFromLoad && this.countDownBonusAutoMerge > 0) {
            this.countDownBonusAutoMerge += vTime;
            this.gameGUI.updateIndcatorBoostAutoMerge(MainGame.secToHHMMSS(this.countDownBonusAutoMerge));
            return
        }
        this.countDownBonusAutoMerge = vTime;
        this.timerBonusAutoMerge = this.time.addEvent({
            delay: 1e3,
            callback: this.updateTimerBonusAutoMerge,
            callbackScope: this,
            loop: true
        });
        this.gameGUI.enableIndcatorBoostAutoMerge(true);
        this.gameGUI.updateIndcatorBoostAutoMerge(MainGame.secToHHMMSS(this.countDownBonusAutoMerge));
        MainGame.Sfx.play("sound", "boost")
    }

    updateTimerBonusAutoMerge() {
        this.countDownBonusAutoMerge--;
        this.gameGUI.updateIndcatorBoostAutoMerge(MainGame.secToHHMMSS(this.countDownBonusAutoMerge));
        if (this.countDownBonusAutoMerge == 0) {
            this.deactivateBoostAutoMerge()
        }
        MainGame.cdBonusMerge = this.countDownBonusAutoMerge
    }

    deactivateBoostAutoMerge() {
        this.isAutoMerge = false;
        this.gameGUI.enableIndcatorBoostAutoMerge(false);
        this.timerBonusAutoMerge.remove()
    }

    activateBoostSpeed(vTime, isFromLoad) {
        vTime = vTime || this.TIME_BOOST_SPEED;
        this.isDoubleSpeed = true;
        this.updateSpeedGame(this.isDoubleSpeed);
        if (!isFromLoad && this.countDownBonusSpeed > 0) {
            this.countDownBonusSpeed += vTime;
            this.gameGUI.updateIndcatorBoostSpeed(MainGame.secToHHMMSS(this.countDownBonusSpeed));
            return
        }
        this.countDownBonusSpeed = vTime;
        this.timerBonusSpeed = this.time.addEvent({
            delay: 1e3,
            callback: this.updateTimerBonusSpeed,
            callbackScope: this,
            loop: true
        });
        this.gameGUI.enableIndcatorBoostSpeed(true);
        this.gameGUI.updateIndcatorBoostSpeed(MainGame.secToHHMMSS(this.countDownBonusSpeed));
        MainGame.Sfx.play("sound", "boost")
    }

    updateTimerBonusSpeed() {
        this.countDownBonusSpeed--;
        this.gameGUI.updateIndcatorBoostSpeed(MainGame.secToHHMMSS(this.countDownBonusSpeed));
        if (this.countDownBonusSpeed == 0) {
            this.deactivateBoosSpeed()
        }
        MainGame.cdBonusSpeed = this.countDownBonusSpeed
    }

    deactivateBoosSpeed() {
        this.isDoubleSpeed = false;
        this.updateSpeedGame(this.isDoubleSpeed);
        this.gameGUI.enableIndcatorBoostSpeed(false);
        this.timerBonusSpeed.remove()
    }

    actionChangeParking(toParking, fromParking) {
        if (fromParking.obj == null) return;
        fromParking.obj.setViewPosition(toParking.x + this.CARS_OFFSET.x, toParking.y + this.CARS_OFFSET.y);
        fromParking.obj.setViewAlpha(1);
        if (fromParking.battle && !toParking.battle) {
            fromParking.obj.clearTarget()
        }
        toParking.busy = true;
        toParking.allow = true;
        toParking.obj = fromParking.obj;
        toParking.type = fromParking.type;
        toParking.obj.setViewAngle(0);
        toParking.obj.setInitPosition(toParking.obj.view.x, toParking.obj.view.y);
        toParking.icon_panel_number.visible = true;
        toParking.textNumberType.visible = true;
        this.setSpriteText(toParking.textNumberType, fromParking.type);
        if (toParking.id != fromParking.id) {
            fromParking.type = 0;
            fromParking.busy = false;
            fromParking.allow = true;
            fromParking.obj = null;
            fromParking.icon_panel_number.visible = false;
            fromParking.textNumberType.visible = false
        }
    }

    actionTrash(selectedParking) {
        var priceCar = this.getPriceCar(selectedParking.type);
        this.amount_coins += Math.round(priceCar * this.VALUE_SELL);
        var text_coins_warm = MainGame.convertNumberFormat(this.amount_coins);
        this.gameGUI.updateCoins(text_coins_warm);
        this.gameGUI.updateShop(text_coins_warm);
        selectedParking.obj.removeTower();
        selectedParking.busy = false;
        selectedParking.allow = true;
        selectedParking.obj = null;
        selectedParking.type = 0;
        selectedParking.icon_panel_number.visible = false;
        selectedParking.textNumberType.visible = false;
        this.checkNextCar();
        MainGame.Sfx.play("sound", "remove_car")
    }

    addHpBar() {
        var obj1 = this.add.image(0, 0, "ss_main", "hp_bar1_0000");
        var obj2 = this.add.image(0, 0, "ss_main", "hp_bar2_0000");
        this.layerHpBars.add(obj1);
        this.layerHpBars.add(obj2);
        var bar_crop = new Phaser.Geom.Rectangle(0, 0, 0, obj2.height);
        obj2.setCrop(bar_crop);
        return {bar1: obj1, bar2: obj2, bar_crop: bar_crop}
    }

    initWave() {
        this.gameGUI.showSystemMessage(MainGame.GAME_TEXT.wave_new + " " + this.num_wave);
        MainGame.Sfx.play("sound", "wave_start");
        this.wave_squard = [];
        this.wave_step = 0;
        this.wave_length = 0;
        this.pass_spawn = 0;
        this.enemies_added = 0;
        this.enemies_killed = 0;
        this.coins_earned = 0;
        this.isWaveEnd = false;
        this.isGameOver = false;
        switch (this.num_wave) {
            case 1:
                this.wave_squard = [1, 0, 1, 0, 1, 0, 1, 0, 1, 0, 1, 1, 0, 2, 1, 0, 1, 0, 1, 0, 1, 7, 0, 0, 7, 0, 0, 7, 7, 7, 0, 100];
                break;
            case 2:
                this.wave_squard = [15, 0, 6, 0, 6, 0, 6, 6, 15, 0, 5, 2, 5, 0, 5, 0, 11, 0, 11, 2, 0, 12, 0, 5, 5, 0, 1, 1, 5, 0, 1, 0, 5, 5, 0, 100];
                break;
            case 3:
                this.wave_squard = [15, 0, 12, 0, 5, 0, 12, 0, 15, 15, 0, 5, 5, 5, 15, 7, 0, 5, 5, 0, 7, 0, 12, 0, 5, 5, 0, 5, 0, 15, 15, 0, 12, 0, 5, 0, 12, 0, 100];
                break;
            case 4:
                this.wave_squard = [7, 12, 0, 7, 12, 0, 7, 12, 2, 0, 11, 11, 11, 11, 11, 11, 11, 11, 11, 0, 7, 12, 0, 7, 12, 0, 7, 12, 0, 100];
                break;
            case 5:
                this.wave_squard = [16, 1, 1, 0, 15, 4, 8, 15, 8, 0, 16, 1, 1, 0, 15, 4, 8, 15, 8, 0, 15, 1, 0, 1, 15, 4, 8, 15, 8, 0, 8, 6, 0, 0, 100, 0, 0, 0, 100];
                break;
            case 6:
                this.wave_squard = [13, 12, 0, 7, 13, 12, 0, 7, 1, 0, 13, 12, 0, 7, 13, 12, 0, 7, 1, 0, 13, 12, 0, 7, 13, 12, 0, 7, 1, 0, 13, 12, 0, 7, 13, 12, 0, 7, 1, 0, 13, 12, 13, 0, 100];
                break;
            case 7:
                this.wave_squard = [13, 0, 13, 0, 13, 0, 13, 0, 15, 0, 14, 0, 14, 0, 14, 0, 14, 0, 16, 0, 14, 0, 14, 0, 14, 0, 14, 0, 16, 0, 13, 0, 13, 0, 13, 0, 13, 0, 15, 0, 16, 0, 15, 0, 1, 100, 0, 100];
                break;
            case 8:
                this.wave_squard = [16, 7, 7, 5, 12, 16, 7, 7, 6, 6, 16, 7, 7, 5, 12, 16, 7, 7, 6, 6, 12, 12, 12, 0, 12, 12, 12, 0, 8, 8, 0, 12, 12, 12, 0, 12, 12, 12, 0, 9, 10, 9, 100, 1, 0, 100];
                break;
            case 9:
                this.wave_squard = [15, 0, 12, 3, 12, 6, 12, 6, 15, 16, 15, 0, 12, 3, 12, 6, 12, 6, 15, 16, 15, 0, 12, 3, 12, 6, 12, 6, 15, 16, 16, 5, 12, 0, 5, 5, 5, 5, 0, 15, 5, 16, 12, 12, 12, 0, 100, 0, 16, 12, 12, 12, 5, 100];
                break;
            case 10:
                this.wave_squard = [15, 3, 12, 3, 12, 6, 12, 6, 15, 16, 15, 3, 12, 3, 12, 6, 12, 6, 15, 16, 16, 5, 12, 3, 12, 5, 12, 5, 3, 15, 12, 5, 12, 0, 5, 6, 5, 5, 16, 12, 12, 0, 0, 100, 0, 6, 5, 5, 16, 12, 12, 0, 0, 100, 0, 6, 5, 5, 16, 12, 12, 0, 0, 100];
                break;
            default:
                this.wave_squard = this.getGeneratedSquad(this.num_wave);
                break
        }
        this.wave_length = this.wave_squard.length;
        this.tickWave = 0;
        this.countEnemies = this.getCountEnemies();
        this.isFinishGame = false;
        this.gameGUI.updateWavePanel(this.num_wave);
        if (MainGame.isDebug) {
            this.debugShowWaveInfo();
            this.debugCheckSave()
        }
    }

    getCountEnemies() {
        var countMobs = 0;
        var countBosses = 0;
        var arCountMobs = [1, 2, 3, 2, 3, 3, 3, 4, 5, 5, 4, 5, 5, 5, 5, 9];
        for (var i = 0; i < this.wave_squard.length; i++) {
            if (this.wave_squard[i] == 100) countBosses++;
            if (this.wave_squard[i] > 0 && this.wave_squard[i] < 20) {
                countMobs += arCountMobs[this.wave_squard[i] - 1]
            }
        }
        return countMobs + countBosses
    }

    getGeneratedSquad(vNumWave) {
        var times = [1, 1, 1, 1, 1, 1, 2, 3, 2, 3, 3, 3, 1, 2, 2, 3, 3];
        var arCountMobs = [1, 2, 3, 2, 3, 3, 3, 4, 5, 5, 4, 5, 5, 5, 5, 9];
        var squad = [];
        var countLines = vNumWave - 3;
        var bossLines = countLines - 3;
        var mobsLine = [];
        var presets = [[16, 10, 10, 5, 12], [16, 10, 10, 6, 6], [12, 12, 12, 6, 6], [15, 0, 12, 3, 12], [6, 12, 6, 15, 16], [15, 3, 12, 3, 12], [6, 12, 6, 15, 16], [5, 6, 5, 5, 16]];
        var countPresets = presets.length - 1;
        var r1 = 0;
        var r2 = 0;
        for (var i = 0; i < countLines; i++) {
            mobsLine = [];
            if (i < bossLines) {
                r1 = MyMath.getRandomInt(0, countPresets);
                r2 = MyMath.getRandomInt(0, countPresets);
                mobsLine = mobsLine.concat(presets[r1]);
                mobsLine = mobsLine.concat(presets[r2])
            } else {
                r1 = MyMath.getRandomInt(0, countPresets);
                mobsLine = mobsLine.concat(presets[r1]);
                mobsLine = mobsLine.concat([0, 0, 100, 0])
            }
            squad = squad.concat(mobsLine)
        }
        return squad
    }

    debugShowWaveInfo() {
        var countMobs = 0;
        var countBosses = 0;
        var timeWave = 0;
        var times = [1, 1, 1, 1, 1, 1, 2, 3, 2, 3, 3, 3, 1, 2, 2, 3, 3];
        var arCountMobs = [1, 2, 3, 2, 3, 3, 3, 4, 5, 5, 4, 5, 5, 5, 5, 9];
        for (var i = 0; i < this.wave_squard.length; i++) {
            if (this.wave_squard[i] == 100) {
                timeWave += times[1] * .92
            } else {
                timeWave += times[this.wave_squard[i]] * .92
            }
            if (this.wave_squard[i] == 100) countBosses++;
            if (this.wave_squard[i] > 0 && this.wave_squard[i] < 20) {
                countMobs += arCountMobs[this.wave_squard[i] - 1]
            }
        }
        var coins1 = this.getCountMobCoins(this.num_wave) * countMobs;
        var coins2 = this.getCountBossCoins(this.num_wave) * countBosses;
        var total_coins = coins1 + coins2;
        var hpMobs = this.getCountMobHp(this.num_wave);
        var hpBoss = this.getCountBossHp(this.num_wave);
        var timeWaveS = Math.round((timeWave + Number.EPSILON) * 100) / 100;
        var timeWaveM = Math.round((timeWave / 60 + Number.EPSILON) * 100) * .01;
        console.log("====================");
        console.log("numWave", this.num_wave);
        console.log("timeWave: ", timeWaveS + "s", "(~" + timeWaveM + "m)");
        console.log("countMobs", countMobs);
        console.log("countBosses", countBosses);
        console.log("coinsMob", "" + MainGame.convertNumberFormat(coins1));
        console.log("coinsBoss", "" + MainGame.convertNumberFormat(coins2));
        console.log("coinsTotal", "" + MainGame.convertNumberFormat(total_coins));
        console.log("hpMobs", "" + MainGame.convertNumberFormat(hpMobs));
        console.log("hpBoss", "" + MainGame.convertNumberFormat(hpBoss));
        console.log("====================")
    }

    updateWave() {
        this.tickWave += this.WAVE_INC;
        if (this.tickWave >= 55) {
            this.spawnWave();
            this.tickWave = 0
        }
    }

    nextWave() {
        this.time.delayedCall(500, this.initWave, [], this)
    }

    resetGame() {
        this.isGameOver = false;
        this.wall_hp = this.wall_hp_max;
        this.updateWallHp(0);
        this.wall.setFrame("wall_0000");
        this.wall.setOrigin(.5);
        this.isWallTweening = false;
        this.wall.setTint(16777215)
    }

    showWallBoom() {
        var posX = 0;
        var posY = 0;
        var arPosY = [];
        for (var i = 0; i < 6; i++) {
            arPosY.push(50 + i * 70)
        }
        MyMath.shuffleArr(arPosY);
        for (var i = 0; i < 6; i++) {
            posX = 650 + MyMath.getRandomInt(-5, 5) * 2;
            posY = arPosY[i] + MyMath.getRandomInt(-5, 5) * 2;
            this.time.delayedCall(50 + 50 * i, this.showEffect, [posX, posY, "effect_boom"], this)
        }
        this.time.delayedCall(350, this.showWallBroken, [], this)
    }

    showWallBroken() {
        this.wall.setFrame("wall_broken_0000");
        this.wall.setOrigin(.72, .5)
    }

    defeatWave() {
        this.isGameOver = true;
        this.enemies_added = 0;
        this.enemies_killed = 0;
        this.showWallBoom();
        MainGame.Sfx.play("sound", "exposion");
        MainGame.api_google("LevelDefeat", this.num_wave);
        this.time.delayedCall(500, this.playSfxAfterExposion, [], this);
        this.time.delayedCall(1e3, this.detroyEnemies, [], this);
        this.time.delayedCall(1500, this.showPopupDefeat, [], this)
    }

    playSfxAfterExposion() {
        MainGame.Sfx.play("sound", "after_exposion")
    }

    checkWallUpgrade() {
        var price = this.getPriceWall();
        price = Math.round(price * this.factorDiscount);
        this.gameGUI.showIconAdvWall(this.amount_coins >= price)
    }

    addCoins(vValue) {
        var coins = vValue;
        coins = Math.floor(coins * this.factorEarning);
        if (this.isBoostTimer) coins *= this.value_boost;
        this.amount_coins += coins;
        this.coins_earned += coins;
        var text_coins_warm = MainGame.convertNumberFormat(this.amount_coins);
        this.gameGUI.updateCoins(text_coins_warm);
        this.gameGUI.updateShop(text_coins_warm);
        this.checkWallUpgrade()
    }

    enemyKilled(vType) {
        this.enemies_killed++;
        var coins = this.getCountMobCoins(this.num_wave);
        if (vType == 100) coins = this.getCountBossCoins(this.num_wave);
        this.addCoins(coins);
        if (!this.isGameOver && !this.isFinishGame && this.enemies_killed >= this.countEnemies) {
            if (MainGame.isDebug) this.debugCheckSave();
            MainGame.api_google("LevelWin", this.num_wave);
            this.num_wave++;
            this.saveGameValues();
            this.time.delayedCall(900, this.showPopupWin, [], this);
            this.isFinishGame = true;
            if (MainGame.isAPI) {
                MainGame.crazysdk.happytime()
            }
        }
    }

    showPopupWin() {
        MainGame.Sfx.play("sound", "wave_finish");
        this.gameGUI.showFinishWindow(true)
    }

    showPopupDefeat() {
        MainGame.Sfx.play("sound", "wave_defeat");
        this.gameGUI.showFinishWindow(false)
    }

    clickWinX2Button() {
        MainGame.isApiGameplayStop = true;
        MainGame.clickReward("coins_wave_x2");
        this.gameGUI.buttonPanelTV.setEnable(false);
        MainGame.api_google("ClickCoinsX2")
    }

    closeFinishWindow(vIsSkip) {
        this.setGameLogicPause(false);
        this.gameGUI.enableMainButtons();
        this.nextWave();
        if (!vIsSkip) MainGame.api_google("ClickNoThanks")
    }

    clickContinueDefeat() {
        if (MainGame.isAPI && MainGame.isApiReady) {
            MainGame.showAds()
        } else {
            this.setGameLogicPause(false)
        }
        this.gameGUI.enableMainButtons();
        this.resetGame();
        this.time.delayedCall(500, this.initWave, [], this)
    }

    debugCheckSave() {
        if (MainGame.isDebug && !MainGame.isNoSave && MainGame.NUM_WAVE_SAVE < this.num_wave) {
            console.log("[STOP SAVE]");
            MainGame.isNoSave = true
        }
    }

    spawnWave() {
        if (this.wave_step == this.wave_length) {
            this.isWaveEnd = true
        } else {
            this.pass_spawn--;
            if (this.pass_spawn <= 0) {
                this.addSquad(this.wave_squard[this.wave_step++])
            }
        }
    }

    detroyEnemies() {
        this.enemies.releaseAll()
    }

    addSquad(vType) {
        var posX = -60;
        var posY = 35;
        var startY = 25;
        var lineY = 35;
        var ofsX = 55;
        var ofsY = 55;
        var arrY = [3, 4, 5, 6, 7, 8, 9, 10];
        if (vType == 0) {
            this.pass_spawn = 2;
            return
        }
        if (vType >= 100) {
            posY = startY + MyMath.getRandomInt(3, 10) * lineY;
            this.addEnemy(posX, posY, vType);
            this.pass_spawn = 1;
            return
        }
        switch (vType) {
            case 1:
                posY = startY + MyMath.getRandomInt(3, 10) * lineY;
                this.addEnemy(posX, posY);
                this.pass_spawn = 1;
                break;
            case 2:
                MyMath.shuffleArr(arrY);
                posY = startY + arrY[0] * lineY - ofsY;
                this.addEnemy(posX, posY);
                posY = startY + arrY[1] * lineY - ofsY;
                this.addEnemy(posX, posY);
                this.pass_spawn = 1;
                break;
            case 3:
                MyMath.shuffleArr(arrY);
                posY = startY + arrY[0] * lineY - ofsY;
                this.addEnemy(posX, posY);
                posY = startY + arrY[1] * lineY - ofsY;
                this.addEnemy(posX, posY);
                posY = startY + arrY[2] * lineY - ofsY;
                this.addEnemy(posX, posY);
                this.pass_spawn = 1;
                break;
            case 4:
                posY = startY + MyMath.getRandomInt(3, 10) * lineY;
                this.addEnemy(posX, posY - ofsY);
                this.addEnemy(posX, posY + ofsY);
                this.pass_spawn = 1;
                break;
            case 5:
                posY = startY + MyMath.getRandomInt(3, 10) * lineY;
                this.addEnemy(posX, posY - ofsY);
                this.addEnemy(posX, posY);
                this.addEnemy(posX, posY + ofsY);
                this.pass_spawn = 1;
                break;
            case 6:
                posY = startY + MyMath.getRandomInt(3, 10) * lineY;
                this.addEnemy(posX - ofsX, posY - ofsY);
                this.addEnemy(posX, posY);
                this.addEnemy(posX - ofsX, posY + ofsY);
                this.pass_spawn = 2;
                break;
            case 7:
                posY = startY + MyMath.getRandomInt(3, 10) * lineY;
                this.addEnemy(posX, posY);
                this.addEnemy(posX - ofsX * 1, posY);
                this.addEnemy(posX - ofsX * 2, posY);
                this.pass_spawn = 3;
                break;
            case 8:
                posY = startY + MyMath.getRandomInt(3, 10) * lineY;
                this.addEnemy(posX - ofsX, posY - ofsY);
                this.addEnemy(posX, posY);
                this.addEnemy(posX - ofsX, posY);
                this.addEnemy(posX - ofsX, posY + ofsY);
                this.pass_spawn = 2;
                break;
            case 9:
                posY = startY + MyMath.getRandomInt(3, 10) * lineY;
                this.addEnemy(posX, posY - ofsY);
                this.addEnemy(posX, posY + ofsY);
                this.addEnemy(posX - ofsX, posY);
                this.addEnemy(posX - ofsX * 2, posY - ofsY);
                this.addEnemy(posX - ofsX * 2, posY + ofsY);
                this.pass_spawn = 3;
                break;
            case 10:
                posY = startY + MyMath.getRandomInt(3, 10) * lineY;
                this.addEnemy(posX - ofsX, posY - ofsY);
                this.addEnemy(posX, posY);
                this.addEnemy(posX - ofsX, posY);
                this.addEnemy(posX - ofsX, posY + ofsY);
                this.addEnemy(posX - ofsX * 2, posY);
                this.pass_spawn = 3;
                break;
            case 11:
                posY = startY + MyMath.getRandomInt(3, 10) * lineY;
                this.addEnemy(posX - ofsX, posY - ofsY);
                this.addEnemy(posX, posY);
                this.addEnemy(posX - ofsX, posY + ofsY);
                this.addEnemy(posX - ofsX * 2, posY);
                this.pass_spawn = 3;
                break;
            case 12:
                posY = startY + MyMath.getRandomInt(5, 9) * lineY;
                this.addEnemy(posX, posY - ofsY * 2);
                this.addEnemy(posX, posY - ofsY * 1);
                this.addEnemy(posX, posY);
                this.addEnemy(posX, posY + ofsY * 1);
                this.addEnemy(posX, posY + ofsY * 2);
                this.pass_spawn = 1;
                break;
            case 13:
                posY = startY + MyMath.getRandomInt(5, 9) * lineY;
                this.addEnemy(posX - ofsX, posY - ofsY * 2);
                this.addEnemy(posX, posY - ofsY * 1);
                this.addEnemy(posX - ofsX, posY);
                this.addEnemy(posX, posY + ofsY * 1);
                this.addEnemy(posX - ofsX, posY + ofsY * 2);
                this.pass_spawn = 2;
                break;
            case 14:
                posY = startY + MyMath.getRandomInt(5, 9) * lineY;
                this.addEnemy(posX, posY - ofsY * 2);
                this.addEnemy(posX - ofsX, posY - ofsY);
                this.addEnemy(posX, posY);
                this.addEnemy(posX - ofsX, posY + ofsY);
                this.addEnemy(posX, posY + ofsY * 2);
                this.pass_spawn = 2;
                break;
            case 15:
                posY = startY + MyMath.getRandomInt(5, 9) * lineY;
                this.addEnemy(posX - ofsX * 2, posY - ofsY * 2);
                this.addEnemy(posX - ofsX, posY - ofsY);
                this.addEnemy(posX, posY);
                this.addEnemy(posX - ofsX, posY + ofsY);
                this.addEnemy(posX - ofsX * 2, posY + ofsY * 2);
                this.pass_spawn = 3;
                break;
            case 16:
                posY = startY + MyMath.getRandomInt(5, 9) * lineY;
                this.addEnemy(posX, posY);
                this.addEnemy(posX - ofsX, posY - ofsY);
                this.addEnemy(posX - ofsX, posY);
                this.addEnemy(posX - ofsX, posY + ofsY);
                this.addEnemy(posX - ofsX * 2, posY);
                this.addEnemy(posX - ofsX * 2, posY - ofsY * 2);
                this.addEnemy(posX - ofsX * 2, posY - ofsY * 1);
                this.addEnemy(posX - ofsX * 2, posY + ofsY * 1);
                this.addEnemy(posX - ofsX * 2, posY + ofsY * 2);
                this.pass_spawn = 3;
                break;
            default:
                this.addEnemy();
                break
        }
    }

    getSkinData() {
        var type_skin = 0;
        var type_warrior = 0;
        var type_helmet = 0;
        var type_weapon = 1;
        var type_weapon2 = 0;
        var type_shield = 0;
        switch (this.num_wave) {
            case 1:
            case 2:
            case 3:
                type_skin = MyMath.getRandomInt(0, 2);
                type_weapon = MyMath.getRandomInt(1, 8);
                type_helmet = MyMath.getRandomInt(0, 1);
                break;
            case 4:
            case 5:
            case 6:
                type_skin = MyMath.getRandomInt(0, 4);
                type_warrior = MyMath.getRandomInt(0, 1);
                type_helmet = MyMath.getRandomInt(0, 2);
                type_weapon = MyMath.getRandomInt(1, 8);
                type_shield = MyMath.getRandomInt(1, 5);
                break;
            case 7:
            case 8:
            case 9:
                type_skin = MyMath.getRandomInt(0, 5);
                if (MyMath.getRandomBool()) type_skin = MyMath.getRandomInt(14, 16);
                type_warrior = MyMath.getRandomInt(0, 2);
                type_helmet = MyMath.getRandomInt(0, 3);
                type_weapon = MyMath.getRandomInt(1, 8);
                type_weapon2 = MyMath.getRandomInt(0, 3);
                type_shield = MyMath.getRandomInt(1, 7);
                break;
            case 10:
            case 11:
            case 12:
                type_skin = MyMath.getRandomInt(0, 6);
                if (MyMath.getRandomBool()) type_skin = MyMath.getRandomInt(14, 16);
                type_warrior = MyMath.getRandomInt(0, 2);
                type_helmet = MyMath.getRandomInt(0, 6);
                type_weapon = MyMath.getRandomInt(1, 14);
                type_weapon2 = MyMath.getRandomInt(0, 4);
                type_shield = MyMath.getRandomInt(1, 10);
                break;
            case 13:
            case 14:
            case 15:
                type_skin = MyMath.getRandomInt(0, 16);
                type_warrior = MyMath.getRandomInt(0, 2);
                type_helmet = MyMath.getRandomInt(0, 9);
                type_weapon = MyMath.getRandomInt(1, 19);
                type_weapon2 = MyMath.getRandomInt(0, 6);
                type_shield = MyMath.getRandomInt(1, 15);
                break;
            default:
                type_skin = MyMath.getRandomInt(0, 13);
                type_warrior = MyMath.getRandomInt(1, 2);
                type_helmet = MyMath.getRandomInt(5, 12);
                type_weapon = MyMath.getRandomInt(12, 25);
                type_weapon2 = MyMath.getRandomInt(0, 8);
                type_shield = MyMath.getRandomInt(9, 19);
                break
        }
        if (this.num_wave >= 20) {
            type_warrior = MyMath.getRandomInt(1, 2);
            type_helmet = MyMath.getRandomInt(8, 12);
            type_shield = MyMath.getRandomInt(16, 19);
            type_weapon = MyMath.getRandomInt(18, 25);
            type_weapon2 = MyMath.getRandomInt(6, 8)
        }
        if (type_skin >= 7) type_helmet = 0;
        if (type_warrior == 2) type_weapon = this.TYPE_WEAPON2[type_weapon2];
        return {
            type_skin: this.TYPE_SKINS[type_skin],
            type_warrior: type_warrior,
            type_helmet: type_helmet,
            type_weapon: type_weapon,
            type_shield: type_shield
        }
    }

    addEnemy(vX, vY, vType) {
        var bot = this.enemies.getFree();
        if (bot) {
            var posX = vX || -60;
            var posY = vY || 35 + MyMath.getRandomInt(1, 10) * 35;
            var skin_data = this.getSkinData();
            bot.setNewBot(this.enemies_added, posX, posY, skin_data, vType, this.num_wave);
            this.enemies_added++
        }
    }

    getEnemy(x, y, distance) {
        var enemyUnits = this.enemies.getChildren();
        var enemy = null;
        var closestEnemy = null;
        var distClosest = 0;
        var dist = 0;
        for (var i = 0; i < enemyUnits.length; i++) {
            enemy = enemyUnits[i];
            if (enemy.active && enemy.x > this.START_ENEMY_X && !enemy.isUnderAttack) {
                if (enemy.x > distClosest) {
                    closestEnemy = enemy;
                    distClosest = enemy.x
                }
            }
        }
        if (closestEnemy) return closestEnemy;
        return false
    }

    initPoolBullets() {
        this.bullets = this.add.group({classType: Bullet, maxSize: this.MAX_POOL_BULLETS, runChildUpdate: true})
    }

    initPoolEffects() {
        this.effects = this.add.group({classType: Effect, maxSize: this.MAX_POOL_EFFECTS})
    }

    initPoolEnemies() {
        this.enemies = new Pool(this, this.layerSpine, this.MAX_POOL_ENEMIES)
    }

    addDmgText() {
        var txt = this.add.bitmapText(100, 100, MainGame.fontName, "123");
        txt.setFontSize(22);
        txt.setOrigin(.5);
        txt.setDropShadow(-2, 2, 0, .6);
        txt.visible = false;
        this.layerDmgText.add(txt);
        return txt
    }

    showDmgText(vX, vY, vObjText, vValue) {
        var obj = vObjText;
        obj.visible = true;
        obj.x = vX;
        obj.y = vY - 40;
        var text_coins_warm = MainGame.convertNumberFormat(vValue);
        obj.setText(text_coins_warm);
        this.tweens.killTweensOf(obj);
        obj.setAlpha(.2);
        obj.setScale(.6);
        this.tweens.add({targets: obj, alpha: 1, ease: "Linear", duration: 300});
        this.tweens.add({targets: obj, scaleX: 1, scaleY: 1, ease: "Linear", duration: 300});
        this.tweens.add({
            targets: obj, alpha: 0, ease: "Linear", delay: 400, duration: 300, onComplete: function () {
                obj.visible = false
            }
        });
        this.tweens.add({targets: obj, y: obj.y - 30, ease: "Linear", delay: 200, duration: 500})
    }

    showEffect(x, y, name, hideOnComplete) {
        hideOnComplete = hideOnComplete || true;
        var effect = this.effects.get();
        if (effect) {
            effect.show(x, y, name, hideOnComplete)
        }
        return effect
    }

    addBullet(target, damage, x, y, angle, color) {
        var bullet = this.bullets.get();
        if (bullet) {
            bullet.fire(target, damage, x, y, angle, color)
        }
    }

    getIntercept(src, dst, v) {
        const tx = dst.x - src.x;
        const ty = dst.y - src.y;
        const tvx = dst.vx;
        const tvy = dst.vy;
        const a = tvx * tvx + tvy * tvy - v * v;
        const b = 2 * (tvx * tx + tvy * ty);
        const c = tx * tx + ty * ty;
        const ts = MyMath.quad(a, b, c);
        let sol = null;
        if (ts) {
            const t0 = ts[0];
            const t1 = ts[1];
            let t = Math.min(t0, t1);
            if (t < 0) t = Math.max(t0, t1);
            if (t > 0) {
                sol = {x: dst.x + dst.vx * t, y: dst.y + dst.vy * t}
            }
        }
        return sol
    }

    updateTower(time, delta, vParking) {
        if (vParking.type <= 0 || !vParking.busy || !vParking.battle) return;
        var posT = vParking.obj.getViewPosition();
        var enemy = vParking.obj.getTarget();
        vParking.obj.updateShoot();
        if (enemy) {
            var angle = Phaser.Math.Angle.Between(posT.x, posT.y, enemy.x, enemy.y);
            vParking.obj.setViewAngleFromRad(angle);
            vParking.obj.checkTarget();
            if (vParking.obj.checkShoot()) {
                const sol = this.getIntercept({x: posT.x, y: posT.y}, {
                    x: enemy.x,
                    y: enemy.y,
                    vx: enemy.speed,
                    vy: 0
                }, this.SPEED_BULLET);
                if (sol) {
                    angle = Phaser.Math.Angle.Between(posT.x, posT.y, sol.x, sol.y);
                    vParking.obj.makeShoot(angle)
                }
            }
        } else {
            enemy = this.getEnemy(posT.x, posT.y, 500);
            if (enemy) {
                vParking.obj.setTarget(enemy)
            }
        }
    }

    initWall() {
        var wall = this.add.image(650, 228, "ss_main", "wall_0000");
        var icon_panel_number = this.add.image(650, 432, "ss_main", "panel_number_0000");
        icon_panel_number.setScale(1.1);
        this.layerWall.add(wall);
        this.layerWall.add(icon_panel_number);
        var text_wall_lvl = this.add.container();
        text_wall_lvl.x = icon_panel_number.x - 3;
        text_wall_lvl.y = icon_panel_number.y - 4;
        text_wall_lvl.setDepth(this.DEPTH_text_number);
        this.setSpriteText(text_wall_lvl, this.level_wall);
        this.text_wall_lvl = text_wall_lvl;
        this.wall = wall;
        this.isWallTweening = false;
        this.tintTickWall = 0
    }

    initFog() {
        var obj = this.add.image(-70, 320, "ss_main", "fog_0000");
        obj.setOrigin(0, .5);
        this.layerEffects.add(obj)
    }

    initEffectMerge() {
        var effect = this.add.sprite(100, 100, "ss_main");
        effect.play("effect_connect3");
        effect.visible = false;
        effect.setScale(1.25);
        this.merge_effect = effect;
        this.layerEffects.add(effect)
    }

    showMergeEffect(vX, vY) {
        this.merge_effect.visible = true;
        this.merge_effect.x = vX + 5;
        this.merge_effect.y = vY
    }

    hideMergeEffect() {
        this.merge_effect.visible = false
    }

    updateWallHp(damage) {
        if (this.isGameOver) return;
        this.wall_hp -= damage;
        if (this.wall_hp < 0) {
            this.wall_hp = 0;
            this.defeatWave()
        }
        this.gameGUI.updateWallHp(this.wall_hp / this.wall_hp_max, this.wall_hp, this.wall_hp_max)
    }

    showWallJelly() {
        if (this.isWallTweening) return;
        this.goTweenWall(this.wall, .04)
    }

    finishTweenWall(tween) {
        this.isWallTweening = false
    }

    updateRedTintWall() {
        if (this.tintTickWall == 0) return;
        this.tintTickWall++;
        switch (this.tintTickWall) {
            case 3:
                this.wall.setTint(16750230);
                break;
            case 6:
                this.wall.setTint(16737380);
                break;
            case 9:
                this.wall.setTint(16750230);
                break;
            case 12:
                this.wall.setTint(16763080);
                break;
            case 15:
                this.wall.setTint(16777215);
                this.tintTickWall = 0;
                break
        }
    }

    goTweenWall(object, strength, delay, initialScale) {
        strength = strength || .2;
        delay = delay || 0;
        initialScale = initialScale || {x: 1, y: 1};
        this.tweens.killTweensOf(object);
        object.x = 650;
        this.tweens.add({
            targets: object,
            x: object.x + 5,
            ease: Phaser.Math.Easing.Cubic.Out,
            duration: 50,
            yoyo: true,
            onComplete: this.finishTweenWall,
            onCompleteScope: this
        });
        this.isWallTweening = true;
        this.tintTickWall = 1
    }

    updateTowerSpeed(vParking, vIsDoubleSpeed) {
        if (vParking.type <= 0 || !vParking.busy || !vParking.battle) return;
        if (vParking.obj) vParking.obj.updateSpeed()
    }

    updateSpeedGame(vIsDoubleSpeed) {
        if (vIsDoubleSpeed) {
            this.SPEED_BULLET = 2 * Phaser.Math.GetSpeed(600, 1);
            this.SPEED_ENEMY = 2 * Phaser.Math.GetSpeed(70, 1);
            this.ATTACK_ENEMY = 2;
            this.ATTACK_TOWER = 2;
            this.WAVE_INC = 2
        } else {
            this.SPEED_BULLET = Phaser.Math.GetSpeed(600, 1);
            this.SPEED_ENEMY = Phaser.Math.GetSpeed(70, 1);
            this.ATTACK_ENEMY = 1;
            this.ATTACK_TOWER = 1;
            this.WAVE_INC = 1
        }
        this.bullets.children.iterate((function (obj) {
            obj.updateSpeed()
        }));
        this.enemies.updateSpeed(vIsDoubleSpeed);
        for (var i = 0; i < this.LIMIT_parking; i++) {
            this.updateTowerSpeed(this.arParking[i], vIsDoubleSpeed)
        }
    }

    getWheelPrize(slices, degrees, backDegrees) {
        return slices - 1 - Math.floor((degrees - backDegrees) / (360 / slices))
    }

    initWheelOptions() {
        this.wheelOptions = {
            slices: 8,
            slicePrizes: ["auto_merge", "bonus_coins", "reward_coin1", "reward_box8", "speed_x2", "reward_box6", "reward_coin2", "reward_box4"],
            sliceProbability: [.18, .12, .08, .1, .18, .12, .04, .18],
            rotationTime: 3e3,
            rotationTimeRange: {min: 3e3, max: 4500},
            wheelRounds: {min: 2, max: 6},
            backSpin: {min: 2, max: 8}
        }
    }

    checkProbability(probs) {
        var summ = 0;
        for (var v in probs) {
            summ += probs[v];
            console.log(summ)
        }
        return summ == 1
    }

    getTypeRewardBox() {
        var boxRandom = this.getTypeRandomBox();
        if (this.nextCarLevel < 6) {
            boxRandom = 1
        } else {
            boxRandom++
        }
        return boxRandom
    }

    getRewardCoinsHours(vCount) {
        var coins = vCount * 3600 * this.getCoinsPerSec();
        this.amount_coins += coins;
        var text_coins_warm = MainGame.convertNumberFormat(this.amount_coins);
        this.gameGUI.updateCoins(text_coins_warm)
    }

    getCoinsPerSec() {
        var parking = null;
        var total_dmg = 0;
        var value = 0;
        for (var i = 0; i < this.LIMIT_parking; i++) {
            parking = this.arParking[i];
            if (parking.busy && parking.battle) {
                total_dmg += this.getDamage(parking.type)
            }
        }
        value = Math.round(total_dmg * this.COINS_PER_DMG);
        return value
    }

    checkCoinsPerSec() {
        var new_profit = (this.amount_coins - this.last_coins) / 5;
        this.last_coins = this.amount_coins;
        console.log(new_profit + "/s")
    }

    getRewards(vReward) {
        switch (vReward) {
            case"reward_coin1":
                this.getRewardCoinsHours(1);
                break;
            case"reward_coin2":
                this.getRewardCoinsHours(2);
                break;
            case"auto_merge":
                this.activateBoostAutoMerge();
                this.gameGUI.hideOfferTV();
                break;
            case"speed_x2":
                this.activateBoostSpeed();
                break;
            case"bonus_coins":
                this.activateBoostCoins();
                break;
            case"reward_box4":
                var boxType = this.getTypeRewardBox();
                this.addBoxToBuffer(boxType);
                this.addBoxToBuffer(boxType);
                this.addBoxToBuffer(boxType);
                this.addBoxToBuffer(boxType);
                this.saveBoxBuffer();
                break;
            case"reward_box6":
                var boxType = this.getTypeRewardBox();
                this.addBoxToBuffer(boxType);
                this.addBoxToBuffer(boxType);
                this.addBoxToBuffer(boxType);
                this.addBoxToBuffer(boxType);
                this.addBoxToBuffer(boxType);
                this.addBoxToBuffer(boxType);
                this.saveBoxBuffer();
                break;
            case"reward_box8":
                var boxType = this.getTypeRewardBox();
                this.addBoxToBuffer(boxType);
                this.addBoxToBuffer(boxType);
                this.addBoxToBuffer(boxType);
                this.addBoxToBuffer(boxType);
                this.addBoxToBuffer(boxType);
                this.addBoxToBuffer(boxType);
                this.addBoxToBuffer(boxType);
                this.addBoxToBuffer(boxType);
                this.saveBoxBuffer();
                break;
            case"coinsX2":
                this.amount_coins += this.value_offline_earning;
                var text_coins_warm = MainGame.convertNumberFormat(this.amount_coins);
                this.gameGUI.updateCoins(text_coins_warm);
                this.gameGUI.updateShop(text_coins_warm);
                this.gameGUI.closeOfflineEarningWindow(true);
                break;
            case"coins_wave_x2":
                this.gameGUI.layerFinishWindow.destroy();
                this.amount_coins += this.coins_earned;
                var text_coins_warm = MainGame.convertNumberFormat(this.amount_coins);
                this.gameGUI.updateCoins(text_coins_warm);
                this.gameGUI.updateShop(text_coins_warm);
                this.closeFinishWindow(true);
                break;
            case"freeCar":
                this.ALLOW_ADS_CAR = false;
                this.gameGUI.iconAdvShop.visible = false;
                if (this.num_ads_car > 0) {
                    this.addBoxToBuffer(this.num_ads_car);
                    this.gameGUI.updateShopItem();
                    MainGame.Sfx.play("sound", "buy")
                }
                this.num_ads_car = 0;
                break;
            case"freeUpgrade":
                if (this.parking_upgrade_id != null && this.parking_upgrade_type > 0) {
                    var parking = this.arParking[this.parking_upgrade_id];
                    parking.type = this.parking_upgrade_type;
                    this.setSpriteText(parking.textNumberType, parking.type);
                    parking.obj.setSkinTower(parking.type);
                    this.showEffect(parking.obj.view.x, parking.obj.view.y, "effect_connect");
                    this.checkNextCar();
                    MainGame.Sfx.play("sound", "boost")
                }
                this.parking_upgrade_id = null;
                this.parking_upgrade_type = 0;
                this.gameGUI.closeUpgadeWindow();
                break;
            case"reward_wheel":
                var item = MyMath.weightedRandom(this.wheelOptions.sliceProbability);
                MainGame.reward_wheel = this.wheelOptions.slicePrizes[item];
                var rounds = Phaser.Math.Between(this.wheelOptions.wheelRounds.min, this.wheelOptions.wheelRounds.max);
                var backDegrees = Phaser.Math.Between(this.wheelOptions.backSpin.min, this.wheelOptions.backSpin.max);
                var degrees = 360 / this.wheelOptions.slices * item + Phaser.Math.Between(0, 29) + backDegrees;
                var duration1 = this.wheelOptions.rotationTime;
                var duration2 = 1500;
                MainGame.Sfx.play("sound", "fortune");
                this.gameGUI.tweenWheelFortune(rounds, degrees, backDegrees, duration1, duration2);
                this.gameGUI.buttonFortunaWheel.setEnable(false);
                if (this.freeTimeWheel > 0) {
                    this.freeTimeWheel--;
                    MainGame.freeTimeWheel = this.freeTimeWheel;
                    MainGame.saveSaves()
                }
                if (this.freeTimeWheel < MainGame.maxTimeWheel && this.countDownNextFree <= 0) {
                    this.countDownNextFree = this.TIME_NEXT_FREE
                }
                if (this.freeTimeWheel > 0) {
                    this.gameGUI.iconAdvFortune.visible = true
                } else {
                    this.gameGUI.iconAdvFortune.visible = false
                }
                this.gameGUI.updateFortunaWheelWindow(this.countDownNextFree);
                break
        }
    }

    clickBuyPrivilege1() {
        var itemInfo = this.arLevelCannonDmg[this.levelCannonDmg - 1];
        var priceUpdate = Math.round(itemInfo.price * this.factorDiscount);
        if (this.amount_coins < priceUpdate) {
            this.gameGUI.showSystemMessage(MainGame.GAME_TEXT.no_money);
            return
        }
        if (this.levelCannonDmg > 10) return;
        this.levelCannonDmg++;
        MainGame.levelCannonDmg = this.levelCannonDmg;
        this.amount_coins -= priceUpdate;
        var text_coins_warm = MainGame.convertNumberFormat(this.amount_coins);
        this.gameGUI.updateCoins(text_coins_warm);
        this.gameGUI.updateShop(text_coins_warm);
        this.updatePrivilegiesItems();
        this.updatePrivilegiesFactors();
        MainGame.saveSaves()
    }

    clickBuyPrivilege2() {
        var itemInfo = this.arLevelDiscount[this.levelDiscount - 1];
        var priceUpdate = Math.round(itemInfo.price * this.factorDiscount);
        if (this.amount_coins < priceUpdate) {
            this.gameGUI.showSystemMessage(MainGame.GAME_TEXT.no_money);
            return
        }
        if (this.levelDiscount > 10) return;
        this.levelDiscount++;
        MainGame.levelDiscount = this.levelDiscount;
        this.amount_coins -= priceUpdate;
        var text_coins_warm = MainGame.convertNumberFormat(this.amount_coins);
        this.gameGUI.updateCoins(text_coins_warm);
        this.gameGUI.updateShop(text_coins_warm);
        this.updatePrivilegiesItems();
        this.updatePrivilegiesFactors();
        MainGame.saveSaves()
    }

    clickBuyPrivilege3() {
        var itemInfo = this.arLevelEarning[this.levelEarning - 1];
        var priceUpdate = Math.round(itemInfo.price * this.factorDiscount);
        if (this.amount_coins < priceUpdate) {
            this.gameGUI.showSystemMessage(MainGame.GAME_TEXT.no_money);
            return
        }
        if (this.levelEarning > 10) return;
        this.levelEarning++;
        MainGame.levelEarning = this.levelEarning;
        this.amount_coins -= priceUpdate;
        var text_coins_warm = MainGame.convertNumberFormat(this.amount_coins);
        this.gameGUI.updateCoins(text_coins_warm);
        this.gameGUI.updateShop(text_coins_warm);
        this.updatePrivilegiesItems();
        this.updatePrivilegiesFactors();
        MainGame.saveSaves()
    }

    updatePrivilegiesItems() {
        var value_level = null;
        var text_value = null;
        var itemInfo = null;
        var priceItem = null;
        var number_warm = null;
        this.itemPrivilege1 = this.gameGUI.itemPrivilege1;
        this.itemPrivilege2 = this.gameGUI.itemPrivilege2;
        this.itemPrivilege3 = this.gameGUI.itemPrivilege3;
        value_level = this.levelCannonDmg;
        if (value_level < 10) {
            itemInfo = this.arLevelCannonDmg[value_level - 1];
            priceItem = Math.round(itemInfo.price * this.factorDiscount);
            number_warm = MainGame.convertNumberFormat(priceItem);
            this.itemPrivilege1.text_value.setText(MainGame.GAME_TEXT.next_level + ": " + itemInfo.value + "%")
        } else {
            value_level = 10;
            itemInfo = this.arLevelEarning[value_level - 2];
            number_warm = MainGame.GAME_TEXT.max.toUpperCase();
            this.itemPrivilege1.btn.setEnable(false);
            this.itemPrivilege1.text_value.setText(itemInfo.value + "%");
            this.itemPrivilege1.text_value.setOrigin(.5);
            this.itemPrivilege1.text_value.x = this.itemPrivilege1.btn.x
        }
        this.itemPrivilege1.btn_text.setText(number_warm);
        this.itemPrivilege1.text_num.setText(value_level);
        value_level = this.levelDiscount;
        if (value_level < 10) {
            itemInfo = this.arLevelDiscount[value_level - 1];
            priceItem = Math.round(itemInfo.price * this.factorDiscount);
            number_warm = MainGame.convertNumberFormat(priceItem);
            this.itemPrivilege2.text_value.setText(MainGame.GAME_TEXT.next_level + ": " + itemInfo.value + "%")
        } else {
            value_level = 10;
            itemInfo = this.arLevelDiscount[value_level - 2];
            number_warm = MainGame.GAME_TEXT.max.toUpperCase();
            this.itemPrivilege2.btn.setEnable(false);
            this.itemPrivilege2.text_value.setText(itemInfo.value + "%");
            this.itemPrivilege2.text_value.setOrigin(.5);
            this.itemPrivilege2.text_value.x = this.itemPrivilege2.btn.x
        }
        this.itemPrivilege2.btn_text.setText(number_warm);
        this.itemPrivilege2.text_num.setText(value_level);
        value_level = this.levelEarning;
        if (value_level < 10) {
            itemInfo = this.arLevelEarning[value_level - 1];
            priceItem = Math.round(itemInfo.price * this.factorDiscount);
            number_warm = MainGame.convertNumberFormat(priceItem);
            this.itemPrivilege3.text_value.setText(MainGame.GAME_TEXT.next_level + ": " + itemInfo.value + "%")
        } else {
            value_level = 10;
            itemInfo = this.arLevelEarning[value_level - 2];
            number_warm = MainGame.GAME_TEXT.max.toUpperCase();
            this.itemPrivilege3.btn.setEnable(false);
            this.itemPrivilege3.text_value.setText(itemInfo.value + "%");
            this.itemPrivilege3.text_value.setOrigin(.5);
            this.itemPrivilege3.text_value.x = this.itemPrivilege3.btn.x
        }
        this.itemPrivilege3.btn_text.setText(number_warm);
        this.itemPrivilege3.text_num.setText(value_level);
        MainGame.updateTextWidth(this.itemPrivilege1.text_value, 200);
        MainGame.updateTextWidth(this.itemPrivilege2.text_value, 200);
        MainGame.updateTextWidth(this.itemPrivilege3.text_value, 200)
    }

    showAdsForFortunaWheel() {
        MainGame.isApiGameplayStop = true;
        MainGame.clickReward("reward_wheel");
        this.gameGUI.buttonFortunaWheel.setEnable(false)
    }

    showAdsForHelicopter(vTypeBonusDron) {
        MainGame.isApiGameplayStop = true;
        MainGame.clickReward(vTypeBonusDron);
        this.gameGUI.boostBtnAds.setEnable(false)
    }

    showAdsForFreeUpgrade() {
        MainGame.isApiGameplayStop = true;
        MainGame.clickReward("freeUpgrade");
        this.gameGUI.buttonFreeUpgrade.setEnable(false)
    }

    showAdsForCoinsX2() {
        MainGame.isApiGameplayStop = true;
        MainGame.clickReward("coinsX2");
        this.gameGUI.offlineEarningBtnAds.setEnable(false)
    }

    showAdsForCar() {
        MainGame.clickReward("freeCar")
    }

    clickOfferTV() {
        MainGame.isApiGameplayStop = true;
        MainGame.clickReward("auto_merge");
        this.gameGUI.buttonPanelTV.setEnable(false)
    }

    debugShowPrices() {
        var ar = [5e5, 25e6, 125e7, 625e8, 3125e9, 15625e10, 78125e11, 390625e12, 1953125e13, 9765625e14];
        for (var i = 0; i < ar.length; i++) {
            console.log(i + 1, MainGame.convertNumberFormat(ar[i]))
        }
    }

    testFeature() {
        this.addEnemy(300, 200)
    }

    testAllowParking() {
        for (var i = 0; i < this.arParking.length; i++) {
            if (!this.arParking[i].allow) console.log("[!!!]", i, this.arParking[i].allow)
        }
    }

    testAddBoxes() {
        this.addBoxToBuffer(2);
        this.addBoxToBuffer(2);
        this.addBoxToBuffer(2);
        this.addBoxToBuffer(2);
        this.saveBoxBuffer()
    }

    testLevelUp() {
        this.increaseLevel(this.exp_max)
    }

    testAddGun() {
        this.addBoxToBuffer(MainGame.debug_typeGun)
    }

    testAddSquad() {
        this.addSquad(MainGame.debug_typeSquad)
    }

    testCoinsHours(vCount) {
    }

    testCarAds() {
        if (!MainGame.isDebug) return;
        var typeCar = this.nextCarLevel - 4;
        this.addObject({lvl: typeCar, fromShop: true}, true)
    }
}

class GameGui extends Phaser.Scene {
    constructor() {
        super("GameGui")
    }

    create() {
        this.gameScreen = this.scene.get("Game");
        this.initResize();
        this.midX = this.GAME_WIDTH / 2;
        this.midY = this.GAME_HEIGHT / 2;
        this.layerGUI = this.add.container();
        this.DEPTH_GUI_TEXT = .2;
        this.DEPTH_GUI_IMAGE = .1;
        this.TIME_OPEN_POPUP = 200;
        this.isShowingFinish = false;
        this.isOnInputDown = false;
        this.isPopupOpened = false;
        this.buttonEnabled = true;
        this.typeDronBonus = "";
        this.scaleWindow1 = .8;
        this.scaleWindow2 = 1;
        this.posWindowY = 0;
        this.isTweeningWheel = false;
        this.isTweeningHat = false;
        this.offsetCameraX = 0;
        this.offsetCameraY = 0;
        this.isShopAdded = false;
        this.itemShop_WIDTH = 125;
        this.MAX_TYPES_CAR = this.gameScreen.MAX_TYPES_CAR;
        this.textFields = [];
        this.initMainButtons();
        this.initBasketTrash();
        this.initCoinsPanel();
        this.initWavePanel();
        this.initLevelBar();
        this.initIndcatorBoostAutoMerge();
        this.initIndcatorBoostSpeed();
        this.initIndcatorBoostCoins();
        this.initOfferTV();
        this.initSystemMessage();
        this.initHelicopter();
        this.initMergeAnimation();
        this.initSettingsWindow();
        this.initOfflineEarningWindow();
        this.initLevelUpWindow();
        this.initUpgradeWindow();
        this.initBoosterWindow();
        this.initFortunaWheelWindow();
        this.initRewardWindow();
        this.initShop();
        this.initInputScrolling();
        this.textFields.forEach(item => this.layerGUI.bringToTop(item))
    }

    initResize() {
        this.GAME_WIDTH = MainGame.Config.DEFAULT_WIDTH;
        this.GAME_HEIGHT = MainGame.Config.DEFAULT_HEIGHT;
        var gameSize = this.scale.gameSize;
        var width = gameSize.width;
        var height = gameSize.height;
        if (window.innerHeight < MainGame.Config.MAX_HEIGHT) {
            height = window.innerHeight
        }
        this.parent = new Phaser.Structs.Size(width, height);
        this.sizer = new Phaser.Structs.Size(this.GAME_WIDTH, this.GAME_HEIGHT, Phaser.Structs.Size.FIT, this.parent);
        this.parent.setSize(width, height);
        this.sizer.setSize(width, height);
        this.scale.on("resize", this.updateResize, this)
    }

    updateResize() {
        var gameSize = this.scale.gameSize;
        var width = gameSize.width;
        var height = gameSize.height;
        if (MainGame.isDesktop && window.innerHeight < MainGame.Config.MAX_HEIGHT) {
            height = window.innerHeight
        }
        this.parent.setSize(width, height);
        this.sizer.setSize(width, height);
        this.updateCamera()
    }

    updateCamera() {
        const camera = this.cameras.main;
        var deltaX = Math.ceil(this.parent.width - this.sizer.width) * .5;
        var deltaY = Math.ceil(this.parent.height - this.sizer.height) * .5;
        var sdvigY = 0;
        if (MainGame.isDesktop && window.innerHeight < MainGame.Config.MAX_HEIGHT) {
            deltaY = Math.ceil(window.innerHeight - this.sizer.height) * .5;
            sdvigY = this.scale.gameSize.height - window.innerHeight
        }
        const scaleX = this.sizer.width / this.GAME_WIDTH;
        const scaleY = this.sizer.height / this.GAME_HEIGHT;
        const zoom = Math.max(scaleX, scaleY);
        const offsetY = deltaY / zoom;
        const offsetX = deltaX / zoom;
        camera.setZoom(zoom);
        if (MainGame.isDesktop) {
            camera.centerOn(this.GAME_WIDTH / 2, this.GAME_HEIGHT / 2 + offsetY + sdvigY)
        } else {
            camera.centerOn(this.GAME_WIDTH / 2, this.GAME_HEIGHT / 2)
        }
    }

    initTutorial() {
        this.buttonUpgradeWall.visible = false;
        this.buttonShop.visible = false;
        this.icon_trash.visible = false;
        this.buttonFortuna.visible = false;
        this.buttonForge.visible = false;
        var effect = this.add.sprite(this.midX, this.midY, "ss_main");
        effect.play("effect_tutor");
        effect.visible = false;
        this.effect_tutor = effect;
        this.tutor_arm = this.add.image(this.midX, this.midY, "ss_main", "tutor_cursor_0000");
        this.tutor_arm.visible = false;
        this.effect_tutor.setDepth(this.gameScreen.DEPTH_cursorcar);
        this.tutor_arm.setDepth(this.gameScreen.DEPTH_cursorcar);
        this.time.delayedCall(500, this.tutorialScenario, [], this);
        this.textTutorial = this.add.bitmapText(this.midX - 100, this.midY - 30, MainGame.fontName, "");
        this.textTutorial.setDropShadow(2, 2, 0, 1);
        this.textTutorial.setMaxWidth(450);
        this.textTutorial.setCenterAlign();
        this.textTutorial.setFontSize(34);
        this.textTutorial.setOrigin(.5);
        this.textTutorial.lineSpacing = -8;
        this.textTutorial.visible = false;
        this.textTutorial.setDepth(this.gameScreen.DEPTH_text_field)
    }

    tutorialScenario() {
        this.gameScreen.tutorialStep++;
        if (this.gameScreen.tutorialStep == 1) {
            this.tutor_arm.visible = true;
            this.effect_tutor.visible = true;
            this.tutor_arm.x = 480;
            this.tutor_arm.y = 540 + 20;
            this.effect_tutor.y = this.tutor_arm.y - 25;
            this.effect_tutor.x = this.tutor_arm.x - 5;
            this.tweens.add({
                targets: this.tutor_arm,
                scaleX: .9,
                scaleY: .9,
                ease: "Linear",
                duration: 500,
                yoyo: true,
                repeat: -1
            })
        } else if (this.gameScreen.tutorialStep == 3) {
            this.buttonAddCar.disableInput();
            var obj = this.gameScreen.arParking[6];
            this.tutor_arm.x = obj.x + 5;
            this.tutor_arm.y = obj.y + 30;
            this.effect_tutor.x = this.tutor_arm.x - 5;
            this.effect_tutor.y = this.tutor_arm.y - 25;
            this.textTutorial.visible = true;
            this.textTutorial.setText(MainGame.GAME_TEXT.text_merge);
            this.tweens.killTweensOf(this.tutor_arm);
            this.tutor_arm.setScale(1);
            this.tweens.add({
                targets: this.tutor_arm,
                y: this.tutor_arm.y - 100,
                ease: "Linear",
                duration: 900,
                repeat: -1,
                hold: 400
            })
        } else if (this.gameScreen.tutorialStep == 4) {
            var obj = this.gameScreen.arParking[5];
            this.tutor_arm.x = obj.x + 5;
            this.tutor_arm.y = obj.y + 30;
            this.effect_tutor.x = this.tutor_arm.x - 5;
            this.effect_tutor.y = this.tutor_arm.y - 25;
            this.textTutorial.setText(MainGame.GAME_TEXT.text_drag);
            this.tweens.killTweensOf(this.tutor_arm);
            var posAnim = {x: this.tutor_arm.x - 130, y: this.tutor_arm.y + 90};
            this.tweens.add({
                targets: this.tutor_arm,
                x: posAnim.x,
                y: posAnim.y,
                ease: "Linear",
                duration: 900,
                repeat: -1,
                hold: 400
            })
        } else if (this.gameScreen.tutorialStep == 5) {
            this.textTutorial.setText("");
            this.textTutorial.visible = false;
            this.tweens.killTweensOf(this.tutor_arm);
            this.gameScreen.addObject({lvl: 1, skinBox: true, parkingId: 5}, true);
            var obj = this.gameScreen.arParking[5];
            this.tutor_arm.x = obj.x + 5;
            this.tutor_arm.y = obj.y + 30;
            this.effect_tutor.x = this.tutor_arm.x - 5;
            this.effect_tutor.y = this.tutor_arm.y - 25;
            this.tutor_arm.setScale(1);
            this.tweens.add({
                targets: this.tutor_arm,
                scaleX: .9,
                scaleY: .9,
                ease: "Linear",
                duration: 500,
                yoyo: true,
                repeat: -1
            })
        } else if (this.gameScreen.tutorialStep == 6) {
            this.tweens.killTweensOf(this.tutor_arm);
            this.tutor_arm.destroy();
            this.effect_tutor.destroy();
            this.textTutorial.destroy();
            this.gameScreen.isGoTutorial = false;
            this.buttonUpgradeWall.visible = true;
            this.buttonShop.visible = true;
            this.icon_trash.visible = true;
            this.buttonFortuna.visible = false;
            this.buttonForge.visible = true;
            this.buttonAddCar.enableInput();
            this.buttonUpgradeWall.enableInput();
            this.gameScreen.finishTutorial()
        }
    }

    onFonInputDown() {
        this.isOnInputDown = true
    }

    onPopupOpen() {
        this.isPopupOpened = true
    }

    onFonInputUp() {
        if (!this.isOnInputDown) return;
        if (!this.isPopupOpened) return;
        this.eventFonImputUp()
    }

    initMainButtons() {
        var posX = 970;
        var posY = 520;
        var buttonSettings = new Button(50, 640 - 50, "ss_main", "btn_settings_0000", this.openSettings, this);
        this.layerGUI.add(buttonSettings);
        this.buttonSettings = buttonSettings;
        var buttonFortuna = new Button(50, 120, "ss_main", "btn_fortune_0000", this.openFortunaWheelWindow, this);
        this.layerGUI.add(buttonFortuna);
        this.buttonFortuna = buttonFortuna;
        var buttonForge = new ButtonText(this.midX + 115, posY, "ss_main", "btn_forge_0000", this.clickForgeButton, this, "");
        this.layerGUI.add(buttonForge);
        this.buttonForge = buttonForge;
        var icon_forge1 = this.add.image(0, -2, "ss_main", "icon_forge1_0000");
        buttonForge.add(icon_forge1);
        this.icon_forge1 = icon_forge1;
        var icon_forge2 = this.add.image(0, -2, "ss_main", "icon_forge2_0000");
        buttonForge.add(icon_forge2);
        this.icon_forge2 = icon_forge2;
        this.forge_crop = new Phaser.Geom.Rectangle(0, 0, this.icon_forge2.height, 0);
        this.icon_forge2.setCrop(this.forge_crop);
        var buttonShop = new ButtonText(this.midX - 274, posY, "ss_main", "btn_shop_0000", this.clickShop, this, "");
        this.layerGUI.add(buttonShop);
        this.buttonShop = buttonShop;
        var buttonAddCar = new ButtonText(this.midX - 65, posY, "ss_main", "btn_big_0000", this.clickAddCarButton, this, "123.456");
        this.layerGUI.add(buttonAddCar);
        this.buttonAddCar = buttonAddCar;
        var icon_fast_car = this.add.image(-70, -4, "ss_main", "tower1_0000");
        icon_fast_car.setScale(this.gameScreen.getScaleCar(.8));
        buttonAddCar.add(icon_fast_car);
        var icon_fast_coin = this.add.image(0, 0, "ss_main", "money_0000");
        icon_fast_coin.setScale(.7);
        buttonAddCar.add(icon_fast_coin);
        buttonAddCar.bringToTop(buttonAddCar.text);
        buttonAddCar.text.setFontSize(26);
        var effect1 = this.add.sprite(buttonAddCar.x, buttonAddCar.y, "ss_main");
        effect1.play("flash_btn_big");
        effect1.visible = false;
        effect1.setScale(2);
        this.layerGUI.add(effect1);
        this.btn_fastbuy_effect = effect1;
        var effect2 = this.add.sprite(buttonForge.x, buttonForge.y, "ss_main");
        effect2.play("flash_btn_forge");
        effect2.visible = false;
        effect2.setScale(2);
        this.layerGUI.add(effect2);
        this.btn_forge_effect = effect2;
        this.buttonAddCar = buttonAddCar;
        this.icon_fast_car = icon_fast_car;
        this.icon_fast_coin = icon_fast_coin;
        var buttonUpgradeWall = new ButtonText(this.midX + 255, posY, "ss_main", "btn_wall_0000", this.clickUpgradeWallButton, this, "123.456");
        this.layerGUI.add(buttonUpgradeWall);
        this.buttonUpgradeWall = buttonUpgradeWall;
        var icon_wall_coin = this.add.image(0, 6, "ss_main", "money_0000");
        icon_wall_coin.setScale(.5);
        buttonUpgradeWall.add(icon_wall_coin);
        var hp_wall1 = this.add.image(0, 26, "ss_main", "hp_wall1_0000");
        var hp_wall2 = this.add.image(0, 26, "ss_main", "hp_wall2_0000");
        this.hp_wall2 = hp_wall2;
        this.hp_wall_crop = new Phaser.Geom.Rectangle(0, 0, 0, this.hp_wall2.height);
        this.hp_wall2.setCrop(this.hp_wall_crop);
        buttonUpgradeWall.add(hp_wall1);
        buttonUpgradeWall.add(hp_wall2);
        buttonUpgradeWall.bringToTop(buttonUpgradeWall.text);
        buttonUpgradeWall.text.setFontSize(20);
        this.text_wallhp = MainGame.addText(this, buttonUpgradeWall, 0, 26, "1000/1000", 14, true, false);
        this.buttonUpgradeWall = buttonUpgradeWall;
        this.icon_wall_coin = icon_wall_coin;
        var iconAdvShop = this.add.image(75, -35, "ss_main", "icon_adv_0000");
        buttonShop.add(iconAdvShop);
        this.iconAdvShop = iconAdvShop;
        iconAdvShop.angle = -4;
        this.tweens.add({
            targets: iconAdvShop,
            scaleX: 1.15,
            scaleY: 1.15,
            ease: "Linear",
            duration: 400,
            yoyo: true,
            repeat: -1
        });
        this.tweens.add({targets: iconAdvShop, angle: 4, ease: "Linear", duration: 400, yoyo: true, repeat: -1});
        this.iconAdvShop.visible = false;
        var iconAdvWall = this.add.image(75, -35, "ss_main", "icon_adv_0000");
        buttonUpgradeWall.add(iconAdvWall);
        this.iconAdvWall = iconAdvWall;
        iconAdvWall.angle = -4;
        this.tweens.add({
            targets: iconAdvWall,
            scaleX: 1.15,
            scaleY: 1.15,
            ease: "Linear",
            duration: 400,
            yoyo: true,
            repeat: -1
        });
        this.tweens.add({targets: iconAdvWall, angle: 4, ease: "Linear", duration: 400, yoyo: true, repeat: -1});
        this.iconAdvWall.visible = false;
        var iconAdvFortune = this.add.image(this.buttonFortuna.x + 21, this.buttonFortuna.y - 21, "ss_main", "icon_adv_0000");
        this.layerGUI.add(iconAdvFortune);
        this.iconAdvFortune = iconAdvFortune;
        iconAdvFortune.angle = -4;
        this.tweens.add({
            targets: iconAdvFortune,
            scaleX: 1.15,
            scaleY: 1.15,
            ease: "Linear",
            duration: 400,
            yoyo: true,
            repeat: -1
        });
        this.tweens.add({targets: iconAdvFortune, angle: 4, ease: "Linear", duration: 400, yoyo: true, repeat: -1});
        this.iconAdvFortune.visible = false
    }

    showBtnFastbuyEffect() {
        this.btn_fastbuy_effect.visible = true;
        this.btn_fastbuy_effect.play("flash_btn_big")
    }

    showBtnForgeEffect() {
        this.btn_forge_effect.visible = true;
        this.btn_forge_effect.play("flash_btn_forge")
    }

    clickForgeButton() {
        this.gameScreen.clickForge()
    }

    clickAddCarButton() {
        this.gameScreen.buyFastCar()
    }

    clickUpgradeWallButton() {
        this.gameScreen.clickBuyWall()
    }

    showIconAdvWall(vIsBool) {
        this.iconAdvWall.visible = vIsBool
    }

    showFinishWindow(vIsWin) {
        this.isShowingFinish = true;
        this.gameScreen.setGameLogicPause(true);
        this.layerFinishWindow = this.add.container();
        var fon_merge = this.add.image(0, 0, "ss_main", "bg_connect_0000");
        fon_merge.setScale(4);
        this.layerFinishWindow.add(fon_merge);
        this.layerFinishWindow.setDepth(this.gameScreen.DEPTH_layerLevelBar);
        this.layerFinishWindow.x = this.midX;
        this.layerFinishWindow.y = this.midY + this.posWindowY;
        this.layerFinishWindow.setScale(this.scaleWindow1);
        this.tweens.add({
            targets: this.layerFinishWindow,
            scaleX: this.scaleWindow2,
            scaleY: this.scaleWindow2,
            ease: Phaser.Math.Easing.Back.Out,
            duration: 400
        });
        this.disableMainButtons();
        var fon_window = this.add.image(0, 10, "ss_main", "bg_victory_0000");
        this.layerFinishWindow.add(fon_window);
        if (vIsWin) {
            var popup_victory = this.add.image(0, -170, "ss_main", "popup_victory_0000");
            var icon_coin = this.add.image(5, -80, "ss_main", "money_0000");
            icon_coin.setScale(.7);
            var icon_chick = this.add.image(5, -35, "ss_main", "icon_chick_0000");
            var buttonWinX2 = new ButtonText(0, 30, "ss_main", "btn_buy2_0000", this.clickWinX2Button, this, "+ 252K");
            MainGame.updateTextWidth(buttonWinX2.text, 200);
            buttonWinX2.text.x = -5;
            var icon_btn_coin = this.add.image(-85, -1, "ss_main", "money_0000");
            var icon_btn_reward = this.add.image(85, 2, "ss_main", "icon_reward_0000");
            buttonWinX2.add(icon_btn_coin);
            buttonWinX2.add(icon_btn_reward);
            this.buttonWinX2 = buttonWinX2;
            if (MainGame.isAPI) {
                if (!MainGame.isApiReady) this.buttonWinX2.setEnable(false)
            } else {
                if (!MainGame.isDebug) this.buttonWinX2.setEnable(false)
            }
            var buttonClose = new ButtonText(0, 102, "ss_main", "btn_buy2_0000", this.closeFinishWindow, this, MainGame.GAME_TEXT.no_thanks);
            buttonClose.text.setFontSize(24);
            MainGame.updateTextWidth(buttonClose.text, 320);
            buttonClose.back.alpha = .01;
            buttonClose.text.setTint(16777215);
            this.layerFinishWindow.add(popup_victory);
            this.layerFinishWindow.add(icon_coin);
            this.layerFinishWindow.add(icon_chick);
            this.layerFinishWindow.add(buttonWinX2);
            this.layerFinishWindow.add(buttonClose);
            var text_earned = MainGame.addText(this, this.layerFinishWindow, -120, -80, MainGame.GAME_TEXT.earned, 26, true);
            var text_killed = MainGame.addText(this, this.layerFinishWindow, -120, -35, MainGame.GAME_TEXT.killed, 26, true);
            text_earned.setOrigin(0, .5);
            text_killed.setOrigin(0, .5);
            var text_title_win = MainGame.addText(this, this.layerFinishWindow, 0, -136, MainGame.GAME_TEXT.wave_cleared, 30, true);
            var text_finish_coins = MainGame.addText(this, this.layerFinishWindow, icon_coin.x + 30, -80, "126K", 26, true);
            var text_finish_enemies = MainGame.addText(this, this.layerFinishWindow, icon_coin.x + 30, -35, "48", 26, true);
            text_finish_coins.setOrigin(0, .5);
            text_finish_enemies.setOrigin(0, .5);
            var text1_warm = MainGame.convertNumberFormat(this.gameScreen.coins_earned);
            var text2_warm = MainGame.convertNumberFormat(this.gameScreen.enemies_killed);
            var text3_warm = MainGame.convertNumberFormat(this.gameScreen.coins_earned);
            text_finish_coins.setText(text1_warm);
            text_finish_enemies.setText(text2_warm);
            buttonWinX2.text.setText("+ " + text3_warm);
            MainGame.updateTextWidth(buttonWinX2.text, 120)
        } else {
            this.layerFinishWindow.y = 300;
            var popup_defeat = this.add.image(0, -160, "ss_main", "popup_defeat_0000");
            this.layerFinishWindow.add(popup_defeat);
            var buttonContinue = new ButtonText(0, 30, "ss_main", "btn_buy_0000", this.clickContinueDefeat, this, MainGame.GAME_TEXT.try_again);
            MainGame.updateTextWidth(buttonContinue.text, 200);
            this.layerFinishWindow.add(buttonContinue);
            var text_title_lose = MainGame.addText(this, this.layerFinishWindow, 0, -80, MainGame.GAME_TEXT.defeat, 30, true)
        }
    }

    clickWinX2Button() {
        this.isShowingFinish = false;
        this.buttonWinX2.setEnable(false);
        this.gameScreen.clickWinX2Button()
    }

    closeFinishWindow() {
        this.isShowingFinish = false;
        this.layerFinishWindow.destroy();
        this.gameScreen.closeFinishWindow()
    }

    clickContinueDefeat() {
        this.isShowingFinish = false;
        this.layerFinishWindow.destroy();
        this.gameScreen.clickContinueDefeat()
    }

    initLevelBar() {
        this.layerPanelLevel = this.add.container();
        var pos = {x: 50, y: 40};
        var icon_level = this.add.image(pos.x, pos.y, "ss_main", "icon_level_0000");
        this.levelBarB = this.add.image(pos.x + 122, pos.y - 7, "ss_main", "exp1_0000");
        this.levelBarT = this.add.image(pos.x + 122, pos.y - 7, "ss_main", "exp2_0000");
        this.levelBarT_crop = new Phaser.Geom.Rectangle(0, 0, 0, this.levelBarT.height);
        this.levelBarT.setCrop(this.levelBarT_crop);
        this.textLevel = this.add.bitmapText(pos.x, pos.y + 4, MainGame.fontName, this.gameScreen.currentLevel, 22);
        this.textLevel.setOrigin(.5, .5);
        this.textLevel.setDropShadow(-2, 2, 0, 1);
        this.layerPanelLevel.add(icon_level);
        this.layerPanelLevel.add(this.levelBarB);
        this.layerPanelLevel.add(this.levelBarT);
        this.layerPanelLevel.add(this.textLevel);
        var text_level = MainGame.addText(this, this.layerPanelLevel, pos.x + 43, pos.y + 12, MainGame.GAME_TEXT.level, 18, true);
        text_level.setOrigin(0, .5);
        MainGame.updateTextWidth(text_level, 400);
        this.layerPanelLevel.setDepth(this.gameScreen.DEPTH_layerLevelBar)
    }

    updateLevel(progress, delay) {
        var originalWidth = this.levelBarT.width;
        var width = originalWidth * progress;
        delay = delay || 0;
        this.tweens.killTweensOf(this.levelBarT_crop);
        this.tweens.add({
            targets: this.levelBarT_crop,
            width: width,
            ease: Phaser.Math.Easing.Linear,
            duration: 200,
            delay: delay,
            onUpdate: () => {
                this.levelBarT.setCrop(this.levelBarT_crop)
            }
        })
    }

    initOfferTV() {
        var buttonPanelTV = new ButtonText(52, 200, "ss_main", "btn_free_boost_0000", this.clickOfferTV, this, "");
        this.layerGUI.add(buttonPanelTV);
        this.buttonPanelTV = buttonPanelTV;
        var icon_forge1 = this.add.image(-1, 2, "ss_main", "indicator_boost_0000");
        buttonPanelTV.add(icon_forge1);
        this.buttonPanelTV.setEnable(false);
        this.buttonPanelTV.visible = false;
        this.tweens.add({
            targets: buttonPanelTV,
            scaleX: .95,
            scaleY: .95,
            ease: "Linear",
            duration: 500,
            yoyo: true,
            repeat: -1
        })
    }

    showOfferTV() {
        if (this.buttonPanelTV.visible || this.gameScreen.isAutoMerge) return;
        this.buttonPanelTV.setEnable(true);
        if (MainGame.isAPI) {
            if (!MainGame.isApiReady) this.buttonPanelTV.setEnable(false)
        } else {
            if (!MainGame.isDebug) this.buttonPanelTV.setEnable(false)
        }
        this.buttonPanelTV.visible = true;
        this.buttonPanelTV.x = -100;
        this.tweens.add({targets: this.buttonPanelTV, x: 52, ease: Phaser.Math.Easing.Back.Out, duration: 500});
        this.time.delayedCall(1e4, this.hideOfferTV, [], this)
    }

    hideOfferTV() {
        if (!this.buttonPanelTV.visible) return;
        var buttonPanelTV = this.buttonPanelTV;
        this.buttonPanelTV.setEnable(false);
        this.buttonPanelTV.x = 52;
        this.tweens.add({
            targets: this.buttonPanelTV,
            x: -100,
            ease: Phaser.Math.Easing.Back.In,
            duration: 500,
            onComplete: function (tween) {
                buttonPanelTV.visible = false
            }
        });
        this.gameScreen.countDownOfferTV = -30
    }

    clickOfferTV() {
        this.gameScreen.clickOfferTV()
    }

    initIndcatorBoostAutoMerge() {
        var icon = this.add.image(0, 0, "ss_main", "indicator_boost_0000");
        var txt = MainGame.addText(this, this.layerGUI, 0, 52, "", 20);
        txt.setText(MainGame.secToHHMMSS(105));
        this.layerGUI.add(icon);
        this.iconIndicatorAutoMerge = icon;
        this.textFieldIndicatorAutoMerge = txt;
        this.iconIndicatorAutoMerge.x = 50;
        this.iconIndicatorAutoMerge.y = 200;
        this.textFieldIndicatorAutoMerge.x = 50;
        this.textFieldIndicatorAutoMerge.y = 200 + 45;
        this.textFields.push(txt)
    }

    initIndcatorBoostSpeed() {
        var icon = this.add.image(0, 0, "ss_main", "indicator_boost2_0000");
        var txt = MainGame.addText(this, this.layerGUI, 0, 52, "", 20);
        txt.setText(MainGame.secToHHMMSS(110));
        this.layerGUI.add(icon);
        this.iconIndicatorSpeed = icon;
        this.textFieldIndicatorSpeed = txt;
        this.iconIndicatorSpeed.x = 50;
        this.iconIndicatorSpeed.y = 300;
        this.textFieldIndicatorSpeed.x = 50;
        this.textFieldIndicatorSpeed.y = 300 + 45;
        this.textFields.push(txt)
    }

    initIndcatorBoostCoins() {
        var icon = this.add.image(0, 0, "ss_main", "indicator_boost3_0000");
        var txt = MainGame.addText(this, this.layerGUI, 0, 52, "", 20);
        txt.setText(MainGame.secToHHMMSS(115));
        this.layerGUI.add(icon);
        this.iconIndicatorCoins = icon;
        this.textFieldIndicatorCoins = txt;
        this.iconIndicatorCoins.x = 50;
        this.iconIndicatorCoins.y = 400;
        this.textFieldIndicatorCoins.x = 50;
        this.textFieldIndicatorCoins.y = 400 + 45;
        this.textFields.push(txt)
    }

    enableIndcatorBoostAutoMerge(vBool) {
        this.iconIndicatorAutoMerge.visible = vBool;
        this.textFieldIndicatorAutoMerge.visible = vBool
    }

    enableIndcatorBoostSpeed(vBool) {
        this.iconIndicatorSpeed.visible = vBool;
        this.textFieldIndicatorSpeed.visible = vBool
    }

    enableIndcatorBoostCoins(vBool) {
        this.iconIndicatorCoins.visible = vBool;
        this.textFieldIndicatorCoins.visible = vBool
    }

    updateIndcatorBoostAutoMerge(vValue) {
        this.textFieldIndicatorAutoMerge.setText(vValue)
    }

    updateIndcatorBoostSpeed(vValue) {
        this.textFieldIndicatorSpeed.setText(vValue)
    }

    updateIndcatorBoostCoins(vValue) {
        this.textFieldIndicatorCoins.setText(vValue)
    }

    updateWallHp(progress, vValue1, vValue2) {
        var originalWidth = this.hp_wall2.width;
        var width = originalWidth * progress;
        this.hp_wall_crop.width = width;
        this.hp_wall2.setCrop(this.hp_wall_crop);
        this.text_wallhp.setText(vValue1 + "/" + vValue2)
    }

    updateForge(progress) {
        var originalHeight = this.icon_forge1.height;
        var height = originalHeight * progress;
        this.forge_crop.height = height;
        this.icon_forge2.setCrop(this.forge_crop)
    }

    updateFastBuy() {
        var typeFastCar = this.gameScreen.getTypeBetterPrice();
        var price = this.gameScreen.getPriceCar(typeFastCar);
        price = Math.round(price * this.gameScreen.factorDiscount);
        var text_coins_warm = MainGame.convertNumberFormat(price);
        this.buttonAddCar.text.setText(text_coins_warm);
        this.buttonAddCar.text.x = 50;
        this.buttonAddCar.text.y = 0;
        this.icon_fast_coin.x = this.buttonAddCar.text.x - this.buttonAddCar.text.width * .5 - 20;
        this.icon_fast_car.setFrame("tower" + typeFastCar + "_0000")
    }

    updateWallBuy() {
        var price = this.gameScreen.getPriceWall();
        price = Math.round(price * this.gameScreen.factorDiscount);
        var text_coins_warm = MainGame.convertNumberFormat(price);
        this.buttonUpgradeWall.text.setText(text_coins_warm);
        this.buttonUpgradeWall.text.x = 10;
        this.buttonUpgradeWall.text.y = 6;
        this.icon_wall_coin.x = this.buttonUpgradeWall.text.x - this.buttonUpgradeWall.text.width * .5 - 15
    }

    initHelicopter() {
        this.helicopter = this.add.container();
        this.heli_shadow = this.add.container();
        this.heli_body = this.add.container();
        this.helicopter.add(this.heli_shadow);
        this.helicopter.add(this.heli_body);
        this.helicopter.setDepth(this.gameScreen.DEPTH_helicopter);
        this.helicopter.setInteractive(new Phaser.Geom.Circle(0, 0, 50), Phaser.Geom.Circle.Contains);
        this.helicopter.on("pointerup", this.onClickHelicopter, this);
        this.helicopter.x = 400;
        this.helicopter.y = 200;
        var shadow = this.add.image(0, 100, "ss_main", "booster_shadow_0000");
        var dron_body = this.add.image(0, 0, "ss_main", "booster_body_0000");
        var propeller1 = this.add.sprite(-3.5, dron_body.y - 30, "ss_main");
        propeller1.play("propeller1");
        var propeller2 = this.add.sprite(dron_body.x + 45, dron_body.y - 6, "ss_main");
        propeller2.play("propeller2");
        this.heli_shadow.add(shadow);
        this.heli_body.add(dron_body);
        this.heli_body.add(propeller1);
        this.heli_body.add(propeller2);
        this.dron_body = dron_body;
        this.dron_propeller1 = propeller1;
        this.dron_propeller2 = propeller2;
        this.helicopter.visible = false
    }

    showHelicopter() {
        this.isShowHelicopter = true;
        this.helicopter.visible = true;
        this.countHelicopterFly = 3;
        this.maxDistX = 650;
        this.speedDron = 1;
        this.flagHelicopter = Math.random() >= .5;
        this.flagHelicopter = false;
        if (this.flagHelicopter) {
            this.helicopter.x = this.midX + this.maxDistX;
            this.helicopter.scaleX = 1
        } else {
            this.helicopter.x = this.midX - this.maxDistX;
            this.helicopter.scaleX = -1
        }
        this.waveCount = 0;
        this.waveStart = 2 * Math.random()
    }

    updateHelicopter() {
        if (!this.isShowHelicopter) return;
        this.waveCount += .02;
        this.helicopter.y = 250 + Math.sin(this.waveStart + this.waveCount) * 50;
        this.heli_body.angle = Phaser.Math.RadToDeg(Math.sin(this.waveCount) * .08) - 5;
        if (this.flagHelicopter) {
            this.helicopter.x -= this.speedDron;
            if (this.helicopter.x < this.midX - this.maxDistX) {
                this.flagHelicopter = false;
                this.helicopter.scaleX = -1;
                this.countHelicopterFly--;
                if (this.countHelicopterFly <= 0) {
                    this.isShowHelicopter = false;
                    this.helicopter.visible = false
                }
            }
        } else {
            this.helicopter.x += this.speedDron;
            if (this.helicopter.x > this.midX + 110) {
                this.flagHelicopter = true;
                this.helicopter.scaleX = 1;
                this.countHelicopterFly--
            }
        }
    }

    onClickHelicopter() {
        if (!this.buttonEnabled) return;
        this.gameScreen.getHelicopterBonus();
        this.showBoosterWindow(this.gameScreen.helicopterBonus)
    }

    initBasketTrash() {
        var posX = 930;
        var posY = 500 - 5 + 20;
        this.icon_trash = this.gameScreen.add.image(posX, posY, "ss_main", "btn_delete_0000");
        var effect = this.gameScreen.add.sprite(this.icon_trash.x + 2, this.icon_trash.y + 2, "ss_main");
        effect.play("delete_flash");
        effect.visible = false;
        this.delete_flash = effect;
        this.icon_trash.setDepth(this.gameScreen.DEPTH_layerTowers);
        this.delete_flash.setDepth(this.gameScreen.DEPTH_layerTowers)
    }

    enableMainButtons() {
        if (this.isShowingFinish) return;
        this.buttonEnabled = true;
        if (MainGame.isApiGameplayStop) {
            this.gameScreen.updateGameplayEvent(false);
            MainGame.isApiGameplayStop = false
        }
        this.buttonFortuna.enableInput();
        this.buttonShop.enableInput();
        this.buttonSettings.enableInput();
        this.buttonForge.enableInput();
        if (this.gameScreen.isGoTutorial && (this.gameScreen.tutorialStep >= 3 && this.gameScreen.tutorialStep <= 5)) return;
        this.buttonAddCar.enableInput();
        this.buttonUpgradeWall.enableInput()
    }

    disableMainButtons(vSkipApiEvent, vSkipCheckInput) {
        if (!vSkipCheckInput) this.gameScreen.checkInputs();
        this.buttonEnabled = false;
        this.isOnInputDown = false;
        this.isPopupOpened = false;
        this.buttonFortuna.disableInput();
        this.buttonAddCar.disableInput();
        this.buttonUpgradeWall.disableInput();
        this.buttonShop.disableInput();
        this.buttonSettings.disableInput();
        this.buttonForge.disableInput();
        if (!vSkipApiEvent) {
            MainGame.isApiGameplayStop = true;
            this.gameScreen.updateGameplayEvent(true)
        }
    }

    initWavePanel() {
        var posX = this.midX;
        var posY = 10;
        var txt = this.add.bitmapText(posX, posY, MainGame.fontName, "", 24);
        txt.setDropShadow(-2, 2, 0, 1);
        this.textWave = txt;
        this.layerGUI.add(this.textWave);
        this.textFields.push(txt)
    }

    updateWavePanel(value) {
        this.textWave.setText(MainGame.GAME_TEXT.wave + " " + value)
    }

    initCoinsPanel() {
        var posX = this.midX + 25;
        var posY = 430 + 20;
        var coin = this.add.image(posX - 105, posY - 2, "ss_main", "money_0000");
        this.icons_coin = coin;
        this.textCoins = this.add.bitmapText(posX - 75, posY, MainGame.fontName, "192.640K", 32);
        this.textCoins.setOrigin(0, .5);
        this.textCoins.setDropShadow(-2, 2, 0, 1);
        this.layerGUI.add(this.icons_coin);
        this.layerGUI.add(this.textCoins);
        this.textFields.push(this.textCoins)
    }

    updateCoins(vValue) {
        this.textCoins.setText(vValue)
    }

    initSystemMessage() {
        this.textSystemContainer = this.add.container();
        this.textSystemContainer.x = this.midX;
        this.textSystemContainer.y = MainGame.world.centerY - 100;
        var txt = this.add.bitmapText(0, 0, MainGame.fontName, "");
        txt.setDropShadow(2, 2, 0, 1);
        txt.setOrigin(.5);
        txt.setMaxWidth(550);
        txt.setCenterAlign();
        txt.setFontSize(34);
        txt.setTint(16183785);
        this.textSystemContainer.add(txt);
        this.textSystemContainer.setDepth(this.gameScreen.DEPTH_systemtext);
        this.textSystemContainer.visible = false;
        this.textSystem = txt
    }

    showSystemMessage(vText) {
        this.textSystemContainer.visible = true;
        this.textSystem.setText(vText);
        this.textSystemContainer.alpha = .2;
        this.textSystemContainer.y = this.midY - 20;
        this.textSystemContainer.setScale(.8);
        this.tweens.killTweensOf(this.textSystemContainer);
        this.tweens.add({targets: this.textSystemContainer, alpha: 1, ease: "Linear", duration: 150});
        this.tweens.add({targets: this.textSystemContainer, scaleX: 1, scaleY: 1, ease: "Linear", duration: 150});
        this.tweens.add({
            targets: this.textSystemContainer,
            alpha: 0,
            ease: "Linear",
            delay: 1500,
            duration: 200,
            onComplete: this.finishSystemTextTween
        });
        this.tweens.add({
            targets: this.textSystemContainer,
            y: this.textSystemContainer.y - 20,
            ease: "Linear",
            delay: 150,
            duration: 1200
        })
    }

    initMergeAnimation() {
        this.layerMerge = this.add.container();
        this.layerUnlocked = this.add.container();
        this.layerMerge.setDepth(this.gameScreen.DEPTH_layerMerge);
        this.layerUnlocked.setDepth(this.gameScreen.DEPTH_layerUnlock);
        this.layerUnlocked.x = this.midX;
        this.layerUnlocked.y = this.midY + this.posWindowY;
        var fon_merge = this.add.image(this.midX, this.midY, "ss_main", "bg_connect_0000");
        fon_merge.setScale(4);
        this.layerMerge.add(fon_merge);
        var fon_unlock = this.add.image(0, 0, "ss_main", "popup_unlocked_0000");
        fon_unlock.setScale(2);
        this.layerUnlocked.add(fon_unlock);
        var effect = this.add.sprite(0, -20, "ss_main");
        effect.play("magic_1");
        effect.setScale(2);
        this.layerUnlocked.add(effect);
        var unlocked_car = this.add.image(0, -30, "ss_main", "tower30_0000");
        unlocked_car.setScale(1.5);
        this.layerUnlocked.add(unlocked_car);
        this.unlocked_car = unlocked_car;
        var car1_merge = this.add.image(this.midX - 160, this.midY - 40, "ss_main", "tower1_0000");
        car1_merge.setScale(1.25);
        this.car1_merge = car1_merge;
        var car2_merge = this.add.image(this.midX + 160, this.midY - 40, "ss_main", "tower1_0000");
        car2_merge.setScale(1.25);
        this.car2_merge = car2_merge;
        this.layerMerge.add(car1_merge);
        this.layerMerge.add(car2_merge);
        var star_flash1 = this.add.image(0, 0, "ss_main", "star_flash_0000");
        this.layerUnlocked.add(star_flash1);
        this.star_flash1 = star_flash1;
        var star_flash2 = this.add.image(0, 0, "ss_main", "star_flash_0000");
        this.layerUnlocked.add(star_flash2);
        this.star_flash2 = star_flash2;
        var star_flash3 = this.add.image(0, 0, "ss_main", "star_flash_0000");
        this.layerUnlocked.add(star_flash3);
        this.star_flash3 = star_flash3;
        this.tweens.add({
            targets: star_flash1,
            scaleX: .1,
            scaleY: .1,
            ease: "Linear",
            duration: 500,
            yoyo: true,
            repeat: -1
        });
        this.tweens.add({
            targets: star_flash2,
            scaleX: .1,
            scaleY: .1,
            ease: "Linear",
            duration: 500,
            yoyo: true,
            repeat: -1
        });
        this.tweens.add({
            targets: star_flash3,
            scaleX: .1,
            scaleY: .1,
            ease: "Linear",
            duration: 500,
            yoyo: true,
            repeat: -1
        });
        var back_car = this.add.image(140, 70, "ss_main", "tower5_0000");
        this.layerUnlocked.add(back_car);
        back_car.setScale(this.gameScreen.getScaleCar(.8));
        back_car.setTintFill(0);
        this.back_car = back_car;
        var buttonContinue = new ButtonText(0, 170, "ss_main", "btn_buy_0000", this.clickContinueUnlocked, this, MainGame.GAME_TEXT.continue);
        this.layerUnlocked.add(buttonContinue);
        MainGame.updateTextWidth(buttonContinue.text, 200);
        var text_unlocked = MainGame.addText(this, this.layerUnlocked, 0, -232, MainGame.GAME_TEXT.unlocked, 34, true);
        text_unlocked.setTint(16777215);
        MainGame.updateTextWidth(text_unlocked, 400);
        var text_damage = MainGame.addText(this, this.layerUnlocked, 0, 70, "", 22, true, true);
        text_damage.setTint(3281430);
        MainGame.updateTextWidth(text_damage, 400);
        text_damage.setText(MainGame.GAME_TEXT.damage + ":" + 2);
        this.textDamage = text_damage;
        this.mergeCars_textNext = MainGame.addText(this, this.layerUnlocked, back_car.x, back_car.y - 50, MainGame.GAME_TEXT.next, 22, true);
        MainGame.updateTextWidth(this.mergeCars_textNext, 120);
        this.mergeCars_textQuestion = MainGame.addText(this, this.layerUnlocked, back_car.x, back_car.y - 2, "?", 26);
        this.layerUnlocked.visible = false;
        this.layerMerge.visible = false;
        fon_unlock.setInteractive();
        fon_merge.setInteractive();
        fon_merge.on("pointerdown", this.onFonInputDown, this);
        fon_merge.on("pointerup", this.onFonInputUp, this)
    }

    clickContinueUnlocked() {
        if (!this.layerUnlocked.visible) return;
        if (MainGame.isApiGameplayStop) {
            this.gameScreen.updateGameplayEvent(false);
            MainGame.isApiGameplayStop = false
        }
        this.gameScreen.hideMergeEffect();
        this.layerUnlocked.visible = false;
        this.layerMerge.visible = false;
        if (this.gameScreen.showAfterMerge) {
            this.time.delayedCall(150, this.showLevelUpWindow, [], this);
            this.gameScreen.showAfterMerge = false
        }
        this.enableMainButtons()
    }

    showMergeAnimation(vType) {
        this.layerMerge.visible = true;
        this.tweens.killTweensOf(this.car1_merge);
        this.tweens.killTweensOf(this.car2_merge);
        this.car1_merge.visible = true;
        this.car2_merge.visible = true;
        this.car1_merge.x = this.midX - 160;
        this.car2_merge.x = this.midX + 160;
        this.car1_merge.angle = -5;
        this.car2_merge.angle = -5;
        var prevType = vType - 1;
        var nextType = vType + 1;
        if (nextType > this.MAX_TYPES_CAR) {
            this.back_car.visible = false;
            this.mergeCars_textNext.visible = false;
            this.mergeCars_textQuestion.visible = false
        } else {
            this.back_car.setFrame("tower" + nextType + "_0000")
        }
        this.car1_merge.setFrame("tower" + prevType + "_0000");
        this.car2_merge.setFrame("tower" + prevType + "_0000");
        this.unlocked_car.setFrame("tower" + vType + "_0000");
        var value_dmg = this.gameScreen.getDamage(vType);
        var value_dmg_warm = MainGame.convertNumberFormat(value_dmg);
        this.textDamage.setText(MainGame.GAME_TEXT.damage + " : " + value_dmg_warm);
        this.star_flash1.x = -180 + Phaser.Math.Between(-5, 5) * 2;
        this.star_flash1.y = -160;
        this.star_flash2.x = 180 + Phaser.Math.Between(-5, 5) * 2;
        this.star_flash2.y = -150;
        this.star_flash3.x = Phaser.Math.Between(-10, 10) * 10;
        this.star_flash3.y = 150;
        this.tweens.add({targets: this.car1_merge, angle: 5, ease: "Linear", duration: 100, yoyo: true, repeat: 1});
        this.tweens.add({
            targets: this.car1_merge,
            x: this.midX,
            ease: Phaser.Math.Easing.Back.In,
            duration: 500,
            delay: 200
        });
        this.tweens.add({targets: this.car2_merge, angle: 5, ease: "Linear", duration: 100, yoyo: true, repeat: 1});
        this.tweens.add({
            targets: this.car2_merge,
            x: this.midX,
            ease: Phaser.Math.Easing.Back.In,
            duration: 500,
            delay: 200
        });
        this.time.delayedCall(700, this.addEffectMerge, [], this);
        this.time.delayedCall(1800, this.showUnlockContent, [], this);
        MainGame.Sfx.play("sound", "merge_unlocked");
        this.disableMainButtons(false, true)
    }

    addEffectMerge() {
        var effect = this.add.sprite(this.midX + 10, this.midY - 60, "ss_main");
        effect.play("effect_connect2");
        effect.setScale(2.5);
        this.layerMerge.add(effect);
        this.car1_merge.visible = false;
        this.car2_merge.visible = false
    }

    showUnlockContent() {
        this.layerUnlocked.visible = true;
        this.layerUnlocked.setScale(this.scaleWindow1);
        this.tweens.add({
            targets: this.layerUnlocked,
            scaleX: this.scaleWindow2,
            scaleY: this.scaleWindow2,
            ease: Phaser.Math.Easing.Back.Out,
            duration: 400
        });
        this.eventFonImputUp = this.clickContinueUnlocked;
        this.time.delayedCall(this.TIME_OPEN_POPUP, this.onPopupOpen, [], this)
    }

    initSettingsWindow() {
        this.layerSettingsWindowMain = this.add.container();
        this.layerSettingsWindow = this.add.container();
        this.layerSettingsWindowMain.setDepth(this.gameScreen.DEPTH_layerMerge);
        this.layerSettingsWindow.setDepth(this.gameScreen.DEPTH_layerUnlock);
        this.layerSettingsWindow.x = this.midX;
        this.layerSettingsWindow.y = this.midY + this.posWindowY;
        var fon_merge = this.add.image(this.midX, this.midY, "ss_main", "bg_connect_0000");
        fon_merge.setScale(4);
        this.layerSettingsWindowMain.add(fon_merge);
        var fon_unlock = this.add.image(0, 0, "ss_main", "popup_unlocked_0000");
        fon_unlock.setScale(2);
        this.layerSettingsWindow.add(fon_unlock);
        var logo_tbs = this.add.image(0, 90, "ss_main", "logo_tbs_0000");
        this.layerSettingsWindow.add(logo_tbs);
        var buttonClose = new Button(228, -231, "ss_main", "btn_close_0000", this.closeSettings, this);
        this.layerSettingsWindow.add(buttonClose);
        var buttonMuteMusic = new ButtonText(0, -130, "ss_main", "btn_buy_0000", this.clickMuteMusic, this, MainGame.GAME_TEXT.music_on);
        buttonMuteMusic.text.setFontSize(26);
        buttonMuteMusic.text.x = 20;
        this.layerSettingsWindow.add(buttonMuteMusic);
        MainGame.updateTextWidth(buttonMuteMusic.text, 140);
        var icon_music = this.add.image(-95, -4, "ss_main", "btn_music_0000");
        buttonMuteMusic.add(icon_music);
        this.buttonMuteMusic = buttonMuteMusic;
        this.buttonMuteMusic.icon = icon_music;
        var buttonMuteSound = new ButtonText(0, buttonMuteMusic.y + 85, "ss_main", "btn_buy_0000", this.clickMuteSound, this, MainGame.GAME_TEXT.sound_on);
        buttonMuteSound.text.setFontSize(26);
        buttonMuteSound.text.x = 20;
        this.layerSettingsWindow.add(buttonMuteSound);
        MainGame.updateTextWidth(buttonMuteSound.text, 140);
        var icon_sound = this.add.image(-95, -4, "ss_main", "btn_sound_0000");
        buttonMuteSound.add(icon_sound);
        this.buttonMuteSound = buttonMuteSound;
        this.buttonMuteSound.icon = icon_sound;
        var text_title = MainGame.addText(this, this.layerSettingsWindow, 0, -232, MainGame.GAME_TEXT.settings, 34, true);
        text_title.setTint(16777215);
        MainGame.updateTextWidth(text_title, 400);
        var textDevs = MainGame.addText(this, this.layerSettingsWindow, 0, logo_tbs.y - 65, MainGame.GAME_TEXT.developed_by, 24, true);
        MainGame.updateTextWidth(textDevs, 380);
        textDevs.setTint(16777215);
        var textMusic = MainGame.addText(this, this.layerSettingsWindow, 0, 170, MainGame.GAME_TEXT.music_by, 24, true);
        MainGame.updateTextWidth(textMusic, 380);
        textMusic.setTint(16777215);
        var text_musian = MainGame.addText(this, this.layerSettingsWindow, 0, textMusic.y + 35, "GRIN DANILOV", 24, true);
        text_musian.setTint(16777215);
        this.layerSettingsWindow.setScale(this.scaleWindow2);
        this.layerSettingsWindowMain.visible = false;
        this.layerSettingsWindow.visible = false;
        var text_v = MainGame.addText(this, this.layerSettingsWindow, 186, 225, MainGame.version, 18, true, true);
        text_v.setOrigin(1, .5);
        text_v.setTint(16777215);
        fon_unlock.setInteractive();
        fon_merge.setInteractive();
        fon_merge.on("pointerdown", this.onFonInputDown, this);
        fon_merge.on("pointerup", this.onFonInputUp, this)
    }

    openSettings() {
        this.gameScreen.setGameLogicPause(true);
        this.layerSettingsWindowMain.visible = true;
        this.layerSettingsWindow.visible = true;
        this.layerSettingsWindow.setScale(this.scaleWindow1);
        this.tweens.add({
            targets: this.layerSettingsWindow,
            scaleX: this.scaleWindow2,
            scaleY: this.scaleWindow2,
            ease: Phaser.Math.Easing.Back.Out,
            duration: 400
        });
        this.disableMainButtons();
        MainGame.Sfx.update("music", this.buttonMuteMusic.icon, this.buttonMuteMusic.text);
        MainGame.Sfx.update("sound", this.buttonMuteSound.icon, this.buttonMuteSound.text);
        this.eventFonImputUp = this.closeSettings;
        this.time.delayedCall(this.TIME_OPEN_POPUP, this.onPopupOpen, [], this)
    }

    closeSettings() {
        this.gameScreen.setGameLogicPause(false);
        this.layerSettingsWindowMain.visible = false;
        this.layerSettingsWindow.visible = false;
        this.enableMainButtons()
    }

    initOfflineEarningWindow() {
        this.layerOfflineEarningWindowMain = this.add.container();
        this.layerOfflineEarningWindow = this.add.container();
        this.layerOfflineEarningWindowMain.setDepth(this.gameScreen.DEPTH_layerMerge);
        this.layerOfflineEarningWindow.setDepth(this.gameScreen.DEPTH_layerUnlock);
        this.layerOfflineEarningWindow.x = this.midX;
        this.layerOfflineEarningWindow.y = this.midY + this.posWindowY;
        var fon_merge = this.add.image(this.midX, this.midY, "ss_main", "bg_connect_0000");
        fon_merge.setScale(4);
        this.layerOfflineEarningWindowMain.add(fon_merge);
        var fon_unlock = this.add.image(0, 0, "ss_main", "popup_unlocked_0000");
        fon_unlock.setScale(2);
        this.layerOfflineEarningWindow.add(fon_unlock);
        var posX = 0;
        var posY = -50;
        var effect = this.add.sprite(posX, posY, "ss_main");
        effect.play("magic_1");
        effect.setScale(2);
        this.layerOfflineEarningWindow.add(effect);
        var offline_coins = this.add.image(posX + 5, posY, "ss_main", "offline_coins_0000");
        this.layerOfflineEarningWindow.add(offline_coins);
        var buttonClose = new ButtonText(0, 215, "ss_main", "btn_buy2_0000", this.closeOfflineEarningWindow, this, MainGame.GAME_TEXT.tap_continue);
        buttonClose.text.setFontSize(20);
        this.layerOfflineEarningWindow.add(buttonClose);
        MainGame.updateTextWidth(buttonClose.text, 320);
        buttonClose.text.y = -4;
        buttonClose.back.alpha = .01;
        buttonClose.text.setTint(16777215);
        var buttonContinue = new ButtonText(0, 145, "ss_main", "btn_buy2_0000", this.clickOfflineEarningButton, this, MainGame.GAME_TEXT.coins_x2);
        this.layerOfflineEarningWindow.add(buttonContinue);
        MainGame.updateTextWidth(buttonContinue.text, 200);
        buttonContinue.text.x = -22;
        var icon_reward = this.add.image(85, 2, "ss_main", "icon_reward_0000");
        buttonContinue.add(icon_reward);
        var text_title = MainGame.addText(this, this.layerOfflineEarningWindow, 0, -232, MainGame.GAME_TEXT.offline_earn, 34, true);
        text_title.setTint(16777215);
        MainGame.updateTextWidth(text_title, 400);
        var offline_earning_text = MainGame.addText(this, this.layerOfflineEarningWindow, 0, 75, "+458K", 40, true);
        offline_earning_text.setTint(16777215);
        offline_earning_text.setDropShadow(-2, 3, 0, 1);
        this.offline_earning_text = offline_earning_text;
        this.offlineEarningBtnAds = buttonContinue;
        this.layerOfflineEarningWindow.setScale(this.scaleWindow2);
        this.layerOfflineEarningWindowMain.visible = false;
        this.layerOfflineEarningWindow.visible = false;
        fon_unlock.setInteractive();
        fon_merge.setInteractive();
        fon_merge.on("pointerdown", this.onFonInputDown, this);
        fon_merge.on("pointerup", this.onFonInputUp, this)
    }

    clickOfflineEarningButton() {
        this.gameScreen.showAdsForCoinsX2()
    }

    showOfflineEarningWindow(vValueCoins) {
        this.layerOfflineEarningWindow.visible = true;
        this.layerOfflineEarningWindowMain.visible = true;
        this.layerOfflineEarningWindow.setScale(this.scaleWindow1);
        this.tweens.add({
            targets: this.layerOfflineEarningWindow,
            scaleX: this.scaleWindow2,
            scaleY: this.scaleWindow2,
            ease: Phaser.Math.Easing.Back.Out,
            duration: 400
        });
        this.disableMainButtons(true);
        var coins = vValueCoins;
        var text_coins_warm = MainGame.convertNumberFormat(coins);
        this.offline_earning_text.setText("+" + text_coins_warm);
        MainGame.Sfx.play("sound", "offline_earning");
        this.offlineEarningBtnAds.setEnable(true);
        if (MainGame.isAPI) {
            if (!MainGame.isApiReady) this.offlineEarningBtnAds.setEnable(false)
        } else {
            if (!MainGame.isDebug) this.offlineEarningBtnAds.setEnable(false)
        }
        this.eventFonImputUp = this.closeOfflineEarningWindowOutAir;
        this.time.delayedCall(this.TIME_OPEN_POPUP, this.onPopupOpen, [], this);
        MainGame.isApiGameplayStop = true
    }

    closeOfflineEarningWindowOutAir() {
        this.layerOfflineEarningWindowMain.visible = false;
        this.layerOfflineEarningWindow.visible = false;
        if (MainGame.isApiGameplayStop) {
            this.gameScreen.updateGameplayEvent(false);
            MainGame.isApiGameplayStop = false
        }
        this.enableMainButtons()
    }

    closeOfflineEarningWindow(isSkipCallAds) {
        MainGame.isApiGameplayStop = true;
        if (isSkipCallAds) {
            this.gameScreen.updateGameplayEvent(false);
            MainGame.isApiGameplayStop = false
        }
        this.layerOfflineEarningWindowMain.visible = false;
        this.layerOfflineEarningWindow.visible = false;
        this.enableMainButtons()
    }

    initLevelUpWindow() {
        this.layerLevelUpWindowMain = this.add.container();
        this.layerLevelUpWindow = this.add.container();
        this.layerLevelUpWindowMain.setDepth(this.gameScreen.DEPTH_layerMerge);
        this.layerLevelUpWindow.setDepth(this.gameScreen.DEPTH_layerUnlock);
        this.layerLevelUpWindow.x = this.midX;
        this.layerLevelUpWindow.y = this.midY + this.posWindowY;
        var fon_merge = this.add.image(this.midX, this.midY, "ss_main", "bg_connect_0000");
        fon_merge.setScale(4);
        this.layerLevelUpWindowMain.add(fon_merge);
        var fon_unlock = this.add.image(0, 0, "ss_main", "popup_unlocked_0000");
        fon_unlock.setScale(2);
        this.layerLevelUpWindow.add(fon_unlock);
        var posX = 0;
        var posY = -75;
        var effect = this.add.sprite(posX, posY, "ss_main");
        effect.play("magic_1");
        effect.setScale(2);
        this.layerLevelUpWindow.add(effect);
        var lvlup_icon = this.add.image(posX, posY - 10, "ss_main", "lvlup_0000");
        this.layerLevelUpWindow.add(lvlup_icon);
        var icon_newmoney = this.add.image(0, 55, "ss_main", "icon_newmoney_0000");
        this.layerLevelUpWindow.add(icon_newmoney);
        var buttonContinue = new ButtonText(0, 180, "ss_main", "btn_buy_0000", this.closeLevelUpWindow, this, MainGame.GAME_TEXT.continue);
        this.layerLevelUpWindow.add(buttonContinue);
        MainGame.updateTextWidth(buttonContinue.text, 200);
        var text_title = MainGame.addText(this, this.layerLevelUpWindow, 0, -232, MainGame.GAME_TEXT.level_up, 34, true);
        text_title.setTint(16777215);
        MainGame.updateTextWidth(text_title, 400);
        this.levelup_text_level = MainGame.addText(this, this.layerLevelUpWindow, posX, posY + 2, "48", 50, true, true);
        this.levelup_text_level.setTint(16777215);
        var levelup_text_money = MainGame.addText(this, this.layerLevelUpWindow, icon_newmoney.x, icon_newmoney.y + 62, "+148k", 26, true);
        levelup_text_money.setTint(16777215);
        this.levelup_text_money = levelup_text_money;
        this.layerLevelUpWindow.setScale(this.scaleWindow2);
        this.layerLevelUpWindow.visible = false;
        this.layerLevelUpWindowMain.visible = false;
        fon_unlock.setInteractive();
        fon_merge.setInteractive();
        fon_merge.on("pointerdown", this.onFonInputDown, this);
        fon_merge.on("pointerup", this.onFonInputUp, this)
    }

    showLevelUpRewards2() {
        var coins = this.gameScreen.getCoinsLevelUp(this.gameScreen.currentLevel);
        var text_coins_warm = MainGame.convertNumberFormat(coins);
        this.levelup_text_money.setText(text_coins_warm);
        this.gameScreen.amount_coins += coins;
        text_coins_warm = MainGame.convertNumberFormat(this.gameScreen.amount_coins);
        this.updateCoins(text_coins_warm);
        this.updateShop(text_coins_warm)
    }

    showLevelUpWindow() {
        this.layerLevelUpWindow.visible = true;
        this.layerLevelUpWindowMain.visible = true;
        this.layerLevelUpWindow.setScale(this.scaleWindow1);
        this.tweens.add({
            targets: this.layerLevelUpWindow,
            scaleX: this.scaleWindow2,
            scaleY: this.scaleWindow2,
            ease: Phaser.Math.Easing.Back.Out,
            duration: 400
        });
        this.disableMainButtons();
        this.showLevelUpRewards2();
        this.levelup_text_level.setText(" " + this.gameScreen.currentLevel + " ");
        MainGame.Sfx.play("sound", "lvl_up");
        this.eventFonImputUp = this.closeLevelUpWindow;
        this.time.delayedCall(this.TIME_OPEN_POPUP, this.onPopupOpen, [], this)
    }

    closeLevelUpWindow() {
        this.layerLevelUpWindow.visible = false;
        this.layerLevelUpWindowMain.visible = false;
        this.enableMainButtons()
    }

    initUpgradeWindow() {
        this.layerUpgradeWindowMain = this.add.container();
        this.layerUpgradeWindow = this.add.container();
        this.layerUpgradeWindowMain.setDepth(this.gameScreen.DEPTH_layerMerge);
        this.layerUpgradeWindow.setDepth(this.gameScreen.DEPTH_layerUnlock);
        this.layerUpgradeWindow.x = this.midX;
        this.layerUpgradeWindow.y = this.midY + this.posWindowY;
        var fon_merge = this.add.image(this.midX, this.midY, "ss_main", "bg_connect_0000");
        fon_merge.setScale(4);
        this.layerUpgradeWindowMain.add(fon_merge);
        var fon_unlock = this.add.image(0, 0, "ss_main", "popup_unlocked_0000");
        fon_unlock.setScale(2);
        this.layerUpgradeWindow.add(fon_unlock);
        var posX = 0;
        var posY = -10;
        var effect = this.add.sprite(130, posY, "ss_main");
        effect.play("magic_1");
        effect.setScale(2);
        this.layerUpgradeWindow.add(effect);
        var arrow_icon = this.add.sprite(posX + 0, posY + 0, "ss_main", "arrow_0000");
        this.layerUpgradeWindow.add(arrow_icon);
        var panel_number1 = this.add.image(posX - 110 - 50, posY - 100, "ss_main", "panel_number_0000");
        this.layerUpgradeWindow.add(panel_number1);
        var panel_number2 = this.add.image(posX + 110 - 30, posY - 100, "ss_main", "panel_number_0000");
        this.layerUpgradeWindow.add(panel_number2);
        var gun1 = this.add.image(-130 + 10, posY, "ss_main", "tower1_0000");
        gun1.setScale(1.2);
        this.layerUpgradeWindow.add(gun1);
        var gun2 = this.add.image(130, posY, "ss_main", "tower4_0000");
        gun2.setScale(1.2);
        this.layerUpgradeWindow.add(gun2);
        var buttonClose = new Button(228, -231, "ss_main", "btn_close_0000", this.closeUpgadeWindow, this);
        this.layerUpgradeWindow.add(buttonClose);
        var buttonContinue = new ButtonText(0, 145, "ss_main", "btn_buy2_0000", this.clickUpgradeButton, this, MainGame.GAME_TEXT.free);
        buttonContinue.text.x = -22;
        this.layerUpgradeWindow.add(buttonContinue);
        MainGame.updateTextWidth(buttonContinue.text, 200);
        this.buttonFreeUpgrade = buttonContinue;
        var icon_reward = this.add.image(85, 2, "ss_main", "icon_reward_0000");
        buttonContinue.add(icon_reward);
        var text_title = MainGame.addText(this, this.layerUpgradeWindow, 0, -232, MainGame.GAME_TEXT.free_upgrade, 34, true);
        MainGame.updateTextWidth(text_title, 400);
        text_title.setTint(16777215);
        var text_level1 = MainGame.addText(this, this.layerUpgradeWindow, panel_number1.x + 60, panel_number1.y - 2, MainGame.GAME_TEXT.level, 24, true);
        MainGame.updateTextWidth(text_level1, 400);
        text_level1.setTint(16777215);
        var text_level2 = MainGame.addText(this, this.layerUpgradeWindow, panel_number2.x + 60, panel_number1.y - 2, MainGame.GAME_TEXT.level, 24, true);
        MainGame.updateTextWidth(text_level2, 400);
        text_level2.setTint(16777215);
        var text_levelGun1 = MainGame.addText(this, this.layerUpgradeWindow, panel_number1.x - 1, panel_number1.y - 2, "12", 24);
        text_levelGun1.setTint(16777215);
        var text_levelGun2 = MainGame.addText(this, this.layerUpgradeWindow, panel_number2.x - 1, panel_number2.y - 2, "34", 24);
        text_levelGun2.setTint(16777215);
        this.text_levelGun1 = text_levelGun1;
        this.text_levelGun2 = text_levelGun2;
        this.layerUpgradeWindow.setScale(this.scaleWindow2);
        this.layerUpgradeWindowMain.visible = false;
        this.layerUpgradeWindow.visible = false;
        this.gun1 = gun1;
        this.gun2 = gun2;
        fon_unlock.setInteractive();
        fon_merge.setInteractive();
        fon_merge.on("pointerdown", this.onFonInputDown, this);
        fon_merge.on("pointerup", this.onFonInputUp, this)
    }

    clickUpgradeButton() {
        this.gameScreen.showAdsForFreeUpgrade()
    }

    showUpgradeWindow(vLevelGun) {
        this.layerUpgradeWindowMain.visible = true;
        this.layerUpgradeWindow.visible = true;
        this.layerUpgradeWindow.setScale(this.scaleWindow1);
        this.tweens.add({
            targets: this.layerUpgradeWindow,
            scaleX: this.scaleWindow2,
            scaleY: this.scaleWindow2,
            ease: Phaser.Math.Easing.Back.Out,
            duration: 400
        });
        var lvl_left = vLevelGun;
        var lvl_right = vLevelGun + 2;
        this.text_levelGun1.setText(lvl_left);
        this.text_levelGun2.setText(lvl_right);
        this.gun1.setFrame("tower" + lvl_left + "_0000");
        this.gun2.setFrame("tower" + lvl_right + "_0000");
        this.buttonFreeUpgrade.setEnable(true);
        if (MainGame.isAPI) {
            if (!MainGame.isApiReady) this.buttonFreeUpgrade.setEnable(false)
        } else {
            if (!MainGame.isDebug) this.buttonFreeUpgrade.setEnable(false)
        }
        this.disableMainButtons();
        this.eventFonImputUp = this.closeUpgadeWindow;
        this.time.delayedCall(this.TIME_OPEN_POPUP, this.onPopupOpen, [], this)
    }

    closeUpgadeWindow() {
        this.layerUpgradeWindowMain.visible = false;
        this.layerUpgradeWindow.visible = false;
        this.enableMainButtons()
    }

    initBoosterWindow() {
        this.layerBoosterWindowMain = this.add.container();
        this.layerBoosterWindow = this.add.container();
        this.layerBoosterWindowMain.setDepth(this.gameScreen.DEPTH_layerMerge);
        this.layerBoosterWindow.setDepth(this.gameScreen.DEPTH_layerUnlock);
        this.layerBoosterWindow.x = this.midX;
        this.layerBoosterWindow.y = this.midY + this.posWindowY;
        var fon_merge = this.add.image(this.midX, this.midY, "ss_main", "bg_connect_0000");
        fon_merge.setScale(4);
        this.layerBoosterWindowMain.add(fon_merge);
        var popup_drop = this.add.sprite(0, 0, "ss_main", "popup_drop_0000");
        popup_drop.setScale(2);
        this.layerBoosterWindow.add(popup_drop);
        var effect = this.add.sprite(0, -20, "ss_main");
        effect.play("magic_1");
        effect.setScale(2);
        this.layerBoosterWindow.add(effect);
        var helicopter_icon = this.add.image(-45, -45, "ss_main", "helicopter_icon_0000");
        this.layerBoosterWindow.add(helicopter_icon);
        var reward_icon = this.add.image(95, 10, "ss_main", "reward_boost_0000");
        this.layerBoosterWindow.add(reward_icon);
        var buttonClose = new Button(228, -194, "ss_main", "btn_close_0000", this.closeBoost, this);
        this.layerBoosterWindow.add(buttonClose);
        var buttonContinue = new ButtonText(0, 145, "ss_main", "btn_buy2_0000", this.clickBoost, this, MainGame.GAME_TEXT.activate);
        buttonContinue.text.x = -22;
        this.layerBoosterWindow.add(buttonContinue);
        MainGame.updateTextWidth(buttonContinue.text, 200);
        this.boostBtnAds = buttonContinue;
        var icon_reward = this.add.image(85, 2, "ss_main", "icon_reward_0000");
        buttonContinue.add(icon_reward);
        var text_title = MainGame.addText(this, this.layerBoosterWindow, 0, -195, MainGame.GAME_TEXT.boost_message, 34, true);
        MainGame.updateTextWidth(text_title, 400);
        text_title.setTint(16777215);
        var reward_text = MainGame.addText(this, this.layerBoosterWindow, 0, 85, MainGame.GAME_TEXT.bonus_merge, 24, true);
        MainGame.updateTextWidth(reward_text, 400);
        reward_text.setTint(16777215);
        this.boosterWindowIconReward = reward_icon;
        this.boosterWindowTextReward = reward_text;
        this.layerBoosterWindowMain.visible = false;
        this.layerBoosterWindow.visible = false;
        popup_drop.setInteractive();
        fon_merge.setInteractive();
        fon_merge.on("pointerdown", this.onFonInputDown, this);
        fon_merge.on("pointerup", this.onFonInputUp, this)
    }

    showBoosterWindow(vBonus) {
        if (vBonus == undefined) vBonus = "reward_box4";
        this.typeDronBonus = vBonus;
        if (vBonus == "auto_merge") {
            this.boosterWindowIconReward.setFrame("reward_boost_0000");
            this.boosterWindowTextReward.setText(MainGame.GAME_TEXT.bonus_merge);
            MainGame.updateTextWidth(this.boosterWindowTextReward, 400)
        } else if (vBonus == "speed_x2") {
            this.boosterWindowIconReward.setFrame("reward_boost2_0000");
            this.boosterWindowTextReward.setText(MainGame.GAME_TEXT.bonus_speed_x2);
            MainGame.updateTextWidth(this.boosterWindowTextReward, 400)
        } else if (vBonus == "bonus_coins") {
            this.boosterWindowIconReward.setFrame("reward_boost3_0000");
            this.boosterWindowTextReward.setText(MainGame.GAME_TEXT.bonus_coins);
            MainGame.updateTextWidth(this.boosterWindowTextReward, 400)
        } else if (vBonus == "reward_box4") {
            this.boosterWindowIconReward.setFrame("reward_boxes_0000");
            this.boosterWindowTextReward.setText(MainGame.GAME_TEXT.towers_4);
            MainGame.updateTextWidth(this.boosterWindowTextReward, 400)
        }
        this.isShowHelicopter = false;
        this.helicopter.visible = false;
        this.layerBoosterWindow.visible = true;
        this.layerBoosterWindowMain.visible = true;
        this.layerBoosterWindow.setScale(this.scaleWindow1);
        this.tweens.add({
            targets: this.layerBoosterWindow,
            scaleX: this.scaleWindow2,
            scaleY: this.scaleWindow2,
            ease: Phaser.Math.Easing.Back.Out,
            duration: 400
        });
        this.disableMainButtons();
        this.boostBtnAds.setEnable(true);
        if (MainGame.isAPI) {
            if (!MainGame.isApiReady) this.boostBtnAds.setEnable(false)
        } else {
            if (!MainGame.isDebug) this.boostBtnAds.setEnable(false)
        }
        this.eventFonImputUp = this.closeBoost;
        this.time.delayedCall(this.TIME_OPEN_POPUP, this.onPopupOpen, [], this)
    }

    clickBoost() {
        this.layerBoosterWindow.visible = false;
        this.layerBoosterWindowMain.visible = false;
        this.gameScreen.showAdsForHelicopter(this.typeDronBonus);
        this.enableMainButtons()
    }

    closeBoost() {
        if (MainGame.isApiGameplayStop) {
            this.gameScreen.updateGameplayEvent(false);
            MainGame.isApiGameplayStop = false
        }
        this.layerBoosterWindow.visible = false;
        this.layerBoosterWindowMain.visible = false;
        this.enableMainButtons()
    }

    initRewardWindow() {
        this.layerRewardWindowMain = this.add.container();
        this.layerRewardWindow = this.add.container();
        this.layerRewardWindowMain.setDepth(this.gameScreen.DEPTH_layerUnlock);
        this.layerRewardWindow.setDepth(this.gameScreen.DEPTH_layerUnlock);
        this.layerRewardWindow.x = this.midX;
        this.layerRewardWindow.y = this.midY + this.posWindowY;
        var fon_merge = this.add.image(this.midX, this.midY, "ss_main", "bg_connect_0000");
        fon_merge.setScale(4);
        this.layerRewardWindowMain.add(fon_merge);
        var popup_drop = this.add.image(0, 0, "ss_main", "popup_drop_0000");
        popup_drop.setScale(2);
        this.layerRewardWindow.add(popup_drop);
        var posX = 0;
        var posY = -15;
        var effect = this.add.sprite(posX, posY, "ss_main");
        effect.play("magic_1");
        effect.setScale(2);
        this.layerRewardWindow.add(effect);
        var iconRewardWindow = this.add.image(posX, posY, "ss_main", "reward_box6_0000");
        this.layerRewardWindow.add(iconRewardWindow);
        this.iconRewardWindow = iconRewardWindow;
        var buttonContinue = new ButtonText(0, 145, "ss_main", "btn_buy_0000", this.clickGetReward, this, MainGame.GAME_TEXT.get);
        this.layerRewardWindow.add(buttonContinue);
        MainGame.updateTextWidth(buttonContinue.text, 200);
        var text_title = MainGame.addText(this, this.layerRewardWindow, 0, -195, MainGame.GAME_TEXT.reward, 34, true);
        MainGame.updateTextWidth(text_title, 400);
        text_title.setTint(16777215);
        var reward_text = MainGame.addText(this, this.layerRewardWindow, 0, 85, MainGame.GAME_TEXT.bonus_merge, 24, true);
        MainGame.updateTextWidth(reward_text, 400);
        reward_text.setTint(16777215);
        this.rewardWindowText = reward_text;
        this.layerRewardWindowMain.visible = false;
        this.layerRewardWindow.visible = false;
        this.layerRewardWindow.setScale(this.scaleWindow2);
        popup_drop.setInteractive();
        fon_merge.setInteractive();
        fon_merge.on("pointerdown", this.onFonInputDown, this);
        fon_merge.on("pointerup", this.onFonInputUp, this)
    }

    showRewardWindow(vTypeReward) {
        this.layerRewardWindow.visible = true;
        this.layerRewardWindowMain.visible = true;
        this.layerRewardWindow.setScale(this.scaleWindow1);
        this.tweens.add({
            targets: this.layerRewardWindow,
            scaleX: this.scaleWindow2,
            scaleY: this.scaleWindow2,
            ease: Phaser.Math.Easing.Back.Out,
            duration: 400
        });
        if (vTypeReward == "auto_merge") {
            this.iconRewardWindow.setFrame("reward_boost_0000");
            this.rewardWindowText.setText(MainGame.GAME_TEXT.bonus_merge)
        } else if (vTypeReward == "speed_x2") {
            this.iconRewardWindow.setFrame("reward_boost2_0000");
            this.rewardWindowText.setText(MainGame.GAME_TEXT.bonus_speed_x2)
        } else if (vTypeReward == "bonus_coins") {
            this.iconRewardWindow.setFrame("reward_boost3_0000");
            this.rewardWindowText.setText(MainGame.GAME_TEXT.bonus_coins)
        } else {
            this.iconRewardWindow.setFrame(vTypeReward + "_0000");
            if (vTypeReward == "reward_coin1" || vTypeReward == "reward_coin2") {
                this.rewardWindowText.setText("")
            } else {
                this.rewardWindowText.setText(MainGame.GAME_TEXT.towers_4)
            }
        }
        this.eventFonImputUp = this.closeRewardWindow;
        this.time.delayedCall(this.TIME_OPEN_POPUP, this.onPopupOpen, [], this);
        MainGame.Sfx.play("sound", "boost")
    }

    clickGetReward() {
        this.closeRewardWindow()
    }

    closeRewardWindow() {
        this.layerRewardWindowMain.visible = false;
        this.layerRewardWindow.visible = false;
        this.updateFortunaWheelWindow(this.gameScreen.countDownNextFree);
        this.eventFonImputUp = this.closeFortunaWheelWindow;
        if (MainGame.reward_wheel) this.gameScreen.getRewards(MainGame.reward_wheel);
        MainGame.reward_wheel = null
    }

    initFortunaWheelWindow() {
        this.layerFortunaWheelWindowMain = this.add.container();
        this.layerFortunaWheelWindow = this.add.container();
        this.layerFortunaWheelWindowMain.setDepth(this.gameScreen.DEPTH_layerMerge);
        this.layerFortunaWheelWindow.setDepth(this.gameScreen.DEPTH_layerUnlock);
        this.layerFortunaWheelWindow.x = this.midX;
        this.layerFortunaWheelWindow.y = this.midY + this.posWindowY;
        var fon_merge = this.add.image(this.midX, this.midY, "ss_main", "bg_connect_0000");
        fon_merge.setScale(4);
        this.layerFortunaWheelWindowMain.add(fon_merge);
        var fon_unlock = this.add.image(0, 0, "ss_main", "popup_unlocked_0000");
        fon_unlock.setScale(2);
        this.layerFortunaWheelWindow.add(fon_unlock);
        var posX = 0;
        var posY = -25;
        var ramka_fortune = this.add.image(posX, posY, "ss_main", "ramka_fortune_0000");
        this.layerFortunaWheelWindow.add(ramka_fortune);
        var wheel_fortune = this.add.image(posX, posY, "ss_main", "wheel_fortune_0000");
        this.layerFortunaWheelWindow.add(wheel_fortune);
        var arrow_fortune = this.add.image(posX, posY - 152, "ss_main", "arrow_fortune_0000");
        this.layerFortunaWheelWindow.add(arrow_fortune);
        this.wheel_fortune = wheel_fortune;
        this.arrow_fortune = arrow_fortune;
        var buttonClose = new Button(228, -231, "ss_main", "btn_close_0000", this.closeFortunaWheelWindow, this);
        this.layerFortunaWheelWindow.add(buttonClose);
        this.buttonCloseFortunaWheelWindow = buttonClose;
        var buttonContinue = new ButtonText(0, 195, "ss_main", "btn_buy2_0000", this.clickFortunaButton, this, MainGame.GAME_TEXT.free);
        buttonContinue.text.x = -22;
        this.layerFortunaWheelWindow.add(buttonContinue);
        MainGame.updateTextWidth(buttonContinue.text, 200);
        var icon_reward = this.add.image(85, 2, "ss_main", "icon_reward_0000");
        buttonContinue.add(icon_reward);
        this.buttonFortunaWheel = buttonContinue;
        var text_title = MainGame.addText(this, this.layerFortunaWheelWindow, 0, -232, MainGame.GAME_TEXT.lucky_wheel, 34, true);
        text_title.setTint(16777215);
        MainGame.updateTextWidth(text_title, 400);
        var text_free_time = MainGame.addText(this, this.layerFortunaWheelWindow, -120, 260, "", 20, true);
        MainGame.updateTextWidth(text_free_time, 300);
        var text_nextfreein = MainGame.addText(this, this.layerFortunaWheelWindow, 100, 260, "", 20, true);
        MainGame.updateTextWidth(text_nextfreein, 300);
        this.text_free_time = text_free_time;
        this.text_nextfreein = text_nextfreein;
        this.layerFortunaWheelWindow.setScale(this.scaleWindow2);
        this.layerFortunaWheelWindowMain.visible = false;
        this.layerFortunaWheelWindow.visible = false;
        this.layerFortunaWheelWindow.setScale(this.scaleWindow2);
        this.gameScreen.initWheelOptions();
        fon_unlock.setInteractive();
        fon_merge.setInteractive();
        fon_merge.on("pointerdown", this.onFonInputDown, this);
        fon_merge.on("pointerup", this.onFonInputUp, this)
    }

    clickFortunaButton() {
        this.gameScreen.showAdsForFortunaWheel()
    }

    checkFortunaWheelWindow() {
        if (this.gameScreen.freeTimeWheel > 0) {
            this.buttonFortunaWheel.setEnable(true)
        } else {
            this.buttonFortunaWheel.setEnable(false)
        }
        if (MainGame.isAPI) {
            if (!MainGame.isApiReady) this.buttonFortunaWheel.setEnable(false)
        } else {
            if (!MainGame.isDebug) this.buttonFortunaWheel.setEnable(false)
        }
    }

    updateFortunaWheelWindow(vCountDownNextFree) {
        var str1 = MainGame.GAME_TEXT.free_time + " " + this.gameScreen.freeTimeWheel + "/" + MainGame.maxTimeWheel;
        this.text_free_time.setText(str1.toUpperCase());
        var timeNextIn = MainGame.secToHHMMSS(vCountDownNextFree);
        var str2 = MainGame.GAME_TEXT.next_free_in + " " + timeNextIn;
        this.text_nextfreein.setText(str2.toUpperCase());
        if (this.gameScreen.freeTimeWheel == MainGame.maxTimeWheel) {
            this.text_nextfreein.visible = false
        } else {
            this.text_nextfreein.visible = true
        }
        if (!this.isTweeningWheel) this.checkFortunaWheelWindow()
    }

    openFortunaWheelWindow() {
        this.layerFortunaWheelWindowMain.visible = true;
        this.layerFortunaWheelWindow.visible = true;
        this.layerFortunaWheelWindow.setScale(this.scaleWindow2);
        this.disableMainButtons();
        this.updateFortunaWheelWindow(this.gameScreen.countDownNextFree);
        this.eventFonImputUp = this.closeFortunaWheelWindow;
        this.time.delayedCall(this.TIME_OPEN_POPUP, this.onPopupOpen, [], this)
    }

    closeFortunaWheelWindow() {
        if (this.isTweeningWheel) return;
        this.layerFortunaWheelWindowMain.visible = false;
        this.layerFortunaWheelWindow.visible = false;
        this.enableMainButtons()
    }

    tweenWheelFortune(rounds, degrees, backDegrees, duration1, duration2) {
        this.buttonCloseFortunaWheelWindow.setEnable(false);
        this.isTweeningWheel = true;
        this.tweens.add({
            targets: [this.wheel_fortune],
            angle: 360 * rounds + degrees,
            duration: duration1,
            ease: "Cubic.easeOut",
            callbackScope: this,
            onComplete: function (tween) {
                this.tweens.add({
                    targets: [this.wheel_fortune],
                    angle: this.wheel_fortune.angle - backDegrees,
                    duration: duration2,
                    ease: "Cubic.easeIn",
                    callbackScope: this,
                    onComplete: function (tween) {
                        this.showRewardWindow(MainGame.reward_wheel);
                        this.buttonCloseFortunaWheelWindow.setEnable(true);
                        this.checkFortunaWheelWindow();
                        this.isTweeningWheel = false
                    }
                })
            }
        })
    }

    initInputScrolling() {
        this.dragging = false;
        this.fling_enabled = true;
        this.isReadingMode = false;
        this.readingNode = -1;
        this.current_pos = {x: 0, y: 0};
        this.pressed_pos = {x: 0, y: 0};
        this.released_pos = {x: 0, y: 0};
        this.fling = {x: 0, y: 0};
        this.contentMaxY = this.contentHeight;
        this.timeConstant = 325;
        this.input.on("pointerdown", this.onInputDownShop, this);
        this.input.on("pointerup", this.onInputUpShop, this);
        this.input.on("pointerupoutside", this.onInputUpShop, this);
        this.input.on("pointermove", this.onInputMoveShop, this)
    }

    onInputDownShop(pointer) {
        if (!this.isShopAdded) return;
        if (!this.layerShop.visible) return;
        if (this.shopTabSelected != 1) return;
        var pos = this.gameScreen.getInputPosition(pointer);
        if (pos.y < 125) return;
        if (pos.x > 770 || pos.x < 340) return;
        this.dragging = true;
        this.pressed_pos.y = pos.y;
        this.pressed_time = Date.now();
        this.fling.y = 0
    }

    onInputUpShop(pointer) {
        if (!this.isShopAdded) return;
        if (!this.layerShop.visible) return;
        if (this.shopTabSelected != 1) return;
        var pos = this.gameScreen.getInputPosition(pointer);
        if (!this.dragging) return;
        this.dragging = false;
        this.current_pos.y = this.limit(this.current_pos.y + this.pressed_pos.y - pos.y);
        if (this.fling_enabled) {
            this.released_pos.y = pos.y;
            var delta_time = Date.now() - this.pressed_time;
            var distance = this.released_pos.y - this.pressed_pos.y;
            var delta = distance * Math.exp(-delta_time / this.timeConstant) * .2;
            if (Math.abs(delta) >= 30) this.fling.y = delta
        }
    }

    limit(posY) {
        posY = Math.min(posY, this.contentMaxY);
        posY = Math.max(posY, 0);
        return posY
    }

    onInputMoveShop(pointer) {
        if (!this.isShopAdded) return;
        if (!this.layerShop.visible) return;
        if (this.shopTabSelected != 1) return;
        var pos = this.gameScreen.getInputPosition(pointer);
        if (this.dragging) {
            var posY = this.current_pos.y + this.pressed_pos.y - pos.y;
            this.updatePositions(this.limit(posY))
        }
    }

    updatePositions(posY, isSkipUpdateSlider) {
        if (!isSkipUpdateSlider) {
            var percent = posY / this.contentMaxY * 100;
            this.slider.setSliderByValueForce(percent, 0)
        }
        this.layerShopContent.y = -posY;
        var itemIndex = Math.floor(posY / this.itemShop_WIDTH);
        if (this.arShopCars.length <= 0) return;
        var item;
        for (var i = 0; i < this.MAX_TYPES_CAR; i++) {
            item = this.arShopCars[i].item;
            if (item) {
                if (i < itemIndex || i > itemIndex + 4) {
                    item.visible = false
                } else {
                    item.visible = true
                }
            }
        }
    }

    getBarPosition(vPositionContent) {
        return Math.abs(vPositionContent / this.contentMaxY * 100)
    }

    updateScrollMap() {
        if (!this.dragging && this.fling_enabled && Math.abs(this.fling.y) > 0) {
            var posY = this.current_pos.y - this.fling.y;
            this.current_pos.y = this.limit(posY);
            this.updatePositions(this.current_pos.y);
            this.fling.y = MyMath.lerp(this.fling.y, 0, .04);
            if (Math.abs(this.fling.y) < .5) {
                this.fling.y = 0
            }
        }
    }

    initShop() {
        this.layerShop = this.add.container();
        this.layerShopContent = this.add.container();
        this.layerShopContent2 = this.add.container();
        this.layerShop.setDepth(this.gameScreen.DEPTH_layerShop);
        this.layerShop.x = this.midX;
        this.layerShop.y = this.midY;
        this.shopTabSelected = 1;
        this.offset_shopY = 40;
        var offsetX = 50;
        var fon_merge = this.add.image(0, 0, "ss_main", "bg_connect_0000");
        fon_merge.setScale(4);
        this.layerShop.add(fon_merge);
        var fon_shop = this.add.image(offsetX, 0, "ss_main", "popup_unlocked_0000");
        fon_shop.setScale(2);
        this.layerShop.add(fon_shop);
        var coin = this.add.image(-80 + offsetX, -232, "ss_main", "money_0000");
        this.layerShop.add(coin);
        this.iconCoinShop = coin;
        var buttonClose = new Button(228 + offsetX, -231, "ss_main", "btn_close_0000", this.closeShop, this);
        this.layerShop.add(buttonClose);
        var buttonShopTab1 = new ButtonText(-342 + offsetX, -135, "ss_main", "btn_shop1_0000", this.clickShopTab1, this, MainGame.GAME_TEXT.cannons);
        buttonShopTab1.text.setFontSize(26);
        buttonShopTab1.text.x = 21;
        buttonShopTab1.text.y = 0;
        this.layerShop.add(buttonShopTab1);
        MainGame.updateTextWidth(buttonShopTab1.text, 140);
        var icon_tab1 = this.add.image(-72, 0, "ss_main", "icon_cannon_0000");
        buttonShopTab1.add(icon_tab1);
        var buttonShopTab2 = new ButtonText(-342 + offsetX, -60, "ss_main", "btn_shop2_0000", this.clickShopTab2, this, MainGame.GAME_TEXT.upgrade);
        buttonShopTab2.text.setFontSize(26);
        buttonShopTab2.text.x = 21;
        buttonShopTab2.text.y = 0;
        this.layerShop.add(buttonShopTab2);
        MainGame.updateTextWidth(buttonShopTab2.text, 140);
        var icon_tab2 = this.add.image(-72, 0, "ss_main", "icon_privilege_0000");
        buttonShopTab2.add(icon_tab2);
        this.buttonShopTab1 = buttonShopTab1;
        this.buttonShopTab2 = buttonShopTab2;
        fon_shop.setInteractive();
        fon_merge.setInteractive();
        fon_merge.on("pointerdown", this.inputOverShopDown, this);
        fon_merge.on("pointerup", this.inputOverShopUp, this);
        this.isInputOverShopDown = false;
        this.layerShop.add(this.layerShopContent);
        this.layerShop.add(this.layerShopContent2);
        this.contentHeight = 0;
        this.arShopCars = [];
        this.addContentTab1(offsetX);
        this.addContentTab2(offsetX);
        this.addSlider(offsetX);
        var graphicsMask = this.make.graphics();
        var color = 65535;
        graphicsMask.fillStyle(color);
        graphicsMask.fillRect(250 + offsetX, 118, 500, 435);
        this.layerShopContent.mask = new Phaser.Display.Masks.BitmapMask(this, graphicsMask);
        var text_title = MainGame.addText(this, this.layerShop, -190 + offsetX, -232, MainGame.GAME_TEXT.shop, 34, true);
        MainGame.updateTextWidth(text_title, 400);
        text_title.setTint(16777215);
        this.textCoinsShop = MainGame.addText(this, this.layerShop, 20 + offsetX, -232, "0", 34, true);
        this.layerShop.visible = false;
        this.contentMaxY = this.contentHeight;
        this.updatePositions(0);
        this.clickShopTab1();
        this.isShopAdded = true
    }

    addSlider(offsetX) {
        const slider = new HorizontalSlider({
            scene: this,
            x: 232 + offsetX,
            y: 27,
            current: 0,
            texture: "ss_main",
            track: {frame: "scroll_bar1_0000", y: -2},
            slider: "scroll_bar2_0000"
        });
        slider.setAngle(90);
        this.layerShop.add(slider);
        this.slider = slider;
        slider.on("update", (slider, value, percent) => {
            var scrollPercent = Math.round(percent * 100);
            var newContentY = (slider.height - this.contentHeight) / 100 * scrollPercent;
            this.current_pos.y = -newContentY;
            this.updatePositions(-newContentY, true)
        }, this);
        this.input.on("wheel", (function (pointer, gameObjects, deltaX, deltaY, deltaZ) {
            var _this = MainGame.state.gameGUI;
            if (_this.shopTabSelected != 1) return;
            _this.current_pos.y = _this.limit(_this.current_pos.y + deltaY * .5);
            var posY = _this.current_pos.y;
            _this.updatePositions(posY)
        }));
        this.updatePositions(0)
    }

    addContentTab1(offsetX) {
        var car;
        for (var i = 1; i <= this.MAX_TYPES_CAR; i++) {
            car = this.addShopItemMain(-8 + offsetX, this.itemShop_WIDTH * i - 130 - this.itemShop_WIDTH, i);
            this.arShopCars.push(car)
        }
        for (var i = 1; i <= this.MAX_TYPES_CAR; i++) {
            car = this.addShopItemText(-8 + offsetX, this.itemShop_WIDTH * i - 130 - this.itemShop_WIDTH, i)
        }
        this.contentHeight -= this.itemShop_WIDTH * 3 + 50
    }

    addShopItemMain(vX, vY, vNum) {
        var item = this.add.container();
        this.layerShopContent.add(item);
        var plaha = this.add.image(vX, vY, "ss_main", "window_car_0000");
        item.add(plaha);
        var car = this.add.image(vX - 110, vY - 3, "ss_main", "tower" + vNum + "_0000");
        car.setScale(1.1);
        item.add(car);
        var buttonBuy = new ButtonText(vX + 85, vY + 10, "ss_main", "btn_buy_shop_0000", this.clickBuyShopItem, this, "123K", vNum);
        item.add(buttonBuy);
        buttonBuy.text.setFontSize(26);
        buttonBuy.text.x = 20;
        buttonBuy.text.setOrigin(.5, .5);
        this.contentHeight += this.itemShop_WIDTH;
        return {item: item, car: car, btn: buttonBuy, btn_back: buttonBuy.back, btn_text: buttonBuy.text}
    }

    clickBuyShopItem(vNum) {
        this.gameScreen.clickBuyShopItem(vNum)
    }

    addShopItemText(vX, vY, vNum) {
        var car = this.arShopCars[vNum - 1];
        var item = car.item;
        var text_num = MainGame.addText(this, item, vX - 186, vY - 30, vNum, 20, true, true);
        var text_dmg = MainGame.addText(this, item, vX - 21, vY - 39, MainGame.GAME_TEXT.damage, 18, true, true);
        text_dmg.setTint(3281430);
        text_dmg.setOrigin(0, .5);
        car.textField_dmg = text_dmg
    }

    addContentTab2(offsetX) {
        this.itemPrivilege1 = this.addShopItemsTabPrivilegies1(-8 + offsetX, this.itemShop_WIDTH * 0 - 130);
        this.itemPrivilege2 = this.addShopItemsTabPrivilegies2(-8 + offsetX, this.itemShop_WIDTH * 1 - 130);
        this.itemPrivilege3 = this.addShopItemsTabPrivilegies3(-8 + offsetX, this.itemShop_WIDTH * 2 - 130)
    }

    addShopItemsTabPrivilegies1(vX, vY) {
        var item = this.add.container();
        this.layerShopContent2.add(item);
        var plaha = this.add.image(vX, vY, "ss_main", "window_car_0000");
        item.add(plaha);
        var icon = this.add.image(vX - 110, vY - 10, "ss_main", "icon_damage_0000");
        item.add(icon);
        var buttonBuy = new ButtonText(vX + 85, vY + 10, "ss_main", "btn_buy_shop_0000", this.clickBuyPrivilege1, this, "");
        item.add(buttonBuy);
        buttonBuy.text.setFontSize(26);
        buttonBuy.text.x = 25;
        buttonBuy.text.setOrigin(.5, .5);
        var text_title = MainGame.addText(this, item, vX - 110, vY + 40, MainGame.GAME_TEXT.upgrade_1, 18, true, true);
        var text_lvl = MainGame.addText(this, item, vX - 185, vY - 1, MainGame.GAME_TEXT.lvl, 18, true, true);
        var text_num = MainGame.addText(this, item, vX - 186, vY - 30, "1", 20, true, true);
        var text_value = MainGame.addText(this, item, vX + 10, vY - 40, "", 18, true, true);
        text_title.setTint(3281430);
        text_lvl.setTint(3281430);
        text_value.setTint(3281430);
        text_value.setOrigin(0, .5);
        MainGame.updateTextWidth(text_title, 150);
        return {
            btn: buttonBuy,
            btn_back: buttonBuy.back,
            btn_text: buttonBuy.text,
            text_num: text_num,
            text_value: text_value
        }
    }

    addShopItemsTabPrivilegies2(vX, vY) {
        var item = this.add.container();
        this.layerShopContent2.add(item);
        var plaha = this.add.image(vX, vY, "ss_main", "window_car_0000");
        item.add(plaha);
        var icon = this.add.image(vX - 110, vY - 10, "ss_main", "icon_price_0000");
        item.add(icon);
        var buttonBuy = new ButtonText(vX + 85, vY + 10, "ss_main", "btn_buy_shop_0000", this.clickBuyPrivilege2, this, "");
        item.add(buttonBuy);
        buttonBuy.text.setFontSize(26);
        buttonBuy.text.x = 25;
        buttonBuy.text.setOrigin(.5, .5);
        var text_title = MainGame.addText(this, item, vX - 110, vY + 40, MainGame.GAME_TEXT.upgrade_2, 18, true, true);
        var text_lvl = MainGame.addText(this, item, vX - 185, vY - 1, MainGame.GAME_TEXT.lvl, 18, true, true);
        var text_num = MainGame.addText(this, item, vX - 186, vY - 30, "1", 20, true, true);
        var text_value = MainGame.addText(this, item, vX + 10, vY - 40, "", 18, true, true);
        text_title.setTint(3281430);
        text_lvl.setTint(3281430);
        text_value.setTint(3281430);
        text_value.setOrigin(0, .5);
        MainGame.updateTextWidth(text_title, 150);
        return {
            btn: buttonBuy,
            btn_back: buttonBuy.back,
            btn_text: buttonBuy.text,
            text_num: text_num,
            text_value: text_value
        }
    }

    addShopItemsTabPrivilegies3(vX, vY) {
        var item = this.add.container();
        this.layerShopContent2.add(item);
        var plaha = this.add.image(vX, vY, "ss_main", "window_car_0000");
        item.add(plaha);
        var icon = this.add.image(vX - 110, vY - 10, "ss_main", "icon_profit_0000");
        item.add(icon);
        var buttonBuy = new ButtonText(vX + 85, vY + 10, "ss_main", "btn_buy_shop_0000", this.clickBuyPrivilege3, this, "");
        item.add(buttonBuy);
        buttonBuy.text.setFontSize(26);
        buttonBuy.text.x = 25;
        buttonBuy.text.setOrigin(.5, .5);
        var text_title = MainGame.addText(this, item, vX - 110, vY + 40, MainGame.GAME_TEXT.upgrade_3, 18, true, true);
        var text_lvl = MainGame.addText(this, item, vX - 185, vY - 1, MainGame.GAME_TEXT.lvl, 18, true, true);
        var text_num = MainGame.addText(this, item, vX - 186, vY - 30, "1", 20, true, true);
        var text_value = MainGame.addText(this, item, vX + 10, vY - 40, "", 18, true, true);
        text_title.setTint(3281430);
        text_lvl.setTint(3281430);
        text_value.setTint(3281430);
        text_value.setOrigin(0, .5);
        MainGame.updateTextWidth(text_title, 150);
        return {
            btn: buttonBuy,
            btn_back: buttonBuy.back,
            btn_text: buttonBuy.text,
            text_num: text_num,
            text_value: text_value
        }
    }

    clickBuyPrivilege1() {
        this.gameScreen.clickBuyPrivilege1()
    }

    clickBuyPrivilege2() {
        this.gameScreen.clickBuyPrivilege2()
    }

    clickBuyPrivilege3() {
        this.gameScreen.clickBuyPrivilege3()
    }

    clickShopTab1() {
        this.shopTabSelected = 1;
        this.layerShopContent.visible = true;
        this.slider.visible = true;
        this.layerShopContent2.visible = false;
        this.buttonShopTab1.back.setFrame("btn_shop1_0000");
        this.buttonShopTab2.back.setFrame("btn_shop2_0000");
        this.updateShopItem()
    }

    clickShopTab2() {
        this.shopTabSelected = 2;
        this.layerShopContent.visible = false;
        this.slider.visible = false;
        this.layerShopContent2.visible = true;
        this.buttonShopTab1.back.setFrame("btn_shop2_0000");
        this.buttonShopTab2.back.setFrame("btn_shop1_0000")
    }

    closeShop() {
        this.enableMainButtons();
        this.layerShop.visible = false
    }

    updateShop(value) {
        if (!this.isShopAdded) return;
        this.textCoinsShop.setText(value);
        this.iconCoinShop.x = this.textCoinsShop.x - this.textCoinsShop.width * .5 - 35
    }

    updateShopItem() {
        if (!this.isShopAdded) return;
        var item;
        this.gameScreen.updatePrivilegiesItems();
        for (var i = 0; i < this.MAX_TYPES_CAR; i++) {
            item = this.arShopCars[i];
            if (i + 2 > this.gameScreen.nextCarLevel) {
                item.car.setTintFill(1513239);
                item.btn_back.setFrame("btn_buy_gray_0000");
                item.btn_text.setText("???");
                item.btn_text.setTint(16777215);
                MainGame.updateTextWidth(item.btn_text, 140);
                item.btn.disableInput();
                item.textField_dmg.visible = false
            } else {
                item.car.clearTint();
                item.textField_dmg.visible = true;
                var value_dmg = this.gameScreen.getDamage(i + 1);
                var value_dmg_warm = MainGame.convertNumberFormat(value_dmg);
                item.textField_dmg.setText(MainGame.GAME_TEXT.damage + " : " + value_dmg_warm);
                if (i > 0 && this.gameScreen.nextCarLevel < i + 6) {
                    if (i == this.gameScreen.nextCarLevel - 5) {
                        if (this.gameScreen.ALLOW_ADS_CAR) {
                            item.btn_back.setFrame("btn_buy2_shop_0000");
                            item.btn_text.setText(" " + MainGame.GAME_TEXT.free.toUpperCase() + " ");
                            MainGame.updateTextWidth(item.btn_text, 120);
                            item.btn.enableInput();
                            item.btn.setEnable(true);
                            if (MainGame.isAPI) {
                                if (!MainGame.isApiReady) item.btn.setEnable(false)
                            } else {
                                if (!MainGame.isDebug) item.btn.setEnable(false)
                            }
                        } else {
                            item.btn_back.setFrame("btn_buy_gray_0000");
                            item.btn_text.setText(MainGame.GAME_TEXT.unlock_car + " " + (i + 5));
                            MainGame.updateTextWidth(item.btn_text, 120);
                            item.btn.disableInput()
                        }
                    } else {
                        item.btn_back.setFrame("btn_buy_gray_0000");
                        item.btn_text.setText(MainGame.GAME_TEXT.unlock_car + " " + (i + 5));
                        MainGame.updateTextWidth(item.btn_text, 120);
                        item.btn.disableInput()
                    }
                } else {
                    item.btn_back.setFrame("btn_buy_shop_0000");
                    var price = Math.round(this.gameScreen.arCurrentPricesCar[i] * this.gameScreen.factorDiscount);
                    var number_warm = MainGame.convertNumberFormat(price);
                    item.btn_text.setText(number_warm);
                    MainGame.updateTextWidth(item.btn_text, 120);
                    item.btn.enableInput()
                }
            }
        }
    }

    inputOverShopDown() {
        this.isInputOverShopDown = true
    }

    inputOverShopUp() {
        if (!this.isInputOverShopDown) return;
        this.closeShop();
        this.isInputOverShopDown = false
    }

    clickShop() {
        this.isInputOverShopDown = false;
        this.layerShop.visible = true;
        this.disableMainButtons();
        this.updateShopItem()
    }

    update(time, delta) {
        if (this.isShopAdded) this.updateScrollMap()
    }

    clickMuteSound() {
        MainGame.Sfx.manage("sound", "switch", this, this.buttonMuteSound.icon, this.buttonMuteSound.text)
    }

    clickMuteMusic() {
        MainGame.Sfx.manage("music", "switch", this, this.buttonMuteMusic.icon, this.buttonMuteMusic.text)
    }
}

Pool = function (game, layer, initialSize) {
    this.game = game;
    this.layer = layer;
    this.nextFree = null;
    this.lastFree = null;
    this.previousFree = null;
    this._pool = [];
    for (let i = 0; i < initialSize; i++) {
        this.addNewObject(this.newPoolObject())
    }
};
Pool.prototype.addNewObject = function (obj) {
    this._pool.push(obj);
    this.release(obj);
    return obj
};
Pool.prototype.release = function (poolObject) {
    poolObject.free = true;
    poolObject.nextFree = null;
    poolObject.previousFree = this.lastFree;
    if (poolObject.previousFree) {
        this.lastFree.nextFree = poolObject
    } else {
        this.nextFree = poolObject
    }
    this.lastFree = poolObject;
    poolObject.init()
};
Pool.prototype.getFree = function () {
    const freeObject = this.nextFree ? this.nextFree : this.addNewObject(this.newPoolObject());
    freeObject.free = false;
    this.nextFree = freeObject.nextFree;
    if (!this.nextFree) this.lastFree = null;
    return freeObject
};
Pool.prototype.newPoolObject = function () {
    return new Enemy(this.game, this.layer, this.lastFree, this.nextFree)
};
Pool.prototype.releaseAll = function () {
    this._pool.forEach(item => this.release(item))
};
Pool.prototype.getChildren = function () {
    return this._pool
};
Pool.prototype.update = function (time, delta) {
    this._pool.forEach(item => {
        item.update(time, delta)
    })
};
Pool.prototype.updateSpeed = function (vIsDoubleSpeed) {
    this._pool.forEach(item => {
        item.updateSpeed(vIsDoubleSpeed)
    })
};
var Effect = new Phaser.Class({
    Extends: Phaser.GameObjects.Sprite, initialize: function Effect(scene) {
        Phaser.GameObjects.Sprite.call(this, scene, 0, 0, "ss_main");
        this.scene = scene;
        this.scene.layerEffects.add(this)
    }, show: function (x, y, name, hideOnComplete) {
        this.setPosition(x, y);
        this.setActive(true);
        this.setVisible(true);
        this.play(name);
        if (hideOnComplete) {
            this.on(Phaser.Animations.Events.ANIMATION_COMPLETE, (function () {
                this.hide()
            }), this)
        }
    }, hide: function () {
        this.setActive(false);
        this.setVisible(false)
    }
});
Tower = function (game, vLayer, vX, vY, vType) {
    this.game = game;
    this.initPos = {x: vX, y: vY};
    this.type = vType;
    this.countBullet = vType;
    this.health = 100;
    this.damage = 30;
    this.count_box_tween = 0;
    this.targetAim = null;
    this.timeReload = 50;
    this.timeShoot = Math.floor(this.timeReload * .5);
    this.ATTACK_TOWER = this.game.ATTACK_TOWER;
    this.countShoot = 0;
    this.typeBullet = 1;
    var view = game.add.image(vX, vY, "ss_main", "tower1_0000");
    this.car_frame = "tower" + vType + "_0000";
    vLayer.add(view);
    this.view = view;
    this.setSkinTower(vType)
};
Tower.prototype.setInitPosition = function (vX, vY) {
    this.initPos.x = vX;
    this.initPos.y = vY
};
Tower.prototype.resetTween = function () {
    this.game.tweens.killTweensOf(this.view);
    this.view.x = this.initPos.x;
    this.view.y = this.initPos.y
};
Tower.prototype.setTarget = function (target) {
    this.targetAim = target;
    this.updateSpeed()
};
Tower.prototype.getTarget = function () {
    return this.targetAim
};
Tower.prototype.clearTarget = function () {
    if (this.targetAim) {
        this.targetAim.isUnderAttack = false;
        this.targetAim = null
    }
};
Tower.prototype.checkTarget = function () {
    if (this.targetAim) {
        if (!this.targetAim.isAlive) {
            this.targetAim = null
        } else {
            if (this.targetAim.isUnderAttack && this.countShoot == 0) {
                this.targetAim = null
            }
        }
    }
};
Tower.prototype.updateSpeed = function () {
    this.ATTACK_TOWER = this.game.ATTACK_TOWER
};
Tower.prototype.updateAnchor = function () {
    var originY = .5;
    var arOrigins = [.5, .5, .6, .5, .5, .5, .5, .6, .5, .6, .5, .5, .6, .5, .6, .5, .5, .5, .5, .6, .5, .6, .5, .6, .5, .5, .6, .5, .6, .5, .5, .5, .5, .5, .5, .5, .5, .5, .5, .5, .5, .5, .5, .5, .5, .5, .5, .5, .5, .5];
    originY = arOrigins[this.type - 1];
    this.view.setOrigin(.5, originY)
};
Tower.prototype.updateTypeBullet = function () {
    var arTypeBullet = [1, 1, 1, 1, 1, 4, 4, 4, 1, 1, 2, 1, 4, 1, 1, 1, 1, 1, 2, 3, 1, 1, 4, 3, 3, 1, 1, 2, 3, 3, 1, 4, 2, 3, 5, 1, 1, 4, 4, 2, 1, 4, 4, 3, 3, 1, 4, 2, 5, 2];
    this.typeBullet = arTypeBullet[this.type - 1];
    this.damage = this.game.getDamage(this.type);
    switch (this.typeBullet) {
        case 2:
        case 4:
            this.damage = Math.round(this.damage / 2);
            break;
        case 3:
        case 5:
            this.damage = Math.round(this.damage / 3);
            break
    }
};
Tower.prototype.updateShoot = function () {
    this.timeShoot += this.ATTACK_TOWER
};
Tower.prototype.checkShoot = function () {
    return this.timeShoot >= this.timeReload
};
Tower.prototype.makeShoot = function (angle) {
    if (this.targetAim && this.targetAim.isAlive) {
        this.fire(angle, this.countShoot);
        this.timeShoot = 0;
        this.countShoot++;
        this.timeReload = 50;
        switch (this.typeBullet) {
            case 2:
                this.targetAim.getAdvanceDmg(this.damage * 2);
                this.countShoot = 0;
                break;
            case 3:
                this.targetAim.getAdvanceDmg(this.damage * 3);
                this.countShoot = 0;
                break;
            case 4:
                if (this.countShoot == 1) this.timeReload = 4;
                if (this.countShoot == 2) this.countShoot = 0;
                this.targetAim.getAdvanceDmg(this.damage);
                break;
            case 5:
                if (this.countShoot == 1) this.timeReload = 4;
                if (this.countShoot == 2) this.timeReload = 4;
                if (this.countShoot == 3) this.countShoot = 0;
                this.targetAim.getAdvanceDmg(this.damage);
                break;
            default:
                this.countShoot = 0;
                this.targetAim.getAdvanceDmg(this.damage);
                break
        }
    }
};
Tower.prototype.fire = function (angle, countShoot) {
    if (countShoot == 0) {
        this.resetTween();
        MainGame.jelly(this.game, this.view, .1)
    }
    if (this.typeBullet == 1) {
        this.game.addBullet(this.targetAim, this.damage, this.view.x, this.view.y, angle)
    } else if (this.typeBullet == 2) {
        var dt = Phaser.Math.DegToRad(90);
        var posX1 = this.view.x + 10 * Math.cos(angle - dt);
        var posY1 = this.view.y + 10 * Math.sin(angle - dt);
        this.game.addBullet(this.targetAim, this.damage, posX1, posY1, angle, 16711680);
        var posX2 = this.view.x - 10 * Math.cos(angle - dt);
        var posY2 = this.view.y - 10 * Math.sin(angle - dt);
        this.game.addBullet(this.targetAim, this.damage, posX2, posY2, angle, 65280)
    } else if (this.typeBullet == 3) {
        this.game.addBullet(this.targetAim, this.damage, this.view.x, this.view.y, angle, 16777215);
        var dt = Phaser.Math.DegToRad(90);
        var posX1 = this.view.x + 20 * Math.cos(angle - dt);
        var posY1 = this.view.y + 20 * Math.sin(angle - dt);
        this.game.addBullet(this.targetAim, this.damage, posX1, posY1, angle, 16711680);
        var posX2 = this.view.x - 20 * Math.cos(angle - dt);
        var posY2 = this.view.y - 20 * Math.sin(angle - dt);
        this.game.addBullet(this.targetAim, this.damage, posX2, posY2, angle, 65280)
    } else if (this.typeBullet == 4) {
        this.game.addBullet(this.targetAim, this.damage, this.view.x, this.view.y, angle)
    } else if (this.typeBullet == 5) {
        this.game.addBullet(this.targetAim, this.damage, this.view.x, this.view.y, angle)
    }
    var r = MyMath.getRandomInt(1, 3);
    MainGame.Sfx.play("sound", "shoot" + r)
};
Tower.prototype.setSkinTower = function (vType) {
    this.type = vType;
    this.view.setFrame("tower" + vType + "_0000");
    this.car_frame = "tower" + vType + "_0000";
    this.updateTypeBullet();
    this.updateAnchor()
};
Tower.prototype.setSkinBox = function (vTypeBox) {
    this.view.setFrame("box" + vTypeBox + "_0000")
};
Tower.prototype.removeTower = function () {
    this.view.destroy()
};
Tower.prototype.getViewPosition = function () {
    return {x: this.view.x, y: this.view.y}
};
Tower.prototype.setViewPosition = function (vX, vY) {
    this.view.x = vX;
    this.view.y = vY
};
Tower.prototype.setViewAngle = function (value) {
    this.view.angle = value
};
Tower.prototype.setViewAngleFromRad = function (value) {
    var angle = (value + Math.PI / 2) * Phaser.Math.RAD_TO_DEG;
    this.setViewAngle(angle + 90)
};
Tower.prototype.setViewAlpha = function (value) {
    this.view.alpha = value
};
Tower.prototype.setViewScale = function (value) {
    this.view.setScale(value)
};
Enemy = function (game, layer, lastFree, nextFree) {
    this.game = game;
    this.lastFree = lastFree;
    this.nextFree = nextFree;
    var view = game.add.spine(0, 0, "skeleton", "idle", true);
    layer.add(view);
    this.hpBars = this.game.addHpBar();
    this.view = view
};
Enemy.prototype.init = function () {
    this.active = false;
    this.isAlive = false;
    this.isUnderAttack = false;
    this.isReachedWall = false;
    this.view.visible = false;
    this.view.angle = 0;
    this.speed = 1;
    this.hpBars.bar1.setVisible(false);
    this.hpBars.bar2.setVisible(false);
    this.game.tweens.killTweensOf(this.view)
};
Enemy.prototype.resetValues = function () {
    this.active = true;
    this.isAlive = true;
    this.isUnderAttack = false;
    this.isReachedWall = false;
    this.health_max = 100;
    this.health_adv = this.health_max;
    this.health = this.health_max;
    this.timeAttack = 0;
    this.speed = this.game.SPEED_ENEMY;
    this.ATTACK_TOWER = this.game.ATTACK_TOWER;
    this.reloading = 50;
    this.damage = 5;
    this.timeLife = 0;
    this.rangeAttack = 600 + MyMath.getRandomInt(-5, 5) * 2;
    this.hpBars.bar1.setVisible(true);
    this.hpBars.bar2.setVisible(true)
};
Enemy.prototype.updateSpeed = function (vIsDoubleSpeed) {
    if (!this.isReachedWall) {
        this.speed = this.game.SPEED_ENEMY
    }
    this.ATTACK_TOWER = this.game.ATTACK_TOWER
};
Enemy.prototype.setNewBot = function (vId, x, y, vData, vType, vNumWave) {
    this.id = vId;
    this.resetValues();
    var type_skin = vData.type_skin;
    var type_warrior = vData.type_warrior;
    var type_helmet = vData.type_helmet;
    var type_weapon = vData.type_weapon;
    var type_shield = vData.type_shield;
    this.view.skeleton.setAttachment("body", type_skin);
    this.view.skeleton.setAttachment("helmet", "helmet" + type_helmet);
    if (type_warrior == 0) {
        this.view.skeleton.setAttachment("weapon", "weapon" + type_weapon);
        this.view.skeleton.setAttachment("weapon2", "weapon0");
        this.view.skeleton.setAttachment("shield", "shield0")
    } else if (type_warrior == 1) {
        this.view.skeleton.setAttachment("weapon", "weapon" + type_weapon);
        this.view.skeleton.setAttachment("weapon2", "weapon0");
        this.view.skeleton.setAttachment("shield", "shield" + type_shield)
    } else if (type_warrior == 2) {
        this.view.skeleton.setAttachment("weapon", "weapon" + type_weapon);
        this.view.skeleton.setAttachment("weapon2", "weapon" + type_weapon);
        this.view.skeleton.setAttachment("shield", "shield0")
    }
    this.type = vType;
    this.initY = y;
    this.x = x;
    this.y = y;
    this.view.setPosition(x, y);
    this.scaleValue = 1;
    this.damage = this.game.getMobDamage(vNumWave);
    this.health_max = this.game.getCountMobHp(vNumWave);
    this.health_adv = this.health_max;
    this.health = this.health_max;
    this.view.setColor(16777215);
    this.hpBars.bar1.setPosition(this.x, this.y + 15);
    this.hpBars.bar2.setPosition(this.x, this.y + 15);
    this.view.setDepth(this.game.DEPTH_layerSpine + this.y * 1e-5);
    this.view.angle = 5;
    this.view.y -= 5;
    this.game.tweens.add({
        targets: this.view,
        props: {
            angle: {value: -5, duration: 300, yoyo: true, repeat: -1},
            y: {value: this.y + 5, duration: 120, yoyo: true, repeat: -1}
        },
        ease: "Linear"
    });
    if (vType == 100) {
        this.scaleValue = 1.4;
        this.view.setColor(16221573);
        this.damage = this.game.getBossDamage(vNumWave);
        this.health_max = this.game.getCountBossHp(vNumWave);
        this.health_adv = this.health_max;
        this.health = this.health_max
    }
    this.view.setScale(this.scaleValue, this.scaleValue);
    this.updateHpBarsView();
    this.view.visible = false;
    this.hpBars.bar1.visible = false;
    this.hpBars.bar2.visible = false
};
Enemy.prototype.getDamage = function (damage) {
    this.health -= damage;
    this.updateHpBarsView();
    this.timeLife = 0;
    if (this.health <= 0) {
        this.health = 0;
        this.game.enemies.release(this);
        this.game.enemyKilled(this.type);
        this.game.addEffectKilled(this.view.x, this.view.y)
    }
};
Enemy.prototype.setForAttack = function () {
    if (!this.isAlive) return;
    this.isUnderAttack = false;
    this.health_adv = this.health;
    this.timeLife = 0
};
Enemy.prototype.getAdvanceDmg = function (damage) {
    this.health_adv -= damage;
    if (this.health_adv <= 0) {
        this.isUnderAttack = true
    }
};
Enemy.prototype.updateHpBarsPosition = function () {
    this.hpBars.bar1.x = this.x;
    this.hpBars.bar2.x = this.x
};
Enemy.prototype.updateHpBarsView = function () {
    var width = this.hpBars.bar1.width * (this.health / this.health_max);
    this.hpBars.bar_crop.width = width;
    this.hpBars.bar2.setCrop(this.hpBars.bar_crop)
};
Enemy.prototype.startAttack = function () {
    this.view.setScale(this.scaleValue, this.scaleValue);
    this.view.y = this.initY;
    this.timeAttack = 40;
    this.isReachedWall = true;
    this.speed = 0;
    this.view.angle = 0;
    this.game.tweens.killTweensOf(this.view)
};
Enemy.prototype.goAttack = function () {
    if (this.game.isGameOver) return;
    MainGame.jelly(this.game, this.view, .1, 0, {x: this.scaleValue, y: this.scaleValue});
    this.game.tweens.add({
        targets: this.view,
        props: {x: {value: this.x + 15, duration: 120, yoyo: true}},
        ease: "Back.easeIn"
    });
    this.game.showWallJelly();
    this.game.updateWallHp(this.damage);
    this.game.addEffectKick(this.x + 62, this.y - 23, 2)
};
Enemy.prototype.update = function (time, delta) {
    if (!this.active || !this.isAlive) return;
    if (this.timeAttack == 0) {
        if (this.view.x < this.rangeAttack) {
            this.view.x += this.speed * delta;
            this.x = this.view.x;
            this.updateHpBarsPosition();
            if (!this.view.visible && this.x > -20) {
                this.view.visible = true;
                this.hpBars.bar1.visible = true;
                this.hpBars.bar2.visible = true
            }
        } else {
            this.startAttack()
        }
    } else {
        this.timeAttack += this.ATTACK_TOWER;
        if (this.timeAttack >= this.reloading) {
            this.timeAttack = 1;
            this.goAttack()
        }
    }
    this.timeLife++;
    if (this.timeAttack > 0) this.timeLife += 10;
    if (this.timeLife > 500) {
        this.setForAttack()
    }
};
var Bullet = new Phaser.Class({
    Extends: Phaser.GameObjects.Image, initialize: function Bullet(scene) {
        Phaser.GameObjects.Image.call(this, scene, 0, 0, "ss_main", "bullet_0000");
        this.target = null;
        this.damage = 0;
        this.dx = 0;
        this.dy = 0;
        this.lifespan = 0;
        this.speed = scene.SPEED_BULLET;
        this.scene = scene;
        this.scene.layerEffects.add(this);
        this.dmgText = this.scene.addDmgText()
    }, updateSpeed: function () {
        this.speed = this.scene.SPEED_BULLET
    }, fire: function (target, damage, x, y, angle, color) {
        this.setPosition(x, y);
        this.setActive(true);
        this.setVisible(true);
        this.dx = Math.cos(angle);
        this.dy = Math.sin(angle);
        this.x += this.dx * 30;
        this.y += this.dy * 30;
        this.damage = damage;
        this.lifespan = 2e3;
        this.target = target
    }, update: function (time, delta) {
        this.lifespan -= delta;
        this.x += this.dx * (this.speed * delta);
        this.y += this.dy * (this.speed * delta);
        if (this.lifespan <= 0 || this.x < -50 || this.y < -50 || this.y > 1e3) {
            this.setActive(false);
            this.setVisible(false);
            this.target.setForAttack()
        }
        var enemy = null;
        var posE = null;
        var dist = 0;
        this.scene.enemies.getChildren().forEach((function (enemy) {
            dist = MyMath.distanceTwoPoints(enemy.x, this.x, enemy.y, this.y);
            if (enemy.isAlive && dist < 500) {
                this.setActive(false);
                this.setVisible(false);
                this.scene.showDmgText(this.x, this.y, this.dmgText, this.damage);
                this.scene.addEffectKick(this.x, this.y, 1);
                if (this.target.id != enemy.id) {
                    this.target.setForAttack()
                }
                enemy.getDamage(this.damage)
            }
        }), this)
    }
});
var MyMath = {
    getRandomInt: function (min, max) {
        return Math.floor(Math.random() * (max - min + 1)) + min
    }, getRandomBool: function () {
        return Math.random() < .5 ? true : false
    }, randomChance: function (vValue) {
        return Math.random() < vValue
    }, shuffleArr: function (o) {
        for (var j, x, i = o.length; i; j = Math.floor(Math.random() * i), x = o[--i], o[i] = o[j], o[j] = x) ;
        return o
    }, distanceTwoPoints: function (x1, x2, y1, y2) {
        var dx = x1 - x2;
        var dy = y1 - y2;
        return dx * dx + dy * dy
    }, parseQuery: function (qstr) {
        var query = {};
        var a = qstr.substr(1).split("&");
        for (var i = 0; i < a.length; i++) {
            var b = a[i].split("=");
            query[decodeURIComponent(b[0])] = decodeURIComponent(b[1] || "")
        }
        return query
    }, weightedRandom: function (prob) {
        let i, sum = 0, r = Math.random();
        for (i in prob) {
            sum += prob[i];
            if (r <= sum) return i
        }
    }, lerp: function (in_Src, in_Dst, in_Ratio) {
        return in_Src * (1 - in_Ratio) + in_Dst * in_Ratio
    }, quad: function (a, b, c) {
        let sol = null;
        if (Math.abs(a) < 1e-6) {
            if (Math.abs(b) < 1e-6) {
                sol = Math.abs(c) < 1e-6 ? [0, 0] : null
            } else {
                sol = [-c / b, -c / b]
            }
        } else {
            let disc = b * b - 4 * a * c;
            if (disc >= 0) {
                disc = Math.sqrt(disc);
                a = 2 * a;
                sol = [(-b - disc) / a, (-b + disc) / a]
            }
        }
        return sol
    }
};
var config = {
    type: Phaser.AUTO,
    backgroundColor: 11720609,
    scale: {
        mode: Phaser.Scale.RESIZE,
        autoCenter: Phaser.Scale.CENTER_HORIZONTALLY,
        parent: "game-container",
        width: 1024,
        height: 640,
        max: {width: 1400, height: 1024}
    },
    plugins: {scene: [{key: "SpinePlugin", plugin: window.SpinePlugin, sceneKey: "spine"}]},
    scene: [Boot, Preloader, Game, GameGui]
};
const game = new Phaser.Game(config);
window.focus();
